#include<linux/proc_fs.h>
#include<asm/io.h>
#include<asm/uaccess.h>
#include<asm/unistd.h>
#include "sm_drv_ahb.h"
#define DW 0    /* For Dump Word */
#define WW 1   /* For Write Word */
#define MEM_START 0x0000   /* First Physical Memory Block Address */
#define MEM_END 0xEFFFFC   /* Last Kernel Memory Block Address 15M*/
#define MEM_LIMIT 0xFFFFFC /* Last Physical Memory Block Address 16M */    
struct proc_dir_entry *quantum_cons;
/* Structure to access user's string content */
struct address
{
	unsigned int operation;
	unsigned int start;
	unsigned int length;
}add;
char buf[100]; /*Global buffer to contain user's given string */
int cnt; /* Global variable to store buffer's length */

extern unsigned int ioread32(void __iomem *addr);
extern void iowrite32(u32 datum,void __iomem *addr);

/* Fuction Prototypes */
int remove_procfile(void);
int kernel_range(unsigned int *data);
void out_of_range(unsigned int *data) ;
int cons_write(struct file *fp,const char *buffer,unsigned int count,void *data);
int cons_read(char *buffer,char **buffer_location,off_t offset,int buffer_length, int *eof,void *data);
int get_hex(int hex[],int beg,int *count);
int parse_string(char *buf,int strln) ;

/* The function for handling the memroy region of user and kernel space */
int kernel_range(unsigned int *data)
{
    unsigned int *wrd=0;
    unsigned int loop=add.start;
    int x=0,i=0,loop_offset=0;
    char str[17];
    memset(str,0,17);
    /* Setting loop's length */
    if(DW==add.operation)
    loop_offset=add.length;
    else if(WW==add.operation)
        loop_offset=4;
    while(loop<(add.start+loop_offset))
    {
        /* User-Space */
        if((unsigned int)data >= 0x00000000 && (unsigned int)data <= 0xbfffffff)    
	{
	   if(DW==add.operation) 
       		x=copy_from_user(wrd,data,16);
	   if(WW==add.operation)
	   {
		x=copy_to_user(data,&(add.length),4);
       		return 0;
	   }
           /* Failure Case */
	   if(x)                                                          
	       printk(KERN_ALERT "\n Unable to copy %d\n",x);
	   memcpy(str,wrd,4);
           printk(KERN_ALERT "%.8x: %.8x ",(unsigned int)virt_to_phys(data),*wrd++);
           if(((unsigned int)data + 3) <= 0xbfffffff)
           {
               memcpy(str+4,wrd,4);
               printk("%.8x ",*wrd++);
           }
           if(((unsigned int)data + 7) <= 0xbfffffff)
           {
               memcpy(str+8,wrd,4);
               printk("%.8x ",*wrd++);
           }
           if(((unsigned int)data + 11) <= 0xbfffffff)
           {
               memcpy(str+12,wrd,4);
               printk("%.8x ",*wrd++);
           }
           str[16]='\0';
           printk("    ");
           for(i=0;i<17;i++)
           {
               if(str[i]=='\0')
                   printk(".");
               else
                   printk("%c",str[i]);
           } 
           printk("\n");
	}
        /* Kernel-Space */
	else if((unsigned int)data >= 0xc0000000 && (unsigned int)data <= 0xffffffff)  
	{
           if(DW==add.operation)
           { 	
               printk(KERN_ALERT "%.8x: %.8x ",(unsigned int)virt_to_phys(data),*data);
               memcpy(str,data,4);
               data++;
               if(((unsigned int)data + 3) <= 0xffffffff)
               {
                   memcpy(str+4,data,4);
                   printk("%.8x ",*data++);
               }
               if(((unsigned int)data + 7) <= 0xffffffff)
               {
                   memcpy(str+8,data,4);
                   printk("%.8x ",*data++);
               }
               if(((unsigned int)data + 11) <= 0xffffffff)
               {
                   memcpy(str+12,data,4);
                   printk("%.8x ",*data++);
               }
               str[16]='\0';
               printk("    "); 
               for(i=0;i<17;i++)
               {
                   if(str[i]=='\0')
                       printk(".");
                   else
                       printk("%c",str[i]);
               }  
	       printk("\n"); 
            }
            if(WW==add.operation)
	    {
                *data=add.length;	
        	return 0;
	    }
	}
	else
	{
       	    printk(KERN_ALERT "\n Invalid address\n ");
 	    return 0;
	}
	loop+=16;
	/* Check for memory access beyond Kernel-Space(15M-16M) */
	if((loop>MEM_END)&&(loop<=MEM_LIMIT)&&(loop<(add.start+loop_offset)))
	{
 	    add.length-=(loop-add.start);
 	    add.start=loop;
 	    return 0;
	}
	/* Case of Invalid Physical Memory access*/
	if(loop>MEM_LIMIT&&(loop<(add.start+loop_offset)))
	{
	    printk(KERN_ALERT "\n Invalid Physical Memory Access\n");
	    return 0;
	}
   }
   return 0;
}

/* For Memory access beyond Kernel-Space */
void out_of_range(unsigned int *data)            
{
    unsigned int loop=add.start;
    unsigned int i=0,loop_offset=0;
    char str[17];
    memset(str,0,17);
    if(DW==add.operation) 
	loop_offset=add.length;
    else if(WW==add.operation)
 	loop_offset=4;
    while(loop<(add.start+loop_offset))
    {
        if(DW==add.operation)
        {
            printk(KERN_ALERT "%.8x: %.8x ",(unsigned int)virt_to_phys(data),ioread32(data));
            memcpy(str,data,4);
            data++;
            if((loop + 3) <= MEM_LIMIT)
            {
                memcpy(str+4,data,4);                   
                printk("%.8x ",ioread32(data));
                data++;
            }
            if((loop + 7) <= MEM_LIMIT)
            {
                memcpy(str+8,data,4); 
                printk("%.8x ",ioread32(data));
                data++;
            }
            if((loop + 11) <= MEM_LIMIT)
            {
                memcpy(str+12,data,4);
                printk("%.8x ",ioread32(data));
                data++;
            }
            str[16]='\0';
            printk("    ");
            for(i=0;i<17;i++)
            {
                if(str[i]=='\0')
                    printk(".");
                else
                    printk("%c",str[i]);
            }  
            printk("\n");
	}
        if(WW==add.operation)
	{ 
            iowrite32(add.length,(void *)data);
   	    break;
	}
	loop+=16;
	if(loop>MEM_LIMIT&&(loop<(add.start+loop_offset)))
	{
	    printk(KERN_ALERT "\n Invalid Physical Memory Access\n");
	    break;
	}
    }
}

/* Write in proc file SolosW_console*/
int cons_write(struct file *fp,const char *buffer,unsigned int count,void *data)   
{  
    unsigned int *content;
    int ret;

    /* Write the user's given string in file*/
    if(copy_from_user(buf,buffer,count))
        printk(KERN_ALERT "\n Can't write in proc file");
    cnt=count;
    /* Parse the given string in structure address*/
    ret=parse_string(buf,count);
    if(ret!=-1)
    {     
    /* Memory Access above Kernel-Space */
        if(add.start<=MEM_END)
	{
	    content=(unsigned int *)phys_to_virt(add.start);
	    kernel_range(content);
	}
    /* Memory Access beyond Kernel-Space */
	if(add.start>MEM_END&&add.start<=MEM_LIMIT)
	{
            /* Dump Memory */
	    if(add.operation==DW)
	    {     
            /* Check for undumpable memory block*/ 
	        if((add.start-MEM_END)<4)
		{
		    add.start+=4;
		    add.length-=4;
		}
		if(add.length>0)
		{
		    content=(unsigned int *)ioremap(add.start,add.length);
		    if(!content)
		    {
		        printk(KERN_ALERT "\n Unable to remap\n");
			return count;
                    }
		out_of_range(content);
                iounmap(content);
	    }
	}
        /* Write word */
	if(WW==add.operation)
	{
	    if(((add.start-MEM_END)<4))
	    {
	        printk(KERN_ALERT "\n Can't write\n");
	        return count;
	    }
            content=(unsigned int *)ioremap(add.start,4);
  	    if(!content)
	    {
	        printk(KERN_ALERT "\n Unable to remap\n");
	        return count;
	    }
	    out_of_range(content);
            iounmap(content);
	}
		}
        /* Invalid Memory Access*/
	if(add.start>MEM_LIMIT)
	{
	    printk(KERN_ALERT "\n Invalid Physical Memory Access\n");
	    return count;
	}
    }
    return count;
}

/* Fuction to read from proc file SolosW_console */
int cons_read(char *buffer,char **buffer_location,off_t offset,int buffer_length, int *eof,void *data)  
{
    int ret;

    if(offset>0)
    ret=0;
    else
    {
        memset(buffer,0,cnt);
	memcpy(buffer,buf,cnt);
	ret=cnt;
    }
    return ret;
}

/* Fuction to get x^y */
unsigned int power(int x,int y)
{
    int i;
    unsigned int prod=1;

    if(y)
        for(i=0;i<y;i++)
	    prod*=x;
    return prod;
}

/* Fuction to parse Hexadecimal string into unsigned int */
int get_hex(int hex[],int beg,int *count)
{
    int i=0;

    for(i=0;(buf[i+beg]!=' ')&&((i+beg)<(cnt-1));i++)
    {  
        if((*count)>8)
        {
            printk(KERN_ALERT "\n Invalid Entry\n");
            return(-1);
        }
        if(buf[i+beg]>='a'&& buf[i+beg]<='f')
	    hex[i]=buf[i+beg]-'a'+10;
	else if(buf[i+beg]>='A'&& buf[i+beg]<='F')
            hex[i]=buf[i+beg]-'A'+10;
	else if(buf[i+beg]>='0'&& buf[i+beg]<='9')
	    hex[i]=buf[i+beg]-'0';
	else
	{
	    printk(KERN_ALERT "\n Invalid Number\n");
	    return(-1);
	}
	(*count)++;
    }
return 0;
}

/* For parsing user given string into the address structure*/
int parse_string(char *buf,int strln)   
{
    char oper[3];
    int beg,ret=0,i=0,pnt;
    int a[10];
    int count=0;
    pnt=0;

    while(buf[pnt]==' ')
        pnt++;
    while(buf[pnt]!=' ')
    {
        oper[i]=buf[pnt];
	i++;
	pnt++;
    }
    oper[2]='\0';
    while(buf[pnt]==' ')
	pnt++;
    /* Address is achieved from given string */
    beg=pnt;
    add.start=0;
    ret=get_hex(a,beg,&count);
    if(ret!=-1)
    {
        for(i=0;i<count;i++)
           add.start+=a[i]*power(16,(count-1)-i);
        pnt=pnt+count;
        while(buf[pnt]==' ')
           pnt++;

        /* Length or Value is achieved from given string*/
        beg=pnt;
        count=0;
        add.length=0;
        if(strcmp(oper,"ww")==0)
            add.operation=WW;
        else if(strcmp(oper,"dw")==0)
	    add.operation=DW;
        else
        {
            add.operation=-1;
	    printk(KERN_ALERT "\n Invalid Operation\n");
	    return -1;
        }
    }
    ret=get_hex(a,beg,&count);
    if(ret!=-1)
       for(i=0;i<count;i++)
          add.length+=a[i]*power(16,(count-1)-i);
    return 0;
}

/* Function to create proc file SolosW_console */
int create_procfile()
{
    if((quantum_cons = create_proc_entry("SolosW_Console",0644, NULL))==NULL)
    printk(KERN_ALERT "\n Can't create proc file\n");
    quantum_cons->write_proc=(write_proc_t *)cons_write;
    quantum_cons->read_proc=(read_proc_t *)cons_read;
    return 0;
}


int remove_procfile()
{
    remove_proc_entry("SolosW_Console",NULL);
    return 0;
}
 



