#include<linux/proc_fs.h>
#include<asm/io.h>
#include<asm/uaccess.h>
#include<asm/unistd.h>
#include "sm_drv_ahb.h"
#define DW 0    /* For Dump Word */
#define WW 1   /* For Write Word */
#define MEM_START 0x0000   /* First Physical Memory Block Address */
#define MEM_END 0xEFFFFC   /* Last Kernel Memory Block Address 15M*/
#define MEM_LIMIT 0xFFFFFC /* Last Physical Memory Block Address 16M */    
struct proc_dir_entry *quantum_cons;
/* Structure to access user's string content */
struct address
{
	unsigned int operation;
	unsigned int start;
	unsigned int length;
}add;
char buf[100]; /*Global buffer to contain user's given string */
int cnt; /* Global variable to store buffer's length */

/*extern unsigned int ioread32(void __iomem *addr);
extern void iowrite32(u32 datum,void __iomem *addr);*/

/* Fuction Prototypes */

int remove_procfile(void);
int dev_write(struct file *fp,const char *buffer,unsigned int count,void *data);
int dev_read(char *buffer,char **buffer_location,off_t offset,int buffer_length, int *eof,void *data);

/* Write in proc file SolosW_console*/
int dev_write(struct file *fp,const char *buffer,unsigned int count,void *data)   
{  
    
    return 0;
}

/* Fuction to read from proc file SolosW_console */
int dev_read(char *buffer,char **buffer_location,off_t offset,int buffer_length, int *eof,void *data)  
{
    int ret;
    struct net_device *dev= data;
    struct net_local *lp = dev->priv;
    
   uint32_t bit_rate=0,rf_status=0,profile=0;	
   struct obj_ssid essid;   
   int txpow;
   unsigned long freq=0,channel=0;
   char ant_status[4];
   char str_profile[4];
   unsigned char mac[6];   
   char str_mac[18];

    sm_drv_get(dev, GEN_OID_LINKSTATE, &bit_rate, sizeof(unsigned int));   
    if(bit_rate != 0)
    bit_rate = bit_rate/2;

    sm_drv_get(dev,GEN_OID_HIBERNATE, &rf_status, sizeof(unsigned int));	
    memset(ant_status,0,4);
    if(rf_status == 0)
    strcpy(ant_status,"ON");
    else
	strcpy(ant_status,"OFF");
	
    ant_status[3] = '\0';

    sm_drv_get(dev,DOT11_OID_SSID, &essid, sizeof(struct obj_ssid));
    essid.octets[essid.length] = '\0';

    sm_drv_get(dev, DOT11_OID_OUTPUTPOWER, &txpow, sizeof(int));
    txpow = txpow/4;
    
    sm_drv_get(dev, DOT11_OID_FREQUENCY, &freq, sizeof(unsigned long)); 
    
    if(freq == 2484000)
    {
          channel = 14*5000;

    }
    else
    { 
	channel =freq - 2407000;
    }

    if(channel)
    {
        channel = channel/5000;
    }  
 
    sm_drv_get(dev, DOT11_OID_PROFILES, &profile, sizeof(unsigned int));
    if(profile == 0 || profile == 5)
    strcpy(str_profile,"11b");
    else
    strcpy(str_profile,"11g"); 
    
    str_profile[3] = '\0';
    
    sm_drv_get(dev,GEN_OID_MACADDRESS,mac, 6);
    
    if(offset>0)
    ret=0;
    else
    {
	ret = sprintf(buffer,"%s \n",dev->name);
	ret += snprintf(buffer+ret,buffer_length-ret,"Dev if:%s \n Tx Rate%d \n Rx Rate:%d \n Rf Status:%s \n SSID:%s \n Tx Power:%d dbm \n Channel:%ld \n BSSID %2.2X:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x\n",dev->name,bit_rate,bit_rate,ant_status,essid.octets,txpow,channel,mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
	
    }
    *eof = 1;
    return ret;
}

/* Function to create proc file SolosW_console */
int dev_create_procfile(struct net_device *dev)
{
    char devname[IFNAMSIZ];
    struct proc_dir_entry *mypath; 
    char path[100] = "sys/dev/";
    strcat(path,dev->name);  
    mypath = proc_mkdir(path,NULL);
    if(mypath == NULL)
     printk(KERN_ALERT "\n Can't create proc dir %s\n",path);

 
    if((quantum_cons = create_proc_entry("stat_and_misc",0644, mypath/*proc_net*/))==NULL)
    printk(KERN_ALERT "\n Can't create proc file\n");
    quantum_cons->write_proc=(write_proc_t *)dev_write;
    quantum_cons->read_proc=(read_proc_t *)dev_read;
    quantum_cons->owner	=	THIS_MODULE;
    quantum_cons->mode	=	S_IFREG | S_IRUGO;
    quantum_cons->uid	=	0;
    quantum_cons->gid	=	0;
    quantum_cons->size	=	37;
    quantum_cons->data	=	dev;
    return 0;
}

/* remove proc entry */
int remove_procfile()
{
    remove_proc_entry("stat_and_misc",NULL);
    return 0;
}
 
