/*  $Header: /home/cvsadmin/pbs/Trunk_linux/kernel/modules/ip806gav4_new/cnxt-src/drivers/wireless/stung/driver/core/sm_drv.c,v 1.1.1.1 2007-10-04 07:12:55 raul_xu Exp $
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the ememntity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
//#ifdef CONFIG_BIGMAC_PCI
//#include <linux/pci.h>
//#endif
#include <linux/string.h>
#include <linux/poll.h>
#include <linux/wireless.h>
#include <asm/uaccess.h>

#include "sm_drv.h"
#ifdef CONFIG_BIGMAC_PCI
#ifdef PCIUART
#include "sm_drv_uartpci.h"
#endif
#endif


#ifdef NETLINK_SUPPORT
#include "sm_drv_netlink.h"
#endif

#ifdef WDS_SUPPORT
#include "sm_drv_wds.h"
#endif
#ifdef VSSDEV_SUPPORT
#include "sm_drv_vss.h"
#endif

#ifdef CONFIG_8827_DEBUG
#include "sm_drv_8827.h"
#endif

#ifdef MEMORY_TRACER
#include "sm_drv_memuse.h"
#endif

//#ifdef CONFIG_BIGMAC_PCI
//#include "sm_drv_pci.h"
//#elif CONFIG_BIGMAC_PCCARD
//#include "sm_drv_pc16.h"
//#endif


#include "sm_drv_ahb.h"
 
extern char driver_name[64];
#ifdef NETLINK_SUPPORT
extern int src_seq;
#endif

#ifdef CLBR_ENABLE
#include "clientbridge.h"
#endif

/* for linux/unistd.h */
int errno;

unsigned int driver_debug = DEBUG_LEVEL;
unsigned int boot_mode = SM_MODE_AP;
struct net_device *root_sm_drv_device = NULL;

unsigned int ssid_from_driver = 0;
char ssid_from_user_str[33] = "not_set";
unsigned int ssid_from_user = 0;



#ifdef IWCONFIG_SUPPORT
extern const struct iw_handler_def sm_drv_handler_def;
extern struct iw_statistics *sm_drv_wireless_stats(struct net_device *dev);
#endif


/******************************************************************************
 *   Static Functions
 ******************************************************************************/

static int sm_drv_reset(struct net_device *dev, uint8_t sm_mode);


/******************************************************************************
 *   Helper Functions
 ******************************************************************************/


static inline void sm_drv_schedule_bh(struct net_device *dev)
{
    struct net_local *lp = dev->priv;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
    queue_task( &lp->tqueue, &tq_immediate );
    mark_bh(IMMEDIATE_BH);
#else
   #ifdef TASK_LET
	tasklet_hi_schedule(&lp->tl);
   #else
	schedule_work(&(lp->glbWQ));
   #endif
#endif
}





void frame_skb_free(struct net_device *dev, struct sk_buff *skb)
{

    if(skb)
      {
#ifdef MEMORY_TRACER
        mu_dev_kfree_skb(skb, 6);
#else
        dev_kfree_skb(skb);
#endif
      }
}

/******************************************************************************
 *   Driver API
 ******************************************************************************/

void sm_drv_dump_data(void *data, uint32_t length)
{
   uint8_t *temp = (uint8_t *)data;
   uint32_t i;
   i = i;
   temp = temp;
   for( i = 0; i < length; i++ )
       DEBUG(DBG_STUN, "%02x%c", temp[i], !((i+1)&15) ? '\n':' ' );

   if( i & 15 )
       DEBUG(DBG_STUN, "\n" );
}



void sm_drv_frame_rx(struct net_device *dev, struct sk_buff *skb)
{
     struct net_local *lp = (struct net_local *)dev->priv;
     static uint32_t lastReceived = 0;

     lastReceived = jiffies;
if(skb!=NULL)
{
      skb->dev = dev;
         skb->protocol = eth_type_trans( skb, dev );
         skb->ip_summed = CHECKSUM_NONE ;
#ifdef CLBR_ENABLE
         if(SM_MODE_CLIENT == lp->sm_mode)
         {
           Clbr_Rx(lp->clbr_ctxt,skb);
         }
#endif
                      lp->stats.rx_packets++;
                      lp->stats.rx_bytes += skb->len;
         netif_rx(skb);
    }
     else
         DEBUG(DBG_FRAME,"NULL skb received");
 }
/******************************************************************************
 *   Kernel API functions
 ******************************************************************************/

/* Create the net device instance that will be associated to the host interface */
struct net_device *sm_drv_netdev_create(struct net_device *netdev, int ioaddr, int irq)
{
    struct net_local *lp;

    DEBUG(DBG_CALLS, "sm_drv_netdev_create\n");
	

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
    netdev = alloc_etherdev(sizeof (struct net_local));
    if (netdev)
    {
        netdev_boot_setup_check (netdev);
        lp = netdev_priv(netdev);
    }
    else
    {
         DEBUG (DBG_ERR,"ALLOC ETHER DEV FAILED .\n");
         return NULL;
    }
    memset(lp,0,sizeof (struct net_local) );
#endif  /* LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0) */


    netdev->base_addr          = ioaddr;
    netdev->irq                = irq;

    strcpy(netdev->name,"wlan%d");
    netdev->open               = &sm_drv_open;
    netdev->stop               = &sm_drv_close;
    netdev->hard_start_xmit    = &sm_drv_transmit;
    netdev->get_stats          = &sm_drv_statistics;
    netdev->do_ioctl           = &sm_drv_ioctl;
	
#ifdef IWCONFIG_SUPPORT

netdev->get_wireless_stats=&sm_drv_wireless_stats;
#if WIRELESS_EXT > 12
netdev->wireless_handlers = (struct iw_handler_def *) &sm_drv_handler_def;

#endif
#endif //IWCONFIG Support
#ifdef HAVE_TX_TIMEOUT
    netdev->watchdog_timeo         = SM_DRV_TX_TIMEOUT;
    netdev->tx_timeout             = &sm_drv_tx_timeout;
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
    /* add a private device structure to the network device for private
     * definitions needed by the driver */
#ifdef CONFIG_ARCH_ISL3893
    netdev->priv = kmalloc(sizeof(struct net_local), GFP_ATOMIC );
#else
    netdev->priv = kmalloc(sizeof(struct net_local), GFP_ATOMIC | GFP_DMA);
#endif
    if (!netdev->priv) {
        DEBUG(DBG_ERR,"Could not allocate private data\n");
        kfree(netdev);
        return NULL;;
    }
    lp = netdev->priv;
    memset(lp, 0, sizeof(struct net_local));
#endif /* LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0) */

    spin_lock_init(&lp->sm_lock);

    init_waitqueue_head(&lp->conf_waitq);
    init_waitqueue_head(&lp->getresp_waitq);
    sema_init(&lp->sm_sem,1); 
    return netdev;
}

struct net_device *sm_drv_get_device( uint32_t *context )
{
    struct net_device *dev = root_sm_drv_device;
    struct net_local *lp;

    /* parse all devices for the context handle */
    while( dev )
    {
        /* check the device context handle and return dev if equal */
        lp = dev->priv;

        if( lp->sm_context == context )
            return dev;

        /* go to the next driver instance */
        dev = lp->next_module;
    }

    /* Oops, could not find the device holding the context */
    BUG();

    return NULL;
}

int sm_drv_open(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
#ifdef WDS_SUPPORT
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_open \n");


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
    MOD_INC_USE_COUNT;
#else
	try_module_get(THIS_MODULE);
#endif

#ifdef WDS_SUPPORT
    open_wds_links(wdsp);
#endif
#ifdef VSSDEV_SUPPORT
    open_vss_devices (lp->vssdev);
#endif
    netif_start_queue(dev);
    return 0;
}

int sm_drv_close(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
#ifdef WDS_SUPPORT
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_close \n");

#ifdef WDS_SUPPORT
    close_wds_links(wdsp);
#endif
#ifdef VSSDEV_SUPPORT
    close_vss_devices (lp->vssdev);
#endif

    netif_stop_queue(dev);

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
    MOD_DEC_USE_COUNT;
#else
    module_put(THIS_MODULE);
#endif

    return 0;
}

#ifdef CONFIG_BIGMAC_PCCARD
void PimforHeaderGet(PimforHeader *header, uint8_t *op, uint32_t *oid, uint32_t *length, void **data)
{
    uint8_t *temp = (char *)header;

    *data = NULL;

    if(header->version != PIMFOR_VERSION)
    {
        DEBUG(DBG_ERR,"PIMFOR Version does not match [%d]\n", header->version);
    }
    else
    {
        temp += sizeof(uint32_t); //version
        temp++;
	DEBUG(DBG_CALLS,"temp = %x ",*(uint32_t *)temp);
        *op = *temp;
	DEBUG(DBG_CALLS,"temp = %x ",*(uint8_t *)temp);
        temp++;
        *oid = ntohl(*(uint32_t *)temp);
	DEBUG(DBG_CALLS,"temp = %x ",*(uint32_t *)temp);
        temp += sizeof(uint32_t);
        temp += sizeof(uint16_t); // reserved bytes
        *length = ntohl(*(uint32_t *)temp);
        temp += sizeof(uint32_t);
	DEBUG(DBG_CALLS,"temp = %x %x \n",*(uint16_t *)temp,*length);
        *data = temp;

        DEBUG(DBG_ISOTOPE, "%s: Operation:%d OID:%x Length:%d\n", __FUNCTION__, *op, *oid, *length);
    }
}

void PimforHeaderSet(PimforHeader *header, uint8_t op, uint32_t oid, uint32_t length)
{
    uint8_t *temp = (char *)header;
    *(uint32_t *)temp = PIMFOR_VERSION;
    temp += sizeof(uint32_t);
    temp++;
    *temp = op;
    temp += sizeof(uint8_t);
    *(uint32_t *)temp = htonl(oid);
    temp += sizeof(uint32_t);
    *temp = 0;
    temp += sizeof(uint8_t);
    *temp = 0;
    temp += sizeof(uint8_t);
    *(uint32_t *)temp = htonl(length);

}
#elif CONFIG_BIGMAC_PCI
void PimforHeaderGet(PimforHeader *header, uint8_t *op, uint32_t *oid, uint32_t *length, void **data)
{
    uint8_t *temp = (char *)header;
    *data = NULL;
     
    if(header->version != PIMFOR_VERSION)
    {
        DEBUG(DBG_ERR,"PIMFOR Version does not match [%d]\n", header->version);
    }
    else
    {
        temp++;
        *op = *temp;
        temp++;
        *oid = ntohl(*(uint32_t *)temp);
        temp += sizeof(uint32_t);
        temp += 2;  // Go past the reserved bytes
        *length = ntohl(*(uint32_t *)temp);
        temp += sizeof(uint32_t);
        *data = temp;

        DEBUG(DBG_FRAME, "%s: Operation:%d OID:%x Length:%d\n", __FUNCTION__, *op, *oid, *length);
    }
}

void PimforHeaderSet(PimforHeader *header, uint8_t op, uint32_t oid, uint32_t length)
{
    uint8_t *temp = (char *)header;
    *temp = PIMFOR_VERSION;
    temp += sizeof(uint8_t);
    *temp = op;
    temp += sizeof(uint8_t);
    *(uint32_t *)temp = htonl(oid);
    temp += sizeof(uint32_t);
    *temp = 0;
    temp += sizeof(uint8_t);
    *temp = 0;
    temp += sizeof(uint8_t);
    *(uint32_t *)temp = htonl(length);

}
#endif

int sm_drv_transmit(struct sk_buff *skb, struct net_device *dev)
{
    struct net_local *lp = dev->priv;

#ifdef CLBR_ENABLE
	int replacements = 0;

	if(SM_MODE_CLIENT == lp->sm_mode)
	{
	    /* Learn IP-MAc association and return number of replacements in packet */
	    replacements = Clbr_Tx(lp->clbr_ctxt,skb);
	}
#endif
#ifdef MEMORY_TRACER
	/* register the already allocated skb to the tracer */
	mu_register_skb( skb, 17 );
#endif

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "sm_drv_transmit\n");

    if(!fragq_drv_pspace(lp, CB_TX_DATAQ))
    {
	dev_kfree_skb(skb);
	lp->stats.tx_dropped++;
    DEBUG(DBG_FRAME,"TX Queue Full \n");
        goto out;
    }

#ifdef DEBUG_ON
    lp->frameTransmitted++;
    if(!(lp->frameTransmitted % 50000))
    {
        DEBUG(DBG_FRAME,"Frame Transmitted [%d] Frame Tx Freed [%d]\n", 
                              lp->frameTransmitted, lp->frameTxFreed);
    }
#endif
#ifdef CLBR_ENABLE
    if(SM_MODE_CLIENT == lp->sm_mode)
    {
	Clbr_SubstituteMAC(lp->clbr_ctxt, frame->data, replacements);
    }
#endif

 	   // find out the next packet to be transmitted
    
    lp->stats.tx_packets++;
    lp->stats.tx_bytes += skb->len;
    dev->trans_start = jiffies;
    sm_drv_add_tx_queue(dev,skb);
    
    spin_unlock_bh(&lp->sm_lock);
    return 0;
out:
    spin_unlock_bh(&lp->sm_lock);
    return 0;
}
void sm_drv_tx_timeout(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct net_device_stats *statistics = &lp->stats;

    DEBUG(DBG_CALLS, "sm_drv_tx_timeout \n");

    /* increment the transmit error counter */
    statistics->tx_errors++;

    return;
}

struct net_device_stats *sm_drv_statistics(struct net_device *dev)
{
    struct net_local *lp = dev->priv;

    DEBUG(DBG_CALLS, "sm_drv_statistics \n");

    return &lp->stats;
}

int sm_drv_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
{
    struct net_local *lp = dev->priv;
    int err;
    struct s_bigmac_ioctl req;
    struct s_sm_conf smconf;
    uint32_t sm_mode;

    if (!capable (CAP_NET_ADMIN))
        return -EPERM;

    if (dev == NULL)
        return -ENODEV;

    if (cmd != SOFTMACIOCTL)
    {
        return -ENOTTY;
    }
#if 1
    /* Sleep until FIRMWARE is completely initialized */
    if(lp->device_state != DEVSTATE_ACTIVE )
        interruptible_sleep_on(&lp->conf_waitq);

    /* Check if we were woken by a signal */
    if(lp->device_state != DEVSTATE_ACTIVE )
    {
        DEBUG(DBG_ERR,"Device State is not active\n");
        return -EINTR;
    }
#endif
    err = copy_from_user(&req, ifr->ifr_data, sizeof(struct s_bigmac_ioctl));
    if (err)
        return -EFAULT;
	
        DEBUG(DBG_IOCTL,"In %s and req.cmd is %d : SMIOC_SETMODE is %d \n",__FUNCTION__,req.cmd,SMIOC_SETMODE);
    switch (req.cmd) {
        case SMIOC_SETMODE:
            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            sm_mode = *(uint32_t *)req.data;
            if(sm_mode < SM_MODE_CLIENT || sm_mode > SM_MODE_PROMISCUOUS)
                return -EINVAL;

          DEBUG(DBG_IOCTL, "sm_drv_ioctl: Setting Mode to %d\n", sm_mode);
            err = sm_drv_reset(dev, sm_mode);
            if(err < 0)
                return -EINVAL;

#ifdef IFF_802_11_WLAN
			if(SM_MODE_CLIENT == sm_mode)
			{
				/* Reset WLAN flag as it is required in case of AP only */
                dev->priv_flags &= (~IFF_802_11_WLAN);
			}
#endif
            break;
        case SMIOC_IFRESET:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Resetting the interface\n");
            /* Reset the device in the current mode */
            err = sm_drv_reset(dev, lp->sm_mode);

            if(err < 0)
                return -EINVAL;

            break;
        case SMIOC_SETOID:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Set OID 0x%x: data %p, len %d\n", req.oid, req.data, req.len);

            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            smconf.flags = SM_CONF_OPSET;
            smconf.length = req.len;
            smconf.oid = req.oid;
            smconf.data = req.data;

            err = sm_drv_conf(dev, &smconf );
            if (err < 0)
            {
                DEBUG(DBG_ERR, "sm_drv_ioctl (SET): sm_conf returned error %d\n", err);
                return -EINVAL;
            }

            break;
        case SMIOC_GETOID:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Get OID 0x%x, len %d\n", req.oid, req.len);

            if (!access_ok(VERIFY_WRITE, req.data, req.len))
                return -EFAULT;

            smconf.flags = 0;
            smconf.length = req.len;
            smconf.oid = req.oid;
            smconf.data = req.data;

            err = sm_drv_conf(dev, &smconf );
            if (err < 0)
            {
                DEBUG(DBG_ERR, "sm_drv_ioctl (GET): sm_conf returned error %d\n", err);
                return -EINVAL;
            }

            break;
        case SMIOC_SET_DBGLEVEL:
            DEBUG(DBG_IOCTL, "SMOIC_SET_DBGLEVEL\n");
            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            driver_debug = *(unsigned int *)req.data;

            DEBUG(DBG_ALL, "sm_drv_ioctl: Setting Debug Level to 0x%x\n", driver_debug);

            break;

#ifdef MEMORY_TRACER
        case SMIOC_UMAC_MEMTRACER:
            return mu_ioctl(req);
#endif

        default:
            DEBUG(DBG_ERR,"Unexpected value\n");
            return -EINVAL;
    }
    return 0;
}

static int sm_drv_reset(struct net_device *dev, uint8_t sm_mode)
{
    struct net_local *lp = dev->priv;
    int ret;

    if(lp->device_state == DEVSTATE_IDLE) {
        DEBUG(DBG_ERR, "sm_srv_reset: Cannot reset device in Idle state\n");
        return -1;
    }

    ret = sm_drv_down(dev);
    if(ret == 0)
        ret = sm_drv_up(dev, sm_mode);

    return ret;
}

int sm_drv_up(struct net_device *dev, uint8_t sm_mode)
{
    int ret = 0;
    struct net_local *lp = dev->priv;

    ret = lp->hif_up(dev);

    if(ret < 0)
        return ret;

    lp->sm_mode = sm_mode;

    /*
     * Used in Linux bridge to sent packets back on own port.
     * Use only when it's defined in linux/if.h header file.
     */
#ifdef IFF_802_11_WLAN
	if(SM_MODE_AP == lp->sm_mode)
	{
        dev->priv_flags |= IFF_802_11_WLAN;
	}
#endif

    return 0;
}

int sm_drv_down(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    int ret = 0;

    /* Disable all device interrupts */
    lp->hif_cli(dev);

    /* Run the bottom halve if it is scheduled */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
    run_task_queue(&tq_immediate);
#else 
	flush_scheduled_work();
#endif
    spin_lock_bh(&lp->sm_lock);

    sm_drv_psm_fsm(dev, PSMEVENT_IFDOWN);

    DEBUG(DBG_ALL, "Shut down BigMAC\n");


    ret = lp->hif_down(dev);

    spin_unlock_bh(&lp->sm_lock);

    return ret;
}

void sm_drv_psm_fsm(struct net_device *dev, int event)
{
    struct net_local *lp = dev->priv;

    if( lp->device_state == DEVSTATE_ACTIVE || lp->device_state == DEVSTATE_BOOTING )
    {
        switch(event) {
            case PSMEVENT_RUN_BH:
                /* schedule bottom halve */
                sm_drv_schedule_bh(dev);                
                break;
            case PSMEVENT_IFUP:
                /* go back into the idle state */
                lp->device_state = DEVSTATE_ACTIVE;
                break;
            case PSMEVENT_IFDOWN:
                /* go back into the idle state */
		        netif_stop_queue(dev);
                lp->device_state = DEVSTATE_IDLE;
                break;
            default:
                /* Unhandled event */
                break;
         }
    }
    else if( event == PSMEVENT_BOOT )
        lp->device_state = DEVSTATE_BOOTING;
}



int sm_drv_conf( struct net_device *dev, struct s_sm_conf *smconf)
{
    struct net_local  *lp;
    uint8_t *dest;
    uint32_t messageLength;
    lp = dev->priv;
    
    if(down_interruptible(&lp->sm_sem))
        return -1;
    spin_lock_bh(&lp->sm_lock);

    if(!fragq_drv_pspace(lp, CB_TX_CTRLQ))
    {   
        DEBUG(DBG_CTRL,"ctrl q is full \n");
        spin_unlock_bh(&lp->sm_lock);
        up(&lp->sm_sem);  
        return -1;
    }
    DEBUG( DBG_CTRL, "sm_drv_conf(%p, oid: %x, data: %p, lenght: %d)\n", dev, smconf->oid, smconf->data, smconf->length );

    messageLength = PIMFOR_HEADER_LENGTH;

    if(smconf->data != NULL)
        messageLength += smconf->length;
      dest = kmalloc(messageLength, GFP_ATOMIC);
    if(!dest)
    {
        DEBUG(DBG_CTRL,"Failed to allocate memory for control packet data\n");
        return -1;
    }

    memset(dest, 0,  messageLength);
    PimforHeaderSet((PimforHeader *)dest, (uint8_t)(smconf->flags & SM_CONF_OPSET) ? PIMFOR_OP_SET : PIMFOR_OP_GET, smconf->oid, smconf->length);

    if(smconf->data != NULL)
    {
        DEBUG(DBG_STUN, "SM CONF Length is %d\n", smconf->length);
        memcpy(dest + PIMFOR_HEADER_LENGTH, smconf->data, smconf->length);
    }
    sm_drv_add_tx_ctrl_queue(dev,dest,messageLength);
    spin_unlock_bh(&lp->sm_lock);


    if( (smconf->oid == 0x10000002) && (ssid_from_driver == 0) && ( smconf->flags == SM_CONF_OPSET) )
    {
        memcpy(ssid_from_user_str , ((struct obj_ssid *)(smconf->data))->octets,33);
    }

    if(smconf->oid == 0x1b000008 && (smconf->flags  & SM_CONF_OPSET ))
    {
        up(&lp->sm_sem);
        return 0;
    }
    if( (smconf->oid == 0x10000002) && (ssid_from_driver==1) )
    {
        mdelay(1000);
        up(&lp->sm_sem);
        return 0;
    }

#ifndef AUTO_ACCESS
    if(1) 
#elif AUTO_ACCESS  
    if(smconf->oid == DOT11_OID_ASSOCIATE || smconf->oid == DOT11_OID_AUTHENTICATE || smconf->oid == DOT11_OID_REASSOCIATE)
    { 
        up(&lp->sm_sem);
        return 0;
    }
    else
#endif
    {
        /*
         * a) Go to Sleep till a response is received from the firmware or time-out comes.
         * b) Put on the sleep queue.
         * c) Wake up when the response is received.
         * d) When response is received, need to distinguish whether it is a
         *    TRAP or a response to the GET operation or time-out.
         * e) If it is a response, then wake up the sleeping process.
         * f) If it is time-out then watch_dog eill be decremented.
         * g) When watch_dog goes to 0 then Card will be reset, Firmware will uploaded and it will run.
         * h) Sounds simple! Try implementing it :)
        */ 
        int err = 0;
        lp->getresp.data = NULL;
        /* Sleep till a responce come or timer runs out */
        if (wait_event_interruptible(lp->getresp_waitq, (lp->getresp.data != NULL)) <0  )    /* Error Condition */
        {
              DEBUG(DBG_ERR,"wait_event_interruptible_timeout: failed waking on correct event\n");
              printk("wait_event_interruptible_timeout: failed waking on correct event\n");
              err = -1;
              goto geterr_out;
        }
        else                         /* Responce is received */
	{   
            if(lp->getresp.flags == PIMFOR_OP_ERROR)              /* Checking for Error flags */
            {
                err =-1;
                goto geterr_out;
            } 
              /* We got woken with a response to our get request */
            if(lp->getresp.oid != smconf->oid)
            {
                DEBUG(DBG_ERR,"sm_drv_conf: Get response invalid OID (0x%x, 0x%x)\n",
                        smconf->oid, lp->getresp.oid);
                err = -1;
                goto geterr_out;
            }
            else if(lp->getresp.length > smconf->length) 
            {
                DEBUG(DBG_ERR,"sm_drv_conf: Get overflow (oid 0x%x, %d > %d)\n",
                                smconf->oid, lp->getresp.length, smconf->length);
                err = -1;
                goto geterr_out;
            }
         
	 }
        
        /* So we've got data copy in smconf struct again and return seccesfull */
        if(lp->getresp.data != NULL)
            memcpy(smconf->data, lp->getresp.data, lp->getresp.length);

        smconf->length = lp->getresp.length;
        DEBUG( DBG_CTRL, "sm_drv_conf: pending returned succesfull\n");
geterr_out:
        /* Checking out the case of no responce */
        if(lp->getresp.data != NULL)
            kfree(lp->getresp.data);
        lp->getresp.data = NULL;
        /* Giving up the semaphore */
        up(&lp->sm_sem);
        if (err == -1) 
        {  
//         DEBUG( DBG_ERR, "sm_drv_conf: pending returned failure oid is %x\n",smconf->oid);
             
         return -1;
        }
    }
    return 0;
}


/******************************************************************************
 *   Netlink Control Interface
 ******************************************************************************/

int sm_drv_set( struct net_device *dev, long oid, void *data, unsigned int len )
{
    struct s_sm_conf  smconf;
    int err = 0;
    DEBUG( DBG_CTRL, "sm_drv_set(%p, %lx, %p, %d)\n", dev, oid, data, len );

    if (dev==NULL) {
        return 1;
    }
    smconf.flags  = SM_CONF_OPSET;
    smconf.oid    = oid;
    smconf.data   = data;
    smconf.length = len;
    err = sm_drv_conf( dev, &smconf);
    return err;
}

int sm_drv_get( struct net_device *dev, long oid, void *data, unsigned int len )
{
    struct s_sm_conf  smconf;
    int err = 0;

    DEBUG( DBG_CTRL, "sm_drv_get(%p, %lx, %p, %d)\n", dev, oid, data, len );

    if (dev==NULL) {
        return 1;
    }
    smconf.flags  = 0;
    smconf.oid    = oid;
    smconf.data   = data;
    smconf.length = len;
	err = sm_drv_conf( dev, &smconf);

    return err;
}

#ifdef NETLINK_SUPPORT
#ifdef WDS_SUPPORT
int sm_drv_addwds( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct wds_link_msg *wlmp = (struct wds_link_msg *) data;
    struct obj_addrkey wds_addrkey;
    unsigned long f;
    int retval;
	// copy mac address
  	memcpy(&wds_addrkey, data, 6);

    // check the data element by its size
    if ( len != sizeof(struct wds_link_msg))
    {
        DEBUG(DBG_ERR,  "sm_drv_addwds: Error, length not size of struct wds_link_msg\n" );
        return -1;
    }

    DEBUG(DBG_WDS, "sm_drv_addwds: (%x:%x:%x:%x:%x:%x)\n", wlmp->mac[0], wlmp->mac[1],
        wlmp->mac[2], wlmp->mac[3], wlmp->mac[4], wlmp->mac[5] );

    if ( retval = add_wds_link(dev, lp->wdsp, wlmp->mac, wlmp->name), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, add_wds_link failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, oid, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }


    if( retval = sm_drv_get( dev, DOT11_OID_FREQUENCY, &f, sizeof(unsigned long) ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_get DOT11_OID_FREQUENCY failed\n", retval );
        return -1;
    }
    else
    {
		DEBUG(DBG_WDS, "sm_drv_addwds: sm_drv_get DOT11_OID_FREQUENCY returned %ld\n", f);
	}

    if FREQ_IS_5GHZ( f ) {
        DEBUG(DBG_WDS, "sm_drv_addwds: band = a\n");
		wds_addrkey.ext = 1;
	} else {
        DEBUG(DBG_WDS, "sm_drv_addwds: band = g\n");
		wds_addrkey.ext = 0;
	}

    if( retval = sm_drv_set( dev, DOT11_OID_EAPAUTHSTAEX, &wds_addrkey, sizeof(obj_addrkey) ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_set DOT11_OID_EAPAUTHSTAEX failed\n", retval );
        return -1;
    }

    return 0;
}

int sm_drv_delwds( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct wds_link_msg *wlmp = (struct wds_link_msg *) data;
    int retval;
    unsigned long f;
    struct obj_addrkey wds_addrkey;

    if ( len != sizeof(struct wds_link_msg))
    {
        DEBUG( DBG_ERR,"sm_drv_delwds: Error, length not size of struct wds_link_msg\n" );
        return -1;
    }

    DEBUG(DBG_WDS, "sm_drv_delwds: (%x:%x:%x:%x:%x:%x)\n", wlmp->mac[0], wlmp->mac[1],
        wlmp->mac[2], wlmp->mac[3], wlmp->mac[4], wlmp->mac[5] );

    if ( retval = del_wds_link(dev, lp->wdsp, wlmp->mac, wlmp->name), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_delwds: Error %d, del_wds_link failed\n", retval );
        return -1;
    }

    /*
     * The UMAC does not (yet) take the addrkey ext field into account for WDS links; We need
     * to set the AUTHSTA oid for this MAC however, so we need the proper value for ext, so
     * here we deduce it from the frequency.
     */

    if( retval = sm_drv_get( dev, DOT11_OID_FREQUENCY, &f, sizeof(unsigned long) ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_get DOT11_OID_FREQUENCY failed\n", retval );
        return -1;
    }
    else
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: sm_drv_get DOT11_OID_FREQUENCY returned %ld\n", f);
    }

    memcpy(&wds_addrkey, data, 6);
    if FREQ_IS_5GHZ( f ) {
        DEBUG(DBG_WDS, "sm_drv_delwds: band = a\n");
        wds_addrkey.ext = 1;
    } else {
        DEBUG(DBG_WDS, "sm_drv_delwds: band = g\n");
        wds_addrkey.ext = 0;
    }

    if( retval = sm_drv_set( dev, DOT11_OID_EAPUNAUTHSTAEX, &wds_addrkey, sizeof(wds_addrkey)), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_delwds: Error %d DOT11_OID_EAPUNAUTSTAEX , sm_drv_set failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, oid, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_delwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    return 0;
}
#endif
#ifdef VSSDEV_SUPPORT
int sm_drv_procvss( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct obj_serviceset *vssobj = (struct obj_serviceset *) data;
    struct net_device *vss_dev;
    int retval;
    int vssid;

    // check the data element by its size
    if ( len != sizeof(struct obj_serviceset))
    {
        DEBUG(DBG_VSS, "sm_drv_procvss: Error, length not size of struct obj_serviceset\n");
        return -1;
    }

    /* Only do special things for OPSET. Let GET through unaltered. */
    if ( op != SM_CONF_OPSET )
        return 1;

    vssid = oid - DOT11_OID_SERVICESET0;
    if (vssobj->ssid.length != 0)
    {
        /* Add a VSS device */
        if ( retval = add_vss_device(dev, lp->vssdev, vssid), retval < 0 )
        {
            if (retval == -3) /* VSS device already exists. (Don't return. Sent settings to UMAC) */
            {
                DEBUG(DBG_VSS, "sm_drv_procvss: Device already exists. No new VSS dev created.\n" );
            }
            else
            {
                DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, add_vss_device failed\n", retval );
                return -1;
            }
        }
    }
    else
    {
        printk(KERN_ERR "Reaching procvss delete");
        /* Remove a VSS device */
        if ( retval = del_vss_device (dev, lp->vssdev, vssid), retval < 0 )
        {
            DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, del_vss_device failed\n",
retval );
            return -1;
        }
    }

    if( retval = sm_drv_set( dev, oid, vssobj, sizeof (struct obj_serviceset)),
retval < 0 )
    {
        DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    /*
     * For VAP, we use randomly generated MAC addresses. These should be known,
     * before the VSS interface is placed into a bridge. UMAC copies the BSSID
     * into the structure, and we use this address as MAC address for the interface.
     */
    if( vss_dev = vss_find_device( vssid, lp->vssdev ), vss_dev != NULL )
    {
        /* Check if not all zeroes (MSSID). */
        if( memcmp(vssobj->bssid, "\x00\x00\x00\x00\x00\x00", 6) != 0 )
        {
            memcpy(vss_dev->dev_addr, vssobj->bssid, ETH_ALEN);
        }
    }

    return 0;
}
#endif



int sm_drv_skip( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    return 0;
}

#define SREAD                           0x01
#define SWRITE                          0x02

struct s_mgt_obj
{
    long oid;
    int (*fp)( struct net_device *dev, int op, long oid, void *data, unsigned int len );
    int  length;
    int  flags;
} sm_drv_mgt_objs[] =
{
#ifdef WDS_SUPPORT
    {DOT11_OID_WDSLINKADD,      sm_drv_addwds,  0,      SWRITE },
    {DOT11_OID_WDSLINKREMOVE,   sm_drv_delwds,  0,      SWRITE },
#endif
#ifdef VSSDEV_SUPPORT
    {DOT11_OID_SERVICESET0,        sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 1,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 2,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 3,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 4,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 5,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 6,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 7,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 8,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 9,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 10,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 11,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 12,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 13,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 14,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 15,   sm_drv_procvss, 0, SWRITE|SREAD},
#endif

};


#define SM_DRV_MGT_OBJS_SIZE     (sizeof(sm_drv_mgt_objs) / sizeof (struct s_mgt_obj))

int sm_drv_lookup_oid( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    int i;
    struct s_mgt_obj *obj;
    int flags = ( op != 0 ) ? SWRITE : SREAD;

    for( i=0, obj=sm_drv_mgt_objs; i<SM_DRV_MGT_OBJS_SIZE; i++, obj++ ) {
        /* Find matching oid in table */
        if( obj->oid == oid ) {
            if ( obj->flags & flags ) {
                if ( obj->fp )
                    /* Found an function for this entry in the table. The
                     * function should do a better job in communicating with
                     * the bigmac so call this function.
                     */
                    return ( obj->fp( dev, op, oid, data, len ) );
                else
                    /* Although there is an entry in the table there is no
                     * function defined for the entry so assume that we still
                     * want the regular treatment.
                     */
                    return 1;
            } else {
               /* Found an entry for this oid. If the requested operation (flags)
                * is not define in the table report an error.
                */
               return -1;
            }
        }
    }

    return 1; /* default:  apply regular treatment */
}

int sm_drv_mgt_indication( unsigned int dev_type, unsigned int dev_seq,
                          unsigned int src_id, unsigned int src_seq,
                          unsigned int op, unsigned int oid, void *data, unsigned long len)
{
    struct net_device *dev;
    struct net_local  *lp;
    struct s_sm_conf smconf;
    int ret = 0;

    DEBUG( DBG_NETLINK, "sm_drv_mgt_indication: dev_seq %d op %d len %ld oid %x\n", dev_seq, op, len, oid );

    op = ( op == PIMFOR_OP_SET) ? SM_CONF_OPSET : 0;

    if ( ! (dev = dev_get_by_index(dev_seq)) ) {
        return -1;
    }

    lp = dev->priv;



    ret = sm_drv_lookup_oid( dev, op, oid, data, len );

    if ( ret > 0 )
    {
        DEBUG( DBG_NETLINK, "sm_drv_mgt_indication:passed( %s, %d, %ld, %x )\n", dev->name, op, len, oid );

        smconf.flags  = op;
        smconf.oid    = oid;
        smconf.data   = data;
        smconf.length = len;
        
        /* This is for RESET functionality*/ 
        if(smconf.oid == 0x10000002)
        {
            ssid_from_driver = 0;
        }

        ret = sm_drv_conf( dev, &smconf);
        if (ret >= 0)
        {
             ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_RESPONSE, smconf.oid, smconf.data, smconf.length);
             DEBUG(DBG_NETLINK, "sm_drv_mgt_indication( %x ):succesfull\n", oid );
        }
        else
        {
             DEBUG(DBG_NETLINK, "sm_drv_mgt_indication( %x ):error: %d\n", oid, ret );
             ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_ERROR, smconf.oid, smconf.data, smconf.length);
        }
    }
    else if ( ret == 0 )
    {

        DEBUG(DBG_NETLINK, "sm_drv_indication:filtered( %s, %d, %ld, %x )\n", dev->name, op, len, oid );
        ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_RESPONSE, oid, data, len);

    }
    else
    {

        DEBUG(DBG_NETLINK, "sm_drv_mgt_indication:ignored( %s, %d, %ld, %x )\n", dev->name, op, len, oid );
        ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_ERROR, oid, data, len);
    }

    dev_put( dev );

    return ret;
}
#endif
