/*  $Header: /home/cvsadmin/pbs/Trunk_linux/kernel/modules/ip806gav4_new/cnxt-src/drivers/wireless/stung/driver/core/sm_drv_wds.c,v 1.1.1.1 2007-10-04 07:12:55 raul_xu Exp $
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/rtnetlink.h>
#include <linux/string.h>
#include <linux/poll.h>

#include "sm_drv_wds.h"
#include "sm_drv.h"

int add_wds_link(struct net_device *dev, struct wds_priv *wdsp, unsigned char *mac_addr, char *brifname )
{
    int err = 0;
    int i=0, j=0;

    struct net_device *wds_dev;

    DEBUG( DBG_WDS, "add_wds_link \n");

    if ( ( dev == NULL ) || ( wdsp == NULL ) || ( mac_addr == NULL ) || ( brifname == NULL ) )
    {
        DEBUG( DBG_WDS, "add_wds_link(%lx, %lx, %lx, %lx) wrong parameter(s)!\n",
            (unsigned long)dev, (unsigned long)wdsp, (unsigned long)mac_addr, (unsigned long)brifname );
        return -1;
    }
	
#ifndef VSSDEV_SUPPORT
    /* If the parent device isn't bridged, the WDS will not work */
    if (dev->br_port == NULL)
    {
        DEBUG( DBG_WDS, "add_wds_link: parent device (%s) not bridged; can't add WDS link\n", dev->name );
        return -2;
    }
#endif

    /* First check if MAX_WDS_LINKS is reached */
    if (wdsp->current_nof_wds_links == MAX_WDS_LINKS)
    {
        /* Max number of links reached */
        DEBUG( DBG_WDS, "add_wds_link: max number of WDS links (%d) reached!\n", MAX_WDS_LINKS );
        return -3;
    }

    /* If this MAC address is our own mac address */
    if(memcmp(dev->dev_addr, mac_addr, 6) == 0)
    {
        DEBUG( DBG_WDS, "add_wds_link: Cannot add WDS link for own MAC address: %2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x\n",
                  mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
        return -4;
    }

    /* Check if this MAC addres is already in the list. */
    for (i=0 ; i < MAX_WDS_LINKS; i++)
    {
        if (((struct wds_net_local*)(wdsp->wds_dev[i])) == NULL)
            continue;

        /* If this MAC address is already linked don't add new WDS device */
        if(memcmp(((struct wds_net_local*)(wdsp->wds_dev[i]->priv))->wds_mac, mac_addr, 6) == 0)
        {
            DEBUG( DBG_WDS, "add_wds_link: WDS link for MAC: %2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x already active!\n",
                      mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
            return -5;
        }
    }

    /* Find an empty field to add WDS device */
    for (i=0 ; i< MAX_WDS_LINKS; i++)
    {
        if (wdsp->wds_dev[i] == NULL)
        {
            /* We have found an empty structure
             * So we can actualy create a new device for this link
             */
            sprintf( brifname, "%s_%d", dev->name, i );

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
            wds_dev = alloc_netdev(0, brifname, ether_setup);
#else
            wds_dev = dev_alloc(brifname, &err);
            if(wds_dev) ether_setup(wds_dev);
#endif
            if ( !wds_dev )
            {
                DEBUG( DBG_WDS,"add_wds_link: dev_alloc() for WDS failed!\n");
                return -6;
            }
            /* Get a pointer to this WDS device */
            wdsp->wds_dev[i] = wds_dev;

            /* May be overridden by piggyback drivers */

            /* Initialize the device priv structure. */
            wds_dev->priv = kmalloc(sizeof(struct wds_net_local), GFP_KERNEL);
            if (wds_dev->priv == NULL) {
                return -7;
            }
            memset(wds_dev->priv, 0, sizeof(struct wds_net_local));
            /* Set the parent device for this WDS link */
            ((struct wds_net_local*)(wds_dev->priv))->parent_dev = dev;

            /* Set WDS MAC in priv structure */
            DEBUG( DBG_WDS,"add_wds_link: wds_mac=");
            for (j = 0; j < 6; j++)
            {
                ((struct wds_net_local*)(wds_dev->priv))->wds_mac[j] = mac_addr[j];
                DEBUG( DBG_WDS," %2.2x", mac_addr[j] );
            }
            DEBUG( DBG_WDS,"\n");

            /* Retrieve and print the ethernet address. */
            DEBUG( DBG_WDS," eth_mac=");
            for (j = 0; j < 6; j++)
            {
                wds_dev->dev_addr[j] = ((struct wds_net_local*)(wds_dev->priv))->parent_dev->dev_addr[j];
                DEBUG( DBG_WDS," %2.2x", wds_dev->dev_addr[j] );
            }
            DEBUG( DBG_WDS,"\n");

            wds_dev->addr_len = 6;

            /* Override the network functions we need to use */
            wds_dev->open                       = wds_net_open;
            wds_dev->stop                       = wds_net_close;
            wds_dev->get_stats              = wds_net_get_stats;
            wds_dev->hard_start_xmit    = wds_net_send_packet;
            wds_dev->do_ioctl               = wds_net_ioctl;

            /* Make ifconfig display some details */
            wds_dev->base_addr = 0;

            err = register_netdev(wds_dev);
            if (err)
            {
                        DEBUG( DBG_WDS,"add_wds_link: register_netdev() for WDS failed!\n");
                        return -8;
            }
            DEBUG(DBG_WDS, "add_wds_link: registered device name: %s\n", wds_dev->name);

            /* Bring the device up, when the root device is UP... */
            if (dev->flags & IFF_UP)
            {
            		rtnl_lock();
                        err = dev_open(wds_dev);
                        rtnl_unlock();
                        if (err)
                        {
                            DEBUG(DBG_WDS, "add_wds_link: dev_open() for WDS failed!\n");
                            return -9;
                        }
                        DEBUG(DBG_WDS, "add_wds_link: bringing up device name: %s\n", wds_dev->name);
            }
            else
            {
                DEBUG(DBG_WDS, "add_wds_link: NOT bringing up device name: %s, cause root device isn't up yet...\n", wds_dev->name);
            }

            wdsp->current_nof_wds_links++;
            return 0;
        }
    }
    /* This should not happen*/
    DEBUG(DBG_WDS, "add_wds_link: WDS link administration screwed\n");
    return -13;
}

int del_wds_link(struct net_device *dev, struct wds_priv *wdsp, unsigned char *mac_addr, char *brifname )
{
    int err = 0;
    int i = 0;

    struct net_device *wds_dev;

    DEBUG( DBG_WDS, "del_wds_link \n");

    if ( ( dev == NULL ) || ( wdsp == NULL ) || ( mac_addr == NULL ) || ( brifname == NULL ) )
    {
        printk( KERN_INFO "del_wds_link(%lx, %lx, %lx, %lx) wrong parameter(s)!\n",
               (unsigned long)dev, (unsigned long)wdsp, (unsigned long)mac_addr, (unsigned long)brifname );
        return -1;
    }

    /* Check if this MAC addres is in the WDS link list. */
    for (i=0 ; i< MAX_WDS_LINKS; i++)
    {
        if( (wdsp->wds_dev[i]) &&
            (memcmp(((struct wds_net_local*)(wdsp->wds_dev[i]->priv))->wds_mac, mac_addr, 6 ) == 0 ) )
        {
            wds_dev = (struct net_device *)wdsp->wds_dev[i];
            strcpy( brifname, wds_dev->name );

            /* Bring the device down */
            rtnl_lock();
            err = dev_close(wds_dev);
            rtnl_unlock();
            if (err)
            {
                printk( KERN_INFO "del_wds_link: dev_close() for WDS failed!\n");
                return err;
            }
            unregister_netdev(wds_dev);

            kfree(wds_dev->priv);
            free_netdev(wds_dev);
            wdsp->current_nof_wds_links--;
            wdsp->wds_dev[i] = NULL;

            DEBUG(DBG_WDS, "del_wds_link: WDSLink removed succesfully\n");
            return err;
        }
    }

    printk( KERN_INFO "del_wds_link: MAC: %2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x is not a WDS link\n",
              mac_addr[0], mac_addr[1], mac_addr[2], mac_addr[3], mac_addr[4], mac_addr[5]);
    return -1;
}

/*
 * called from the open() function of sm_drv. rtnl_lock
 * is already held because of dev_open();
 */
 
int open_wds_links(struct wds_priv *wdsp)
{
    int i;

    DEBUG(DBG_WDS, "open_wds_links \n");

    if ( wdsp == NULL ) {
        DEBUG( DBG_WDS, "open_wds_links: no resources");
        return -1;
    }

    /* Bring the associated WDS devices up and RUNNING. */
    DEBUG(DBG_WDS, "Open all associated WDS links: ");

    for (i = 0; i < MAX_WDS_LINKS; i++)
    {
        if (wdsp->wds_dev[i] == NULL)
            continue;
        DEBUG(DBG_WDS, "WDS%d...",i);
        dev_open(wdsp->wds_dev[i]);
    }
    DEBUG(DBG_WDS, "\n");
    return 0;
}
EXPORT_SYMBOL(open_wds_links);

/*
 * Called from the close() function of the sm_drv. rtnl lock
 * is already grabbed by dev_close();
 */
 
int close_wds_links(struct wds_priv *wdsp)
{
    int i;

    DEBUG(DBG_WDS, "close_wds_links \n");

    if ( wdsp == NULL ) {
        DEBUG( DBG_WDS, "close_wds_links: no resources");
        return -1;
    }

    DEBUG(DBG_WDS, "Close associated WDS links: ");
    for (i = 0; i < MAX_WDS_LINKS; i++)
    {
        if (wdsp->wds_dev[i] == NULL)
            continue;
        DEBUG(DBG_WDS, "WDS%d...",i);
        dev_close(wdsp->wds_dev[i]);
    }
    DEBUG(DBG_WDS, "\n");
    return 0;
}


int check_skb_for_wds(struct sk_buff *skb, unsigned char *wds_mac)
{
    /* If this skb came from a WDS device, the
     * skb->cb field will be filled with a WDSLink mac_addr.
     * Due to the reason the cb field is free to use, the MAC address
     * will be packed in the following keys "WDSL"<MAC ADDRESS>".
     */

    if(*(long*)&skb->cb[0] == cpu_to_le32(0x4c534457)) /* WDSL */
    {
        memcpy(wds_mac, skb->cb+4, 6);
        DEBUG( DBG_WDS, "check_skb_for_wds: found wdsmac in skb: %2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x\n",
                wds_mac[0],wds_mac[1],wds_mac[2],wds_mac[3],wds_mac[4],wds_mac[5]);
        /* Make the WDS data invalid */
        *(long*)&skb->cb[0] = 0;

        return(1);      /* WDS Link is available */
    }
    return(0);          /* WDS Link is unavailable */
}

struct net_device *wds_find_device( unsigned char *wds_mac, struct wds_priv *wdsp )
{
    int i=0;

    DEBUG( DBG_WDS, "wds_find_device\n");
    if ( wdsp == NULL ) {
        DEBUG(DBG_WDS, "wds_find_device: wds_priv not found, returning NULL\n");
        return NULL;
    }

    if (wds_mac[0] == 0 && wds_mac[1] == 0 &&
        wds_mac[2] == 0 && wds_mac[3] == 0 &&
        wds_mac[4] == 0 && wds_mac[5] == 0)
    {
        DEBUG(DBG_WDS, "wds_find_device: wds_mac no MAC found, returning NULL\n");
        return NULL;
    }
    for (i=0; i < MAX_WDS_LINKS; i++)
    {
        if (wdsp->wds_dev[i] == NULL)
            continue;
        if(memcmp(((struct wds_net_local*)(wdsp->wds_dev[i]->priv))->wds_mac, wds_mac, 6) == 0)
        {
            DEBUG(DBG_WDS, "wds_find_device: wds_mac MAC found, returning dev->name: %s\n",
                   wdsp->wds_dev[i]->name);
            return ((struct net_device*)wdsp->wds_dev[i]);
        }
    }
    DEBUG(DBG_WDS, "wds_find_device: WDS from mac %2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x not in current config, returning NULL\n",
           wds_mac[0],wds_mac[1],wds_mac[2],wds_mac[3],wds_mac[4],wds_mac[5]);

    return NULL;
}

int wds_net_open(struct net_device *dev)
{
#ifndef VSSDEV_SUPPORT    
    struct wds_net_local *wnlp = (struct wds_net_local *)dev->priv;
#endif    
    int err = 0;

    DEBUG(DBG_WDS, "wds_net_open \n");

    netif_start_queue(dev);

#ifndef VSSDEV_SUPPORT
    /* Check if the parent device is bridged */
    if (wnlp->parent_dev->br_port == NULL)
    {
                DEBUG(DBG_WDS, "wds_net_open: Error parent device (%s) is not "
                        "bridged, can't add WDS link.\n", wnlp->parent_dev->name);
        return -1;
    }
#endif

    return err;
}

int wds_net_send_packet(struct sk_buff *skb, struct net_device *dev)
{    
    struct wds_net_local *wnl = (struct wds_net_local *)dev->priv;

    DEBUG(DBG_WDS, "wds_net_send_packet\n");

    if (wnl == NULL)
    {
        printk("wds_net_send_packet: NULL pointer detected\n");
        return 0;
    }
    if ((wnl->parent_dev->flags & IFF_UP) && (dev->flags & IFF_UP))
    {
        /* OK lets copy the WDSlink MACAddres in the skb->cb fields */
        memcpy(skb->cb, "WDSL", 4);
        memcpy(skb->cb+4, ((struct wds_net_local*)(dev->priv))->wds_mac, dev->addr_len);

        /* Set the "transmit" dev in this skb */
        skb->dev = wnl->parent_dev;

        /* Move this skb to the "transmit" devices queue */
        if(dev_queue_xmit(skb) < 0)
        {
            DEBUG( DBG_WDS, "wds_net_send_packet: dev_queue_xmit failed\n");
        }
    }
    return 0;
}

int wds_net_close(struct net_device *dev)
{
    int err = 0;
#ifndef VSSDEV_SUPPORT
    struct wds_net_local *lp = (struct wds_net_local *)dev->priv;
#endif

    DEBUG(DBG_WDS, "wds_net_close \n");

    netif_stop_queue(dev);

#ifndef VSSDEV_SUPPORT
    /* Check if the parent device is bridged */
    if (lp->parent_dev->br_port == NULL)
    {
                DEBUG(DBG_WDS, "wds_net_close: Error parent device (%s) is not bridged, can't close WDS link.\n",lp->parent_dev->name);
        return -1;
    }
#endif

    return err;
}


/**********************************************************************
 *  wds_net_get_stats
 *
 *  DESCRIPTION: Gets the statistics for the WDS device.
 *
 *  PARAMETERS:  struct net_device *dev - WDS device to get statistics from.
 *
 *  RETURN:      pointer to net_device_stats struct.
 *
 **********************************************************************/
struct net_device_stats* wds_net_get_stats(struct net_device *dev)
{
    struct wds_net_local *lp = (struct wds_net_local *)dev->priv;
    struct net_device_stats *stats = &lp->stats;

    DEBUG(DBG_WDS, "wds_net_get_stats \n");

    return stats;
}

/**********************************************************************
 *  wds_net_ioctl
 *
 *  DESCRIPTION: Ioctl for WDS devices are NOT supported. Tell them.
 *
 *  PARAMETERS:  struct net_device *dev -
 *               struct ifreq      *ifr -
 *               int    cmd             -
 *
 *  RETURN:      -EINVAL.
 *
 **********************************************************************/
int wds_net_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
{
    DEBUG( DBG_WDS, "wds_net_ioctl: Ioctls for WDS devices are NOT supported.\n");
    return -EINVAL;
}
