/* ###########################################################################
# (c) Copyright GlobespanVirata Limited 2003
#
# GlobespanVirata Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential
# and is proprietary to GlobespanVirata Limited ("GlobespanVirata").  It may
# only be read, used, copied, adapted, modified or otherwise dealt with by
# you if you have entered into a confidentiality agreement with Virata and
# then subject to the terms of that confidentiality agreement and any other
# applicable agreement between you and GlobespanVirata  If you are in any
# doubt as to whether you are entitled to access, read, use, copy, adapt,
# modify or otherwise deal with the Software or whether you are entitled to
# disclose the Software to any other person you should contact GlobespanVirata.
# If you have not entered into a confidentiality agreement with GlobespanVirata
# granting access to this Software you should forthwith return all media,
# copies and printed listings containing the Software to GlobespanVirata.
#
# GlobespanVirata reserves the right to take legal action against you should
# you breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@globespanvirata.com
# ##########################################################################*/

/****************************************************************************/
/*                                                                          */
/* bf_config_io.h                                                           */
/*                                                                          */
/* Bandit Family (Gallus WLC) IO Configuration Block Hardware Definitions   */
/*                                                                          */
/****************************************************************************/

#ifndef BF_IOCONF_H
#define BF_IOCONF_H

/* C structure mapping onto the IOCONF interface registers */

typedef volatile struct {
 unsigned CONFIG0; /* @0 */
 unsigned CONFIG1; /* @4 */
 unsigned CONFIG2; /* @8 */
 unsigned CONFIG3; /* @12 */
 unsigned CONFIG4; /* @16 */
 unsigned CONFIG5; /* @20 */
 unsigned CONFIG6; /* @24 */
 unsigned CONFIG7; /* @28 */
 unsigned CONFIG8; /* @32 */
 unsigned CONFIG9; /* @36 */
 unsigned CONFIG10; /* @40 */
 unsigned CONFIG11; /* @44 */
 unsigned CONFIG12; /* @48 */
 unsigned CONFIG13; /* @52 */
 unsigned CONFIG14; /* @56 */
 unsigned CONFIG15; /* @60 */
 unsigned CONFIG16; /* @64 */
 unsigned CONFIG17; /* @68 */
 unsigned fill0;
 unsigned CONFIG19; /* @76 */
 unsigned CONFIG20; /* @80 */
 unsigned CONFIG21; /* @84 */
 unsigned CONFIG22; /* @88 */
 unsigned CONFIG23; /* @92 */
 unsigned fill1;
 unsigned fill2;
 unsigned fill3;
 unsigned fill4;
 unsigned fill5;
 unsigned fill6;
 unsigned fill7;
 unsigned fill8;
 unsigned PPU_EN; /* @128 */
 unsigned PPD_EN; /* @132 */
 unsigned DRIVE; /* @136 */
} BF_IOCONF_REGS;

//#define BF_IOCONF_IO ((volatile struct s_BF_IOCONF_IO *) 0x40000600)


/* Register values */

/* - CONFIG0 */
#define	BF_IOCONF_IOCONFIG0		        (0x0)
#define	BF_IOCONF_IOCONFIG0InitialValue	(0x2200000)
#define	BF_IOCONF_IOCONFIG0AccessType	(RW)
#define	BF_IOCONF_IOCONFIG0TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG0Mask		    (0xffffffff)

/* - CONFIG1 */
#define	BF_IOCONF_IOCONFIG1		        (0x4)
#define	BF_IOCONF_IOCONFIG1InitialValue	(0x22222022)
#define	BF_IOCONF_IOCONFIG1AccessType	(RW)
#define	BF_IOCONF_IOCONFIG1TestMask	    (0xeeeee0ee)
#define	BF_IOCONF_IOCONFIG1Mask		    (0xffffffff)

/* - CONFIG2 */
#define	BF_IOCONF_IOCONFIG2		        (0x8)
#define	BF_IOCONF_IOCONFIG2InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG2AccessType	(RW)
#define	BF_IOCONF_IOCONFIG2TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG2Mask		    (0xffffffff)

/* - CONFIG3 */
#define	BF_IOCONF_IOCONFIG3		        (0xc)
#define	BF_IOCONF_IOCONFIG3InitialValue	(0x2222)
#define	BF_IOCONF_IOCONFIG3AccessType	(RW)
#define	BF_IOCONF_IOCONFIG3TestMask 	(0xeeee)
#define	BF_IOCONF_IOCONFIG3Mask		    (0xffffffff)

/* - CONFIG4 */
#define	BF_IOCONF_IOCONFIG4		        (0x10)
#define	BF_IOCONF_IOCONFIG4InitialValue	(0x22222200)
#define	BF_IOCONF_IOCONFIG4AccessType	(RW)
#define	BF_IOCONF_IOCONFIG4TestMask	    (0xeeeeee00)
#define	BF_IOCONF_IOCONFIG4Mask		    (0xffffffff)

/* - CONFIG5 */
#define	BF_IOCONF_IOCONFIG5		        (0x14)
#define	BF_IOCONF_IOCONFIG5InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG5AccessType	(RW)
#define	BF_IOCONF_IOCONFIG5TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG5Mask		    (0xffffffff)

/* - CONFIG6 */
#define	BF_IOCONF_IOCONFIG6		        (0x18)
#define	BF_IOCONF_IOCONFIG6InitialValue	(0x22202222)
#define	BF_IOCONF_IOCONFIG6AccessType	(RW)
#define	BF_IOCONF_IOCONFIG6TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG6Mask		    (0xffffffff)

/* - CONFIG7 */
#define	BF_IOCONF_IOCONFIG7		        (0x1c)
#define	BF_IOCONF_IOCONFIG7InitialValue	(0x22022220)
#define	BF_IOCONF_IOCONFIG7AccessType	(RW)
#define	BF_IOCONF_IOCONFIG7TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG7Mask		    (0xffffffff)

/* - CONFIG8 */
#define	BF_IOCONF_IOCONFIG8		        (0x20)
#define	BF_IOCONF_IOCONFIG8InitialValue	(0x22220202)
#define	BF_IOCONF_IOCONFIG8AccessType	(RW)
#define	BF_IOCONF_IOCONFIG8TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG8Mask		    (0xffffffff)

/* - CONFIG9 */
#define	BF_IOCONF_IOCONFIG9		        (0x24)
#define	BF_IOCONF_IOCONFIG9InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG9AccessType	(RW)
#define	BF_IOCONF_IOCONFIG9TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG9Mask		    (0xffffffff)

/* - CONFIG10 */
#define	BF_IOCONF_IOCONFIG10		        (0x28)
#define	BF_IOCONF_IOCONFIG10InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG10AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG10TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG10Mask		    (0xffffffff)

/* - CONFIG11 */
#define	BF_IOCONF_IOCONFIG11		        (0x2c)
#define	BF_IOCONF_IOCONFIG11InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG11AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG11TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG11Mask		    (0xffffffff)

/* - CONFIG12 */
#define	BF_IOCONF_IOCONFIG12		        (0x30)
#define	BF_IOCONF_IOCONFIG12InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG12AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG12TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG12Mask		    (0xffffffff)

/* - CONFIG13 */                     
#define	BF_IOCONF_IOCONFIG13		        (0x34)
#define	BF_IOCONF_IOCONFIG13InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG13AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG13TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG13Mask		    (0xffffffff)

/* - CONFIG14 */
#define	BF_IOCONF_IOCONFIG14		        (0x38)
#define	BF_IOCONF_IOCONFIG14InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG14AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG14TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG14Mask		    (0xffffffff)

/* - CONFIG15 */
#define	BF_IOCONF_IOCONFIG15		        (0x3c)
#define	BF_IOCONF_IOCONFIG15InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG15AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG15TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG15Mask		    (0xffffffff)
                                         
/* - CONFIG16 */
#define	BF_IOCONF_IOCONFIG16		        (0x40)
#define	BF_IOCONF_IOCONFIG16InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG16AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG16TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG16Mask		    (0xffffffff)

/* - CONFIG17 */
#define	BF_IOCONF_IOCONFIG17		        (0x44)
#define	BF_IOCONF_IOCONFIG17InitialValue	(0x22222)
#define	BF_IOCONF_IOCONFIG17AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG17TestMask	    (0xeeeeee)
#define	BF_IOCONF_IOCONFIG17Mask		    (0xffffffff)

/* - CONFIG19 */
#define	BF_IOCONF_IOCONFIG19		        (0x4c)
#define	BF_IOCONF_IOCONFIG19InitialValue	(0x22222200)
#define	BF_IOCONF_IOCONFIG19AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG19TestMask	    (0xeeeeee00)
#define	BF_IOCONF_IOCONFIG19Mask		    (0xffffffff)

/* - CONFIG20 */
#define	BF_IOCONF_IOCONFIG20		        (0x50)
#define	BF_IOCONF_IOCONFIG20InitialValue	(0x22222220)
#define	BF_IOCONF_IOCONFIG20AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG20TestMask	    (0xeeeeeee0)
#define	BF_IOCONF_IOCONFIG20Mask		    (0xffffffff)

/* - CONFIG21 */
#define	BF_IOCONF_IOCONFIG21		        (0x54)
#define	BF_IOCONF_IOCONFIG21InitialValue	(0x22222222)
#define	BF_IOCONF_IOCONFIG21AccessType	    (RW)
#define	BF_IOCONF_IOCONFIG21TestMask	    (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG21Mask		    (0xffffffff)

/* - CONFIG22 */
#define	BF_IOCONF_IOCONFIG22		     (0x58)
#define	BF_IOCONF_IOCONFIG22InitialValue (0x22222222)
#define	BF_IOCONF_IOCONFIG22AccessType	 (RW)
#define	BF_IOCONF_IOCONFIG22TestMask	 (0xeeeee)
#define	BF_IOCONF_IOCONFIG22Mask		 (0xffffffff)

/* - CONFIG23 */
#define	BF_IOCONF_IOCONFIG23		     (0x5c)
#define	BF_IOCONF_IOCONFIG23InitialValue (0x222)
#define	BF_IOCONF_IOCONFIG23AccessType	 (RW)
#define	BF_IOCONF_IOCONFIG23TestMask	 (0xeeeeeeee)
#define	BF_IOCONF_IOCONFIG23Mask		 (0xffffffff)

/* - PPU_EN */
#define	BF_IOCONF_IOPPU_EN			    (0x60)
#define	BF_IOCONF_IOPPU_ENInitialValue	(0x0)
#define	BF_IOCONF_IOPPU_ENAccessType	(RW)
#define	BF_IOCONF_IOPPU_ENTestMask		(0x3000000)
#define	BF_IOCONF_IOPPU_ENMask		    (0xffffffff)

/* - PPD_EN */
#define	BF_IOCONF_IOPPD_EN			    (0x84)
#define	BF_IOCONF_IOPPD_ENInitialValue	(0x0)
#define	BF_IOCONF_IOPPD_ENAccessType	(RW)
#define	BF_IOCONF_IOPPD_ENTestMask		(0x3f)
#define	BF_IOCONF_IOPPD_ENMask		    (0xffffffff)

/* - DRIVE */
#define	BF_IOCONF_IODRIVE			    (0x88)
#define	BF_IOCONF_IODRIVEInitialValue	(0x0)
#define	BF_IOCONF_IODRIVEAccessType	    (RW)
#define	BF_IOCONF_IODRIVETestMask		(0x3)
#define	BF_IOCONF_IODRIVEMask		    (0xffffffff)

/* Instance values */
#define	BF_IOCONF_REG_IOCONFIG0		    (0x40000600)
#define	BF_IOCONF_REG_IOCONFIG1		    (0x40000604)
#define	BF_IOCONF_REG_IOCONFIG2		    (0x40000608)
#define	BF_IOCONF_REG_IOCONFIG3		    (0x4000060c)
#define	BF_IOCONF_REG_IOCONFIG4		    (0x40000610)
#define	BF_IOCONF_REG_IOCONFIG5		    (0x40000614)
#define	BF_IOCONF_REG_IOCONFIG6		    (0x40000618)
#define	BF_IOCONF_REG_IOCONFIG7		    (0x4000061c)
#define	BF_IOCONF_REG_IOCONFIG8		    (0x40000620)
#define	BF_IOCONF_REG_IOCONFIG9		    (0x40000624)
#define	BF_IOCONF_REG_IOCONFIG10		(0x40000628)
#define	BF_IOCONF_REG_IOCONFIG11		(0x4000062c)
#define	BF_IOCONF_REG_IOCONFIG12		(0x40000630)
#define	BF_IOCONF_REG_IOCONFIG13		(0x40000634)
#define	BF_IOCONF_REG_IOCONFIG14		(0x40000638)
#define	BF_IOCONF_REG_IOCONFIG15		(0x4000063c)
#define	BF_IOCONF_REG_IOCONFIG16		(0x40000640)
#define	BF_IOCONF_REG_IOCONFIG17		(0x40000644)
#define	BF_IOCONF_REG_IOCONFIG19		(0x4000064c)
#define	BF_IOCONF_REG_IOCONFIG20		(0x40000650)
#define	BF_IOCONF_REG_IOCONFIG21		(0x40000654)
#define	BF_IOCONF_REG_IOCONFIG22		(0x40000658)
#define	BF_IOCONF_REG_IOCONFIG23		(0x4000065c)
#define	BF_IOCONF_REG_IOPPU_EN		    (0x40000680)
#define	BF_IOCONF_REG_IOPPD_EN		    (0x40000684)
#define	BF_IOCONF_REG_IODRIVE		    (0x40000688)

#endif /* !defined(BF_IOCONF_H) */
