/* ###########################################################################
# (c) Copyright GlobespanVirata Limited 2003
#
# GlobespanVirata Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential
# and is proprietary to GlobespanVirata Limited ("GlobespanVirata").  It may
# only be read, used, copied, adapted, modified or otherwise dealt with by
# you if you have entered into a confidentiality agreement with Virata and
# then subject to the terms of that confidentiality agreement and any other
# applicable agreement between you and GlobespanVirata  If you are in any
# doubt as to whether you are entitled to access, read, use, copy, adapt,
# modify or otherwise deal with the Software or whether you are entitled to
# disclose the Software to any other person you should contact GlobespanVirata.
# If you have not entered into a confidentiality agreement with GlobespanVirata
# granting access to this Software you should forthwith return all media,
# copies and printed listings containing the Software to GlobespanVirata.
#
# GlobespanVirata reserves the right to take legal action against you should
# you breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@globespanvirata.com
# ##########################################################################*/

/****************************************************************************
*  bf_gpio.h                        Last Modified   -   BJK   -   23/06/04  *
*****************************************************************************/

/****************************************************************************/
/*                                                                          */
/* bf_gpio.h                                                                */
/*                                                                          */
/* Bandit Family GPIO Hardware Definitions                                  */
/*                                                                          */
/****************************************************************************/

#ifndef BF_GPIO_H
#define BF_GPIO_H

#define GALLUS_WLC
/* C structure mapping onto the GPIO interface registers */
#define U32 unsigned long int

typedef volatile struct {
    unsigned CONTROL1;     /* 0x00 GPIO control register 1         */
    unsigned CONTROL2;     /* 0x04 GPIO control register 2         */
    unsigned CONTROL3;     /* 0x08 GPIO control register 3         */
    unsigned CONTROL4;     /* 0x0c GPIO control register 4         */
    unsigned CONTROL5;     /* 0x10 GPIO control register 5         */
    unsigned CONTROL6;     /* 0x14 GPIO control register 6         */
    unsigned CONTROL7;     /* 0x18 GPIO control register 7         */
    unsigned CONTROL8;     /* 0x1c GPIO control register 8         */

    unsigned _reserved_20; /* 0x20 reserved */
    unsigned _reserved_24; /* 0x24 reserved */
    unsigned _reserved_28; /* 0x28 reserved */
    unsigned _reserved_2c; /* 0x2c reserved */
    unsigned _reserved_30; /* 0x30 reserved */
    unsigned _reserved_34; /* 0x34 reserved */
    unsigned _reserved_38; /* 0x38 reserved */
    unsigned _reserved_3c; /* 0x3c reserved */

    unsigned OUTPUT1;      /* 0x40 GPIO output register 1          */
    unsigned OUTPUT2;      /* 0x44 GPIO output register 2          */

    unsigned INPUT1;       /* 0x48 GPIO input register 1           */
    unsigned INPUT2;       /* 0x4c GPIO input register 2           */

    unsigned SET1;         /* 0x50 GPIO set register 1             */
    unsigned SET2;         /* 0x54 GPIO set register 2             */

    unsigned CLEAR1;       /* 0x58 GPIO clear register 1           */
    unsigned CLEAR2;       /* 0x5c GPIO clear register 2           */
    
    unsigned _reserved_60; /* 0x60 reserved */
    unsigned _reserved_64; /* 0x60 reserved */
    unsigned _reserved_68; /* 0x60 reserved */
    unsigned _reserved_6c; /* 0x60 reserved */
    unsigned _reserved_70; /* 0x60 reserved */
    unsigned _reserved_74; /* 0x60 reserved */
    unsigned _reserved_78; /* 0x60 reserved */
    unsigned _reserved_7c; /* 0x60 reserved */
    unsigned _reserved_80; /* 0x60 reserved */
    unsigned _reserved_84; /* 0x60 reserved */
    unsigned _reserved_88; /* 0x60 reserved */
    unsigned _reserved_8c; /* 0x60 reserved */
    unsigned _reserved_90; /* 0x60 reserved */
    unsigned _reserved_94; /* 0x60 reserved */
    unsigned _reserved_98; /* 0x60 reserved */
    unsigned _reserved_9c; /* 0x60 reserved */
    unsigned _reserved_a0; /* 0x60 reserved */
    unsigned _reserved_a4; /* 0x60 reserved */
    unsigned _reserved_a8; /* 0x60 reserved */
    unsigned _reserved_ac; /* 0x60 reserved */
    unsigned _reserved_b0; /* 0x60 reserved */
    unsigned _reserved_b4; /* 0x60 reserved */
    unsigned _reserved_b8; /* 0x60 reserved */
    unsigned _reserved_bc; /* 0x60 reserved */
    unsigned _reserved_c0; /* 0x60 reserved */
    unsigned _reserved_c4; /* 0x60 reserved */
    unsigned _reserved_c8; /* 0x60 reserved */
    unsigned _reserved_cc; /* 0x60 reserved */
    unsigned _reserved_d0; /* 0x60 reserved */
    unsigned _reserved_d4; /* 0x60 reserved */
    unsigned _reserved_d8; /* 0x60 reserved */
    unsigned _reserved_dc; /* 0x60 reserved */
    unsigned _reserved_e0; /* 0x60 reserved */
    unsigned _reserved_e4; /* 0x60 reserved */
    unsigned _reserved_e8; /* 0x60 reserved */
    unsigned _reserved_ec; /* 0x60 reserved */
    unsigned _reserved_f0; /* 0x60 reserved */
    unsigned _reserved_f4; /* 0x60 reserved */
    unsigned _reserved_f8; /* 0x60 reserved */
    unsigned _reserved_fc; /* 0x60 reserved */
} BF_GPIO_REGS;


/* Control register configuration values */

#define BF_GPIO_CONTROL_INPUT      (0x1) /* Normal input (default)   */
#define BF_GPIO_CONTROL_INVINPUT   (0x2) /* Inverted input           */
#define BF_GPIO_CONTROL_FUNCTION0  (0x3) /* Special function 0       */
#define BF_GPIO_CONTROL_FUNCTION1  (0x4) /* Special function 1       */
#define BF_GPIO_CONTROL_FUNCTION2  (0x5) /* Special function 2       */
#ifdef GALLUS_WLC
#define BF_GPIO_CONTROL_FUNCTION3  (0x6) /* Special function 2       */
#define BF_GPIO_CONTROL_FUNCTION4  (0x7) /* Special function 2       */
#define BF_GPIO_CONTROL_FUNCTION5  (0x8) /* Special function 2       */
#define BF_GPIO_CONTROL_FUNCTION6  (0x9) /* Special function 2       */
#else
#define BF_GPIO_CONTROL_IRQ0_HIGH  (0x6) /* IRQ[0] when pin is High  */
#define BF_GPIO_CONTROL_IRQ0_LOW   (0x7) /* IRQ[0] when pin is Low   */
#define BF_GPIO_CONTROL_IRQ1_HIGH  (0x8) /* IRQ[1] when pin is High  */
#define BF_GPIO_CONTROL_IRQ1_LOW   (0x9) /* IRQ[1] when pin is Low   */
#define BF_GPIO_CONTROL_IRQ2_HIGH  (0xa) /* IRQ[2] when pin is High  */
#define BF_GPIO_CONTROL_IRQ2_LOW   (0xb) /* IRQ[2] when pin is Low   */
#endif
#define BF_GPIO_CONTROL_OUTPUT     (0xc) /* Normal output            */
#define BF_GPIO_CONTROL_INVOUTPUT  (0xd) /* Inverted output          */
#define BF_GPIO_CONTROL_OPENDRAIN  (0xe) /* Open drain output        */
#define BF_GPIO_CONTROL_OPENSOURCE (0xf) /* Open source output       */
#define BF_GPIO_CONTROL_MASK       (0xf) /* Mask of GPIO config bits */

/* Control register 1 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL1_GPIO0_BIT  (0)   /* Bit pos for GPIO line 0 */
#define BF_GPIO_CONTROL1_GPIO1_BIT  (4)   /* Bit pos for GPIO line 1 */
#define BF_GPIO_CONTROL1_GPIO2_BIT  (8)   /* Bit pos for GPIO line 2 */
#define BF_GPIO_CONTROL1_GPIO3_BIT  (12)  /* Bit pos for GPIO line 3 */
#define BF_GPIO_CONTROL1_GPIO4_BIT  (16)  /* Bit pos for GPIO line 4 */
#define BF_GPIO_CONTROL1_GPIO5_BIT  (20)  /* Bit pos for GPIO line 5 */
#define BF_GPIO_CONTROL1_GPIO6_BIT  (24)  /* Bit pos for GPIO line 6 */
#define BF_GPIO_CONTROL1_GPIO7_BIT  (28)  /* Bit pos for GPIO line 7 */

#define BF_GPIO_CONTROL1_MASK       (0xf) /* Mask to get config bits */

/* Control register 2 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL2_GPIO8_BIT  (0)   /* Bit pos for GPIO line 8 */
#define BF_GPIO_CONTROL2_GPIO9_BIT  (4)   /* Bit pos for GPIO line 9 */
#define BF_GPIO_CONTROL2_GPIO10_BIT (8)   /* Bit pos for GPIO line 10*/
#define BF_GPIO_CONTROL2_GPIO11_BIT (12)  /* Bit pos for GPIO line 11*/
#define BF_GPIO_CONTROL2_GPIO12_BIT (16)  /* Bit pos for GPIO line 12*/
#define BF_GPIO_CONTROL2_GPIO13_BIT (20)  /* Bit pos for GPIO line 13*/
#define BF_GPIO_CONTROL2_GPIO14_BIT (24)  /* Bit pos for GPIO line 14*/
#define BF_GPIO_CONTROL2_GPIO15_BIT (28)  /* Bit pos for GPIO line 15*/

#define BF_GPIO_CONTROL2_MASK       (0xf) /* Mask to get config bits */

/* Control register 3 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL3_GPIO16_BIT (0)   /* Bit pos for GPIO line 16*/
#define BF_GPIO_CONTROL3_GPIO17_BIT (4)   /* Bit pos for GPIO line 17*/
#define BF_GPIO_CONTROL3_GPIO18_BIT (8)   /* Bit pos for GPIO line 18*/
#define BF_GPIO_CONTROL3_GPIO19_BIT (12)  /* Bit pos for GPIO line 19*/
#define BF_GPIO_CONTROL3_GPIO20_BIT (16)  /* Bit pos for GPIO line 20*/
#define BF_GPIO_CONTROL3_GPIO21_BIT (20)  /* Bit pos for GPIO line 21*/
#define BF_GPIO_CONTROL3_GPIO22_BIT (24)  /* Bit pos for GPIO line 22*/
#define BF_GPIO_CONTROL3_GPIO23_BIT (28)  /* Bit pos for GPIO line 23*/

#define BF_GPIO_CONTROL3_MASK       (0xf) /* Mask to get config bits */

/* Control register 4 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL4_GPIO24_BIT (0)   /* Bit pos for GPIO line 24*/
#define BF_GPIO_CONTROL4_GPIO25_BIT (4)   /* Bit pos for GPIO line 25*/
#define BF_GPIO_CONTROL4_GPIO26_BIT (8)   /* Bit pos for GPIO line 26*/
#define BF_GPIO_CONTROL4_GPIO27_BIT (12)  /* Bit pos for GPIO line 27*/
#define BF_GPIO_CONTROL4_GPIO28_BIT (16)  /* Bit pos for GPIO line 28*/
#define BF_GPIO_CONTROL4_GPIO29_BIT (20)  /* Bit pos for GPIO line 29*/
#define BF_GPIO_CONTROL4_GPIO30_BIT (24)  /* Bit pos for GPIO line 30*/
#define BF_GPIO_CONTROL4_GPIO31_BIT (28)  /* Bit pos for GPIO line 31*/

#define BF_GPIO_CONTROL4_MASK       (0xf) /* Mask to get config bits */

/* Control register 5 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL5_GPIO32_BIT (0)   /* Bit pos for GPIO line 32*/
#define BF_GPIO_CONTROL5_GPIO33_BIT (4)   /* Bit pos for GPIO line 33*/
#define BF_GPIO_CONTROL5_GPIO34_BIT (8)   /* Bit pos for GPIO line 34*/
#define BF_GPIO_CONTROL5_GPIO35_BIT (12)  /* Bit pos for GPIO line 35*/
#define BF_GPIO_CONTROL5_GPIO36_BIT (16)  /* Bit pos for GPIO line 36*/
#define BF_GPIO_CONTROL5_GPIO37_BIT (20)  /* Bit pos for GPIO line 37*/
#define BF_GPIO_CONTROL5_GPIO38_BIT (24)  /* Bit pos for GPIO line 38*/
#define BF_GPIO_CONTROL5_GPIO39_BIT (28)  /* Bit pos for GPIO line 39*/

#define BF_GPIO_CONTROL5_MASK       (0xf) /* Mask to get config bits */

/* Control register 6 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL6_GPIO40_BIT (0)   /* Bit pos for GPIO line 40*/
#define BF_GPIO_CONTROL6_GPIO41_BIT (4)   /* Bit pos for GPIO line 41*/
#define BF_GPIO_CONTROL6_GPIO42_BIT (8)   /* Bit pos for GPIO line 42*/
#define BF_GPIO_CONTROL6_GPIO43_BIT (12)  /* Bit pos for GPIO line 43*/
#define BF_GPIO_CONTROL6_GPIO44_BIT (16)  /* Bit pos for GPIO line 44*/
#define BF_GPIO_CONTROL6_GPIO45_BIT (20)  /* Bit pos for GPIO line 45*/
#define BF_GPIO_CONTROL6_GPIO46_BIT (24)  /* Bit pos for GPIO line 46*/
#define BF_GPIO_CONTROL6_GPIO47_BIT (28)  /* Bit pos for GPIO line 47*/

#define BF_GPIO_CONTROL6_MASK       (0xf) /* Mask to get config bits */

/* Control register 7 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL7_GPIO48_BIT (0)   /* Bit pos for GPIO line 48*/
#define BF_GPIO_CONTROL7_GPIO49_BIT (4)   /* Bit pos for GPIO line 49*/
#define BF_GPIO_CONTROL7_GPIO50_BIT (8)   /* Bit pos for GPIO line 50*/
#define BF_GPIO_CONTROL7_GPIO51_BIT (12)  /* Bit pos for GPIO line 51*/
#define BF_GPIO_CONTROL7_GPIO52_BIT (16)  /* Bit pos for GPIO line 52*/
#define BF_GPIO_CONTROL7_GPIO53_BIT (20)  /* Bit pos for GPIO line 53*/
#define BF_GPIO_CONTROL7_GPIO54_BIT (24)  /* Bit pos for GPIO line 54*/
#define BF_GPIO_CONTROL7_GPIO55_BIT (28)  /* Bit pos for GPIO line 55*/

#define BF_GPIO_CONTROL7_MASK       (0xf) /* Mask to get config bits */

/* Control register 8 bit positions - bit numbers, not masks! */

#define BF_GPIO_CONTROL8_GPIO56_BIT (0)   /* Bit pos for GPIO line 56*/
#define BF_GPIO_CONTROL8_GPIO57_BIT (4)   /* Bit pos for GPIO line 57*/
#define BF_GPIO_CONTROL8_GPIO58_BIT (8)   /* Bit pos for GPIO line 58*/
#define BF_GPIO_CONTROL8_GPIO59_BIT (12)  /* Bit pos for GPIO line 59*/
#define BF_GPIO_CONTROL8_GPIO60_BIT (16)  /* Bit pos for GPIO line 60*/
#define BF_GPIO_CONTROL8_GPIO61_BIT (20)  /* Bit pos for GPIO line 61*/
#define BF_GPIO_CONTROL8_GPIO62_BIT (24)  /* Bit pos for GPIO line 62*/
#define BF_GPIO_CONTROL8_GPIO63_BIT (28)  /* Bit pos for GPIO line 63*/

#define BF_GPIO_CONTROL8_MASK       (0xf) /* Mask to get config bits */

/* Bit definitions for output register 1 */

#define BF_GPIO_OUTPUT1_GPIO0  (0x00000001) /* GPIO line 0 output val*/
#define BF_GPIO_OUTPUT1_GPIO1  (0x00000002) /* GPIO line 1 output val*/
#define BF_GPIO_OUTPUT1_GPIO2  (0x00000004) /* GPIO line 2 output val*/
#define BF_GPIO_OUTPUT1_GPIO3  (0x00000008) /* GPIO line 3 output val*/
#define BF_GPIO_OUTPUT1_GPIO4  (0x00000010) /* GPIO line 4 output val*/
#define BF_GPIO_OUTPUT1_GPIO5  (0x00000020) /* GPIO line 5 output val*/
#define BF_GPIO_OUTPUT1_GPIO6  (0x00000040) /* GPIO line 6 output val*/
#define BF_GPIO_OUTPUT1_GPIO7  (0x00000080) /* GPIO line 7 output val*/
#define BF_GPIO_OUTPUT1_GPIO8  (0x00000100) /* GPIO line 8 output val*/
#define BF_GPIO_OUTPUT1_GPIO9  (0x00000200) /* GPIO line 9 output val*/
#define BF_GPIO_OUTPUT1_GPIO10 (0x00000400) /* GPIO line 10 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO11 (0x00000800) /* GPIO line 11 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO12 (0x00001000) /* GPIO line 12 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO13 (0x00002000) /* GPIO line 13 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO14 (0x00004000) /* GPIO line 14 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO15 (0x00008000) /* GPIO line 15 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO16 (0x00010000) /* GPIO line 16 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO17 (0x00020000) /* GPIO line 17 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO18 (0x00040000) /* GPIO line 18 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO19 (0x00080000) /* GPIO line 19 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO20 (0x00100000) /* GPIO line 20 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO21 (0x00200000) /* GPIO line 21 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO22 (0x00400000) /* GPIO line 22 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO23 (0x00800000) /* GPIO line 23 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO24 (0x01000000) /* GPIO line 24 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO25 (0x02000000) /* GPIO line 25 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO26 (0x04000000) /* GPIO line 26 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO27 (0x08000000) /* GPIO line 27 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO28 (0x10000000) /* GPIO line 28 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO29 (0x20000000) /* GPIO line 29 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO30 (0x40000000) /* GPIO line 30 outpt val*/
#define BF_GPIO_OUTPUT1_GPIO31 (0x80000000) /* GPIO line 31 outpt val*/

/* Bit definitions for output register 2 */

#define BF_GPIO_OUTPUT2_GPIO32 (0x00000001) /* GPIO line 32 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO33 (0x00000002) /* GPIO line 33 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO34 (0x00000004) /* GPIO line 34 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO35 (0x00000008) /* GPIO line 35 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO36 (0x00000010) /* GPIO line 36 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO37 (0x00000020) /* GPIO line 37 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO38 (0x00000040) /* GPIO line 38 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO39 (0x00000080) /* GPIO line 39 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO40 (0x00000100) /* GPIO line 40 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO41 (0x00000200) /* GPIO line 41 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO42 (0x00000400) /* GPIO line 42 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO43 (0x00000800) /* GPIO line 43 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO44 (0x00001000) /* GPIO line 44 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO45 (0x00002000) /* GPIO line 45 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO46 (0x00004000) /* GPIO line 46 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO47 (0x00008000) /* GPIO line 47 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO48 (0x00010000) /* GPIO line 48 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO49 (0x00020000) /* GPIO line 49 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO50 (0x00040000) /* GPIO line 50 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO51 (0x00080000) /* GPIO line 51 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO52 (0x00100000) /* GPIO line 52 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO53 (0x00200000) /* GPIO line 53 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO54 (0x00400000) /* GPIO line 54 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO55 (0x00800000) /* GPIO line 55 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO56 (0x01000000) /* GPIO line 56 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO57 (0x02000000) /* GPIO line 57 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO58 (0x04000000) /* GPIO line 58 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO59 (0x08000000) /* GPIO line 59 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO60 (0x10000000) /* GPIO line 60 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO61 (0x20000000) /* GPIO line 61 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO62 (0x40000000) /* GPIO line 62 outpt val*/
#define BF_GPIO_OUTPUT2_GPIO63 (0x80000000) /* GPIO line 63 outpt val*/

/* Bit definitions for input register 1*/

#define BF_GPIO_INPUT1_GPIO0   (0x00000001) /* GPIO line 0 input val */
#define BF_GPIO_INPUT1_GPIO1   (0x00000002) /* GPIO line 1 input val */
#define BF_GPIO_INPUT1_GPIO2   (0x00000004) /* GPIO line 2 input val */
#define BF_GPIO_INPUT1_GPIO3   (0x00000008) /* GPIO line 3 input val */
#define BF_GPIO_INPUT1_GPIO4   (0x00000010) /* GPIO line 4 input val */
#define BF_GPIO_INPUT1_GPIO5   (0x00000020) /* GPIO line 5 input val */
#define BF_GPIO_INPUT1_GPIO6   (0x00000040) /* GPIO line 6 input val */
#define BF_GPIO_INPUT1_GPIO7   (0x00000080) /* GPIO line 7 input val */
#define BF_GPIO_INPUT1_GPIO8   (0x00000100) /* GPIO line 8 input val */
#define BF_GPIO_INPUT1_GPIO9   (0x00000200) /* GPIO line 9 input val */
#define BF_GPIO_INPUT1_GPIO10  (0x00000400) /* GPIO line 10 input val*/
#define BF_GPIO_INPUT1_GPIO11  (0x00000800) /* GPIO line 11 input val*/
#define BF_GPIO_INPUT1_GPIO12  (0x00001000) /* GPIO line 12 input val*/
#define BF_GPIO_INPUT1_GPIO13  (0x00002000) /* GPIO line 13 input val*/
#define BF_GPIO_INPUT1_GPIO14  (0x00004000) /* GPIO line 14 input val*/
#define BF_GPIO_INPUT1_GPIO15  (0x00008000) /* GPIO line 15 input val*/
#define BF_GPIO_INPUT1_GPIO16  (0x00010000) /* GPIO line 16 input val*/
#define BF_GPIO_INPUT1_GPIO17  (0x00020000) /* GPIO line 17 input val*/
#define BF_GPIO_INPUT1_GPIO18  (0x00040000) /* GPIO line 18 input val*/
#define BF_GPIO_INPUT1_GPIO19  (0x00080000) /* GPIO line 19 input val*/
#define BF_GPIO_INPUT1_GPIO20  (0x00100000) /* GPIO line 20 input val*/
#define BF_GPIO_INPUT1_GPIO21  (0x00200000) /* GPIO line 21 input val*/
#define BF_GPIO_INPUT1_GPIO22  (0x00400000) /* GPIO line 22 input val*/
#define BF_GPIO_INPUT1_GPIO23  (0x00800000) /* GPIO line 23 input val*/
#define BF_GPIO_INPUT1_GPIO24  (0x01000000) /* GPIO line 24 input val*/
#define BF_GPIO_INPUT1_GPIO25  (0x02000000) /* GPIO line 25 input val*/
#define BF_GPIO_INPUT1_GPIO26  (0x04000000) /* GPIO line 26 input val*/
#define BF_GPIO_INPUT1_GPIO27  (0x08000000) /* GPIO line 27 input val*/
#define BF_GPIO_INPUT1_GPIO28  (0x10000000) /* GPIO line 28 input val*/
#define BF_GPIO_INPUT1_GPIO29  (0x20000000) /* GPIO line 29 input val*/
#define BF_GPIO_INPUT1_GPIO30  (0x40000000) /* GPIO line 30 input val*/
#define BF_GPIO_INPUT1_GPIO31  (0x80000000) /* GPIO line 31 input val*/ 

/* Bit definitions for input register 2 */

#define BF_GPIO_INPUT2_GPIO32  (0x00000001) /* GPIO line 32 input val*/
#define BF_GPIO_INPUT2_GPIO33  (0x00000002) /* GPIO line 33 input val*/
#define BF_GPIO_INPUT2_GPIO34  (0x00000004) /* GPIO line 34 input val*/
#define BF_GPIO_INPUT2_GPIO35  (0x00000008) /* GPIO line 35 input val*/
#define BF_GPIO_INPUT2_GPIO36  (0x00000010) /* GPIO line 36 input val*/
#define BF_GPIO_INPUT2_GPIO37  (0x00000020) /* GPIO line 37 input val*/
#define BF_GPIO_INPUT2_GPIO38  (0x00000040) /* GPIO line 38 input val*/
#define BF_GPIO_INPUT2_GPIO39  (0x00000080) /* GPIO line 39 input val*/
#define BF_GPIO_INPUT2_GPIO40  (0x00000100) /* GPIO line 40 input val*/
#define BF_GPIO_INPUT2_GPIO41  (0x00000200) /* GPIO line 41 input val*/
#define BF_GPIO_INPUT2_GPIO42  (0x00000400) /* GPIO line 42 input val*/
#define BF_GPIO_INPUT2_GPIO43  (0x00000800) /* GPIO line 43 input val*/
#define BF_GPIO_INPUT2_GPIO44  (0x00001000) /* GPIO line 44 input val*/
#define BF_GPIO_INPUT2_GPIO45  (0x00002000) /* GPIO line 45 input val*/
#define BF_GPIO_INPUT2_GPIO46  (0x00004000) /* GPIO line 46 input val*/
#define BF_GPIO_INPUT2_GPIO47  (0x00008000) /* GPIO line 47 input val*/
#define BF_GPIO_INPUT2_GPIO48  (0x00010000) /* GPIO line 48 input val*/
#define BF_GPIO_INPUT2_GPIO49  (0x00020000) /* GPIO line 49 input val*/
#define BF_GPIO_INPUT2_GPIO50  (0x00040000) /* GPIO line 50 input val*/
#define BF_GPIO_INPUT2_GPIO51  (0x00080000) /* GPIO line 51 input val*/
#define BF_GPIO_INPUT2_GPIO52  (0x00100000) /* GPIO line 52 input val*/
#define BF_GPIO_INPUT2_GPIO53  (0x00200000) /* GPIO line 53 input val*/
#define BF_GPIO_INPUT2_GPIO54  (0x00400000) /* GPIO line 54 input val*/
#define BF_GPIO_INPUT2_GPIO55  (0x00800000) /* GPIO line 55 input val*/
#define BF_GPIO_INPUT2_GPIO56  (0x01000000) /* GPIO line 56 input val*/
#define BF_GPIO_INPUT2_GPIO57  (0x02000000) /* GPIO line 57 input val*/
#define BF_GPIO_INPUT2_GPIO58  (0x04000000) /* GPIO line 58 input val*/
#define BF_GPIO_INPUT2_GPIO59  (0x08000000) /* GPIO line 59 input val*/
#define BF_GPIO_INPUT2_GPIO60  (0x10000000) /* GPIO line 60 input val*/
#define BF_GPIO_INPUT2_GPIO61  (0x20000000) /* GPIO line 61 input val*/
#define BF_GPIO_INPUT2_GPIO62  (0x40000000) /* GPIO line 62 input val*/
#define BF_GPIO_INPUT2_GPIO63  (0x80000000) /* GPIO line 63 input val*/ 

/* Bit definitions for set register 1*/

#define BF_GPIO_SET1_GPIO0   (0x00000001) /* GPIO line 0 set value   */
#define BF_GPIO_SET1_GPIO1   (0x00000002) /* GPIO line 1 set value   */
#define BF_GPIO_SET1_GPIO2   (0x00000004) /* GPIO line 2 set value   */
#define BF_GPIO_SET1_GPIO3   (0x00000008) /* GPIO line 3 set value   */
#define BF_GPIO_SET1_GPIO4   (0x00000010) /* GPIO line 4 set value   */
#define BF_GPIO_SET1_GPIO5   (0x00000020) /* GPIO line 5 set value   */
#define BF_GPIO_SET1_GPIO6   (0x00000040) /* GPIO line 6 set value   */
#define BF_GPIO_SET1_GPIO7   (0x00000080) /* GPIO line 7 set value   */
#define BF_GPIO_SET1_GPIO8   (0x00000100) /* GPIO line 8 set value   */
#define BF_GPIO_SET1_GPIO9   (0x00000200) /* GPIO line 9 set value   */
#define BF_GPIO_SET1_GPIO10  (0x00000400) /* GPIO line 10 set value  */
#define BF_GPIO_SET1_GPIO11  (0x00000800) /* GPIO line 11 set value  */
#define BF_GPIO_SET1_GPIO12  (0x00001000) /* GPIO line 12 set value  */
#define BF_GPIO_SET1_GPIO13  (0x00002000) /* GPIO line 13 set value  */
#define BF_GPIO_SET1_GPIO14  (0x00004000) /* GPIO line 14 set value  */
#define BF_GPIO_SET1_GPIO15  (0x00008000) /* GPIO line 15 set value  */
#define BF_GPIO_SET1_GPIO16  (0x00010000) /* GPIO line 16 set value  */
#define BF_GPIO_SET1_GPIO17  (0x00020000) /* GPIO line 17 set value  */
#define BF_GPIO_SET1_GPIO18  (0x00040000) /* GPIO line 18 set value  */
#define BF_GPIO_SET1_GPIO19  (0x00080000) /* GPIO line 19 set value  */
#define BF_GPIO_SET1_GPIO20  (0x00100000) /* GPIO line 20 set value  */
#define BF_GPIO_SET1_GPIO21  (0x00200000) /* GPIO line 21 set value  */
#define BF_GPIO_SET1_GPIO22  (0x00400000) /* GPIO line 22 set value  */
#define BF_GPIO_SET1_GPIO23  (0x00800000) /* GPIO line 23 set value  */
#define BF_GPIO_SET1_GPIO24  (0x01000000) /* GPIO line 24 set value  */
#define BF_GPIO_SET1_GPIO25  (0x02000000) /* GPIO line 25 set value  */
#define BF_GPIO_SET1_GPIO26  (0x04000000) /* GPIO line 26 set value  */
#define BF_GPIO_SET1_GPIO27  (0x08000000) /* GPIO line 27 set value  */
#define BF_GPIO_SET1_GPIO28  (0x10000000) /* GPIO line 28 set value  */
#define BF_GPIO_SET1_GPIO29  (0x20000000) /* GPIO line 29 set value  */
#define BF_GPIO_SET1_GPIO30  (0x40000000) /* GPIO line 30 set value  */
#define BF_GPIO_SET1_GPIO31  (0x80000000) /* GPIO line 31 set value  */ 

/* Bit definitions for set register 2 */

#define BF_GPIO_SET2_GPIO32  (0x00000001) /* GPIO line 32 set value  */
#define BF_GPIO_SET2_GPIO33  (0x00000002) /* GPIO line 33 set value  */
#define BF_GPIO_SET2_GPIO34  (0x00000004) /* GPIO line 34 set value  */
#define BF_GPIO_SET2_GPIO35  (0x00000008) /* GPIO line 35 set value  */
#define BF_GPIO_SET2_GPIO36  (0x00000010) /* GPIO line 36 set value  */
#define BF_GPIO_SET2_GPIO37  (0x00000020) /* GPIO line 37 set value  */
#define BF_GPIO_SET2_GPIO38  (0x00000040) /* GPIO line 38 set value  */
#define BF_GPIO_SET2_GPIO39  (0x00000080) /* GPIO line 39 set value  */
#define BF_GPIO_SET2_GPIO40  (0x00000100) /* GPIO line 40 set value  */
#define BF_GPIO_SET2_GPIO41  (0x00000200) /* GPIO line 41 set value  */
#define BF_GPIO_SET2_GPIO42  (0x00000400) /* GPIO line 42 set value  */
#define BF_GPIO_SET2_GPIO43  (0x00000800) /* GPIO line 43 set value  */
#define BF_GPIO_SET2_GPIO44  (0x00001000) /* GPIO line 44 set value  */
#define BF_GPIO_SET2_GPIO45  (0x00002000) /* GPIO line 45 set value  */
#define BF_GPIO_SET2_GPIO46  (0x00004000) /* GPIO line 46 set value  */
#define BF_GPIO_SET2_GPIO47  (0x00008000) /* GPIO line 47 set value  */
#define BF_GPIO_SET2_GPIO48  (0x00010000) /* GPIO line 48 set value  */
#define BF_GPIO_SET2_GPIO49  (0x00020000) /* GPIO line 49 set value  */
#define BF_GPIO_SET2_GPIO50  (0x00040000) /* GPIO line 50 set value  */
#define BF_GPIO_SET2_GPIO51  (0x00080000) /* GPIO line 51 set value  */
#define BF_GPIO_SET2_GPIO52  (0x00100000) /* GPIO line 52 set value  */
#define BF_GPIO_SET2_GPIO53  (0x00200000) /* GPIO line 53 set value  */
#define BF_GPIO_SET2_GPIO54  (0x00400000) /* GPIO line 54 set value  */
#define BF_GPIO_SET2_GPIO55  (0x00800000) /* GPIO line 55 set value  */
#define BF_GPIO_SET2_GPIO56  (0x01000000) /* GPIO line 56 set value  */
#define BF_GPIO_SET2_GPIO57  (0x02000000) /* GPIO line 57 set value  */
#define BF_GPIO_SET2_GPIO58  (0x04000000) /* GPIO line 58 set value  */
#define BF_GPIO_SET2_GPIO59  (0x08000000) /* GPIO line 59 set value  */
#define BF_GPIO_SET2_GPIO60  (0x10000000) /* GPIO line 60 set value  */
#define BF_GPIO_SET2_GPIO61  (0x20000000) /* GPIO line 61 set value  */
#define BF_GPIO_SET2_GPIO62  (0x40000000) /* GPIO line 62 set value  */
#define BF_GPIO_SET2_GPIO63  (0x80000000) /* GPIO line 63 set value  */ 

/* Bit definitions for clear register 1*/

#define BF_GPIO_CLEAR1_GPIO0   (0x00000001) /* GPIO line 0 clear val */
#define BF_GPIO_CLEAR1_GPIO1   (0x00000002) /* GPIO line 1 clear val */
#define BF_GPIO_CLEAR1_GPIO2   (0x00000004) /* GPIO line 2 clear val */
#define BF_GPIO_CLEAR1_GPIO3   (0x00000008) /* GPIO line 3 clear val */
#define BF_GPIO_CLEAR1_GPIO4   (0x00000010) /* GPIO line 4 clear val */
#define BF_GPIO_CLEAR1_GPIO5   (0x00000020) /* GPIO line 5 clear val */
#define BF_GPIO_CLEAR1_GPIO6   (0x00000040) /* GPIO line 6 clear val */
#define BF_GPIO_CLEAR1_GPIO7   (0x00000080) /* GPIO line 7 clear val */
#define BF_GPIO_CLEAR1_GPIO8   (0x00000100) /* GPIO line 8 clear val */
#define BF_GPIO_CLEAR1_GPIO9   (0x00000200) /* GPIO line 9 clear val */
#define BF_GPIO_CLEAR1_GPIO10  (0x00000400) /* GPIO line 10 clear val*/
#define BF_GPIO_CLEAR1_GPIO11  (0x00000800) /* GPIO line 11 clear val*/
#define BF_GPIO_CLEAR1_GPIO12  (0x00001000) /* GPIO line 12 clear val*/
#define BF_GPIO_CLEAR1_GPIO13  (0x00002000) /* GPIO line 13 clear val*/
#define BF_GPIO_CLEAR1_GPIO14  (0x00004000) /* GPIO line 14 clear val*/
#define BF_GPIO_CLEAR1_GPIO15  (0x00008000) /* GPIO line 15 clear val*/
#define BF_GPIO_CLEAR1_GPIO16  (0x00010000) /* GPIO line 16 clear val*/
#define BF_GPIO_CLEAR1_GPIO17  (0x00020000) /* GPIO line 17 clear val*/
#define BF_GPIO_CLEAR1_GPIO18  (0x00040000) /* GPIO line 18 clear val*/
#define BF_GPIO_CLEAR1_GPIO19  (0x00080000) /* GPIO line 19 clear val*/
#define BF_GPIO_CLEAR1_GPIO20  (0x00100000) /* GPIO line 20 clear val*/
#define BF_GPIO_CLEAR1_GPIO21  (0x00200000) /* GPIO line 21 clear val*/
#define BF_GPIO_CLEAR1_GPIO22  (0x00400000) /* GPIO line 22 clear val*/
#define BF_GPIO_CLEAR1_GPIO23  (0x00800000) /* GPIO line 23 clear val*/
#define BF_GPIO_CLEAR1_GPIO24  (0x01000000) /* GPIO line 24 clear val*/
#define BF_GPIO_CLEAR1_GPIO25  (0x02000000) /* GPIO line 25 clear val*/
#define BF_GPIO_CLEAR1_GPIO26  (0x04000000) /* GPIO line 26 clear val*/
#define BF_GPIO_CLEAR1_GPIO27  (0x08000000) /* GPIO line 27 clear val*/
#define BF_GPIO_CLEAR1_GPIO28  (0x10000000) /* GPIO line 28 clear val*/
#define BF_GPIO_CLEAR1_GPIO29  (0x20000000) /* GPIO line 29 clear val*/
#define BF_GPIO_CLEAR1_GPIO30  (0x40000000) /* GPIO line 30 clear val*/
#define BF_GPIO_CLEAR1_GPIO31  (0x80000000) /* GPIO line 31 clear val*/ 

/* Bit definitions for clear register 2 */

#define BF_GPIO_CLEAR2_GPIO32  (0x00000001) /* GPIO line 32 clear val*/
#define BF_GPIO_CLEAR2_GPIO33  (0x00000002) /* GPIO line 33 clear val*/
#define BF_GPIO_CLEAR2_GPIO34  (0x00000004) /* GPIO line 34 clear val*/
#define BF_GPIO_CLEAR2_GPIO35  (0x00000008) /* GPIO line 35 clear val*/
#define BF_GPIO_CLEAR2_GPIO36  (0x00000010) /* GPIO line 36 clear val*/
#define BF_GPIO_CLEAR2_GPIO37  (0x00000020) /* GPIO line 37 clear val*/
#define BF_GPIO_CLEAR2_GPIO38  (0x00000040) /* GPIO line 38 clear val*/
#define BF_GPIO_CLEAR2_GPIO39  (0x00000080) /* GPIO line 39 clear val*/
#define BF_GPIO_CLEAR2_GPIO40  (0x00000100) /* GPIO line 40 clear val*/
#define BF_GPIO_CLEAR2_GPIO41  (0x00000200) /* GPIO line 41 clear val*/
#define BF_GPIO_CLEAR2_GPIO42  (0x00000400) /* GPIO line 42 clear val*/
#define BF_GPIO_CLEAR2_GPIO43  (0x00000800) /* GPIO line 43 clear val*/
#define BF_GPIO_CLEAR2_GPIO44  (0x00001000) /* GPIO line 44 clear val*/
#define BF_GPIO_CLEAR2_GPIO45  (0x00002000) /* GPIO line 45 clear val*/
#define BF_GPIO_CLEAR2_GPIO46  (0x00004000) /* GPIO line 46 clear val*/
#define BF_GPIO_CLEAR2_GPIO47  (0x00008000) /* GPIO line 47 clear val*/
#define BF_GPIO_CLEAR2_GPIO48  (0x00010000) /* GPIO line 48 clear val*/
#define BF_GPIO_CLEAR2_GPIO49  (0x00020000) /* GPIO line 49 clear val*/
#define BF_GPIO_CLEAR2_GPIO50  (0x00040000) /* GPIO line 50 clear val*/
#define BF_GPIO_CLEAR2_GPIO51  (0x00080000) /* GPIO line 51 clear val*/
#define BF_GPIO_CLEAR2_GPIO52  (0x00100000) /* GPIO line 52 clear val*/
#define BF_GPIO_CLEAR2_GPIO53  (0x00200000) /* GPIO line 53 clear val*/
#define BF_GPIO_CLEAR2_GPIO54  (0x00400000) /* GPIO line 54 clear val*/
#define BF_GPIO_CLEAR2_GPIO55  (0x00800000) /* GPIO line 55 clear val*/
#define BF_GPIO_CLEAR2_GPIO56  (0x01000000) /* GPIO line 56 clear val*/
#define BF_GPIO_CLEAR2_GPIO57  (0x02000000) /* GPIO line 57 clear val*/
#define BF_GPIO_CLEAR2_GPIO58  (0x04000000) /* GPIO line 58 clear val*/
#define BF_GPIO_CLEAR2_GPIO59  (0x08000000) /* GPIO line 59 clear val*/
#define BF_GPIO_CLEAR2_GPIO60  (0x10000000) /* GPIO line 60 clear val*/
#define BF_GPIO_CLEAR2_GPIO61  (0x20000000) /* GPIO line 61 clear val*/
#define BF_GPIO_CLEAR2_GPIO62  (0x40000000) /* GPIO line 62 clear val*/
#define BF_GPIO_CLEAR2_GPIO63  (0x80000000) /* GPIO line 63 clear val*/ 



/* ------ OBSOLETE DEFINITIONS BELOW THIS POINT WILL BE REMOVED WHEN ------- */
/* --------- THE TRANSITION TO C STRUCTURE DEFINITIONS IS COMPLETE --------- */

#define BF_PERIPH_GPIO          (0x0200) /* Base address of GPIO block      */

/* Register offsets from CHM_MAP_LOWER */

#define BF_PERIPH_GPIO_CONTROL1 (0x0100) /* GPIO control register 1         */
#define BF_PERIPH_GPIO_CONTROL2 (0x0104) /* GPIO control register 2         */
#define BF_PERIPH_GPIO_CONTROL3 (0x0108) /* GPIO control register 3         */
#define BF_PERIPH_GPIO_CONTROL4 (0x010c) /* GPIO control register 4         */
#define BF_PERIPH_GPIO_CONTROL5 (0x0110) /* GPIO control register 5         */
#define BF_PERIPH_GPIO_CONTROL6 (0x0114) /* GPIO control register 6         */
#define BF_PERIPH_GPIO_CONTROL7 (0x0118) /* GPIO control register 7         */
#define BF_PERIPH_GPIO_CONTROL8 (0x011c) /* GPIO control register 8         */

#define BF_PERIPH_GPIO_OUTPUT1  (0x0140) /* GPIO output register 1          */
#define BF_PERIPH_GPIO_OUTPUT2  (0x0144) /* GPIO output register 2          */

#define BF_PERIPH_GPIO_INPUT1   (0x0148) /* GPIO input register 1           */
#define BF_PERIPH_GPIO_INPUT2   (0x014c) /* GPIO input register 2           */

#define BF_PERIPH_GPIO_SET1     (0x0150) /* GPIO set register 1             */
#define BF_PERIPH_GPIO_SET2     (0x0154) /* GPIO set register 2             */

#define BF_PERIPH_GPIO_CLEAR1   (0x0158) /* GPIO clear register 1           */
#define BF_PERIPH_GPIO_CLEAR2   (0x015c) /* GPIO clear register 2           */


/* The INFO registers DO NOT EXIST anymore and will read as zero */
/* Definitions retained only for compatability */

#define BF_PERIPH_GPIO_INFO1    (0x0120) /* GPIO information register 1     */
#define BF_PERIPH_GPIO_INFO2    (0x0124) /* GPIO information register 2     */
#define BF_PERIPH_GPIO_INFO3    (0x0128) /* GPIO information register 3     */
#define BF_PERIPH_GPIO_INFO4    (0x012c) /* GPIO information register 4     */
#define BF_PERIPH_GPIO_INFO5    (0x0130) /* GPIO information register 5     */
#define BF_PERIPH_GPIO_INFO6    (0x0134) /* GPIO information register 6     */
#define BF_PERIPH_GPIO_INFO7    (0x0138) /* GPIO information register 7     */
#define BF_PERIPH_GPIO_INFO8    (0x013c) /* GPIO information register 8     */


/* Control register configuration values */

#define BF_PERIPH_GPIO_CONTROL_INPUT      (0x1) /* Normal input (default)   */
#define BF_PERIPH_GPIO_CONTROL_INVINPUT   (0x2) /* Inverted input           */
#define BF_PERIPH_GPIO_CONTROL_FUNCTION0  (0x3) /* Special function 0       */
#define BF_PERIPH_GPIO_CONTROL_FUNCTION1  (0x4) /* Special function 1       */
#define BF_PERIPH_GPIO_CONTROL_FUNCTION2  (0x5) /* Special function 2       */
#define BF_PERIPH_GPIO_CONTROL_IRQ0_HIGH  (0x6) /* IRQ[0] when pin is High  */
#define BF_PERIPH_GPIO_CONTROL_IRQ0_LOW   (0x7) /* IRQ[0] when pin is Low   */
#define BF_PERIPH_GPIO_CONTROL_IRQ1_HIGH  (0x8) /* IRQ[1] when pin is High  */
#define BF_PERIPH_GPIO_CONTROL_IRQ1_LOW   (0x9) /* IRQ[1] when pin is Low   */
#define BF_PERIPH_GPIO_CONTROL_IRQ2_HIGH  (0xa) /* IRQ[2] when pin is High  */
#define BF_PERIPH_GPIO_CONTROL_IRQ2_LOW   (0xb) /* IRQ[2] when pin is Low   */
#define BF_PERIPH_GPIO_CONTROL_OUTPUT     (0xc) /* Normal output            */
#define BF_PERIPH_GPIO_CONTROL_INVOUTPUT  (0xd) /* Inverted output          */
#define BF_PERIPH_GPIO_CONTROL_OPENDRAIN  (0xe) /* Open drain output        */
#define BF_PERIPH_GPIO_CONTROL_OPENSOURCE (0xf) /* Open source output       */
#define BF_PERIPH_GPIO_CONTROL_MASK       (0xf) /* Mask of GPIO config bits */

/* Control register 1 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL1_GPIO0_BIT  (0)   /* Bit pos for GPIO line 0 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO1_BIT  (4)   /* Bit pos for GPIO line 1 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO2_BIT  (8)   /* Bit pos for GPIO line 2 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO3_BIT  (12)  /* Bit pos for GPIO line 3 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO4_BIT  (16)  /* Bit pos for GPIO line 4 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO5_BIT  (20)  /* Bit pos for GPIO line 5 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO6_BIT  (24)  /* Bit pos for GPIO line 6 */
#define BF_PERIPH_GPIO_CONTROL1_GPIO7_BIT  (28)  /* Bit pos for GPIO line 7 */

#define BF_PERIPH_GPIO_CONTROL1_MASK       (0xf) /* Mask to get config bits */

/* Control register 2 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL2_GPIO8_BIT  (0)   /* Bit pos for GPIO line 8 */
#define BF_PERIPH_GPIO_CONTROL2_GPIO9_BIT  (4)   /* Bit pos for GPIO line 9 */
#define BF_PERIPH_GPIO_CONTROL2_GPIO10_BIT (8)   /* Bit pos for GPIO line 10*/
#define BF_PERIPH_GPIO_CONTROL2_GPIO11_BIT (12)  /* Bit pos for GPIO line 11*/
#define BF_PERIPH_GPIO_CONTROL2_GPIO12_BIT (16)  /* Bit pos for GPIO line 12*/
#define BF_PERIPH_GPIO_CONTROL2_GPIO13_BIT (20)  /* Bit pos for GPIO line 13*/
#define BF_PERIPH_GPIO_CONTROL2_GPIO14_BIT (24)  /* Bit pos for GPIO line 14*/
#define BF_PERIPH_GPIO_CONTROL2_GPIO15_BIT (28)  /* Bit pos for GPIO line 15*/

#define BF_PERIPH_GPIO_CONTROL2_MASK       (0xf) /* Mask to get config bits */

/* Control register 3 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL3_GPIO16_BIT (0)   /* Bit pos for GPIO line 16*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO17_BIT (4)   /* Bit pos for GPIO line 17*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO18_BIT (8)   /* Bit pos for GPIO line 18*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO19_BIT (12)  /* Bit pos for GPIO line 19*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO20_BIT (16)  /* Bit pos for GPIO line 20*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO21_BIT (20)  /* Bit pos for GPIO line 21*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO22_BIT (24)  /* Bit pos for GPIO line 22*/
#define BF_PERIPH_GPIO_CONTROL3_GPIO23_BIT (28)  /* Bit pos for GPIO line 23*/

#define BF_PERIPH_GPIO_CONTROL3_MASK       (0xf) /* Mask to get config bits */

/* Control register 4 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL4_GPIO24_BIT (0)   /* Bit pos for GPIO line 24*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO25_BIT (4)   /* Bit pos for GPIO line 25*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO26_BIT (8)   /* Bit pos for GPIO line 26*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO27_BIT (12)  /* Bit pos for GPIO line 27*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO28_BIT (16)  /* Bit pos for GPIO line 28*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO29_BIT (20)  /* Bit pos for GPIO line 29*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO30_BIT (24)  /* Bit pos for GPIO line 30*/
#define BF_PERIPH_GPIO_CONTROL4_GPIO31_BIT (28)  /* Bit pos for GPIO line 31*/

#define BF_PERIPH_GPIO_CONTROL4_MASK       (0xf) /* Mask to get config bits */

/* Control register 5 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL5_GPIO32_BIT (0)   /* Bit pos for GPIO line 32*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO33_BIT (4)   /* Bit pos for GPIO line 33*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO34_BIT (8)   /* Bit pos for GPIO line 34*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO35_BIT (12)  /* Bit pos for GPIO line 35*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO36_BIT (16)  /* Bit pos for GPIO line 36*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO37_BIT (20)  /* Bit pos for GPIO line 37*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO38_BIT (24)  /* Bit pos for GPIO line 38*/
#define BF_PERIPH_GPIO_CONTROL5_GPIO39_BIT (28)  /* Bit pos for GPIO line 39*/

#define BF_PERIPH_GPIO_CONTROL5_MASK       (0xf) /* Mask to get config bits */

/* Control register 6 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL6_GPIO40_BIT (0)   /* Bit pos for GPIO line 40*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO41_BIT (4)   /* Bit pos for GPIO line 41*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO42_BIT (8)   /* Bit pos for GPIO line 42*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO43_BIT (12)  /* Bit pos for GPIO line 43*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO44_BIT (16)  /* Bit pos for GPIO line 44*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO45_BIT (20)  /* Bit pos for GPIO line 45*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO46_BIT (24)  /* Bit pos for GPIO line 46*/
#define BF_PERIPH_GPIO_CONTROL6_GPIO47_BIT (28)  /* Bit pos for GPIO line 47*/

#define BF_PERIPH_GPIO_CONTROL6_MASK       (0xf) /* Mask to get config bits */

/* Control register 7 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL7_GPIO48_BIT (0)   /* Bit pos for GPIO line 48*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO49_BIT (4)   /* Bit pos for GPIO line 49*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO50_BIT (8)   /* Bit pos for GPIO line 50*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO51_BIT (12)  /* Bit pos for GPIO line 51*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO52_BIT (16)  /* Bit pos for GPIO line 52*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO53_BIT (20)  /* Bit pos for GPIO line 53*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO54_BIT (24)  /* Bit pos for GPIO line 54*/
#define BF_PERIPH_GPIO_CONTROL7_GPIO55_BIT (28)  /* Bit pos for GPIO line 55*/

#define BF_PERIPH_GPIO_CONTROL7_MASK       (0xf) /* Mask to get config bits */

/* Control register 8 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_CONTROL8_GPIO56_BIT (0)   /* Bit pos for GPIO line 56*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO57_BIT (4)   /* Bit pos for GPIO line 57*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO58_BIT (8)   /* Bit pos for GPIO line 58*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO59_BIT (12)  /* Bit pos for GPIO line 59*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO60_BIT (16)  /* Bit pos for GPIO line 60*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO61_BIT (20)  /* Bit pos for GPIO line 61*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO62_BIT (24)  /* Bit pos for GPIO line 62*/
#define BF_PERIPH_GPIO_CONTROL8_GPIO63_BIT (28)  /* Bit pos for GPIO line 63*/

#define BF_PERIPH_GPIO_CONTROL8_MASK       (0xf) /* Mask to get config bits */

/* Bit definitions for output register 1 */

#define BF_PERIPH_GPIO_OUTPUT1_GPIO0  (0x00000001) /* GPIO line 0 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO1  (0x00000002) /* GPIO line 1 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO2  (0x00000004) /* GPIO line 2 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO3  (0x00000008) /* GPIO line 3 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO4  (0x00000010) /* GPIO line 4 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO5  (0x00000020) /* GPIO line 5 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO6  (0x00000040) /* GPIO line 6 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO7  (0x00000080) /* GPIO line 7 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO8  (0x00000100) /* GPIO line 8 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO9  (0x00000200) /* GPIO line 9 output val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO10 (0x00000400) /* GPIO line 10 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO11 (0x00000800) /* GPIO line 11 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO12 (0x00001000) /* GPIO line 12 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO13 (0x00002000) /* GPIO line 13 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO14 (0x00004000) /* GPIO line 14 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO15 (0x00008000) /* GPIO line 15 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO16 (0x00010000) /* GPIO line 16 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO17 (0x00020000) /* GPIO line 17 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO18 (0x00040000) /* GPIO line 18 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO19 (0x00080000) /* GPIO line 19 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO20 (0x00100000) /* GPIO line 20 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO21 (0x00200000) /* GPIO line 21 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO22 (0x00400000) /* GPIO line 22 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO23 (0x00800000) /* GPIO line 23 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO24 (0x01000000) /* GPIO line 24 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO25 (0x02000000) /* GPIO line 25 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO26 (0x04000000) /* GPIO line 26 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO27 (0x08000000) /* GPIO line 27 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO28 (0x10000000) /* GPIO line 28 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO29 (0x20000000) /* GPIO line 29 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO30 (0x40000000) /* GPIO line 30 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT1_GPIO31 (0x80000000) /* GPIO line 31 outpt val*/

/* Bit definitions for output register 2 */

#define BF_PERIPH_GPIO_OUTPUT2_GPIO32 (0x00000001) /* GPIO line 32 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO33 (0x00000002) /* GPIO line 33 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO34 (0x00000004) /* GPIO line 34 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO35 (0x00000008) /* GPIO line 35 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO36 (0x00000010) /* GPIO line 36 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO37 (0x00000020) /* GPIO line 37 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO38 (0x00000040) /* GPIO line 38 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO39 (0x00000080) /* GPIO line 39 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO40 (0x00000100) /* GPIO line 40 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO41 (0x00000200) /* GPIO line 41 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO42 (0x00000400) /* GPIO line 42 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO43 (0x00000800) /* GPIO line 43 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO44 (0x00001000) /* GPIO line 44 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO45 (0x00002000) /* GPIO line 45 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO46 (0x00004000) /* GPIO line 46 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO47 (0x00008000) /* GPIO line 47 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO48 (0x00010000) /* GPIO line 48 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO49 (0x00020000) /* GPIO line 49 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO50 (0x00040000) /* GPIO line 50 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO51 (0x00080000) /* GPIO line 51 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO52 (0x00100000) /* GPIO line 52 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO53 (0x00200000) /* GPIO line 53 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO54 (0x00400000) /* GPIO line 54 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO55 (0x00800000) /* GPIO line 55 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO56 (0x01000000) /* GPIO line 56 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO57 (0x02000000) /* GPIO line 57 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO58 (0x04000000) /* GPIO line 58 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO59 (0x08000000) /* GPIO line 59 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO60 (0x10000000) /* GPIO line 60 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO61 (0x20000000) /* GPIO line 61 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO62 (0x40000000) /* GPIO line 62 outpt val*/
#define BF_PERIPH_GPIO_OUTPUT2_GPIO63 (0x80000000) /* GPIO line 63 outpt val*/

/* Bit definitions for input register 1*/

#define BF_PERIPH_GPIO_INPUT1_GPIO0   (0x00000001) /* GPIO line 0 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO1   (0x00000002) /* GPIO line 1 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO2   (0x00000004) /* GPIO line 2 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO3   (0x00000008) /* GPIO line 3 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO4   (0x00000010) /* GPIO line 4 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO5   (0x00000020) /* GPIO line 5 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO6   (0x00000040) /* GPIO line 6 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO7   (0x00000080) /* GPIO line 7 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO8   (0x00000100) /* GPIO line 8 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO9   (0x00000200) /* GPIO line 9 input val */
#define BF_PERIPH_GPIO_INPUT1_GPIO10  (0x00000400) /* GPIO line 10 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO11  (0x00000800) /* GPIO line 11 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO12  (0x00001000) /* GPIO line 12 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO13  (0x00002000) /* GPIO line 13 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO14  (0x00004000) /* GPIO line 14 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO15  (0x00008000) /* GPIO line 15 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO16  (0x00010000) /* GPIO line 16 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO17  (0x00020000) /* GPIO line 17 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO18  (0x00040000) /* GPIO line 18 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO19  (0x00080000) /* GPIO line 19 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO20  (0x00100000) /* GPIO line 20 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO21  (0x00200000) /* GPIO line 21 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO22  (0x00400000) /* GPIO line 22 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO23  (0x00800000) /* GPIO line 23 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO24  (0x01000000) /* GPIO line 24 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO25  (0x02000000) /* GPIO line 25 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO26  (0x04000000) /* GPIO line 26 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO27  (0x08000000) /* GPIO line 27 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO28  (0x10000000) /* GPIO line 28 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO29  (0x20000000) /* GPIO line 29 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO30  (0x40000000) /* GPIO line 30 input val*/
#define BF_PERIPH_GPIO_INPUT1_GPIO31  (0x80000000) /* GPIO line 31 input val*/ 

/* Bit definitions for input register 2 */

#define BF_PERIPH_GPIO_INPUT2_GPIO32  (0x00000001) /* GPIO line 32 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO33  (0x00000002) /* GPIO line 33 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO34  (0x00000004) /* GPIO line 34 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO35  (0x00000008) /* GPIO line 35 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO36  (0x00000010) /* GPIO line 36 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO37  (0x00000020) /* GPIO line 37 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO38  (0x00000040) /* GPIO line 38 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO39  (0x00000080) /* GPIO line 39 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO40  (0x00000100) /* GPIO line 40 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO41  (0x00000200) /* GPIO line 41 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO42  (0x00000400) /* GPIO line 42 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO43  (0x00000800) /* GPIO line 43 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO44  (0x00001000) /* GPIO line 44 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO45  (0x00002000) /* GPIO line 45 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO46  (0x00004000) /* GPIO line 46 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO47  (0x00008000) /* GPIO line 47 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO48  (0x00010000) /* GPIO line 48 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO49  (0x00020000) /* GPIO line 49 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO50  (0x00040000) /* GPIO line 50 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO51  (0x00080000) /* GPIO line 51 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO52  (0x00100000) /* GPIO line 52 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO53  (0x00200000) /* GPIO line 53 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO54  (0x00400000) /* GPIO line 54 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO55  (0x00800000) /* GPIO line 55 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO56  (0x01000000) /* GPIO line 56 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO57  (0x02000000) /* GPIO line 57 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO58  (0x04000000) /* GPIO line 58 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO59  (0x08000000) /* GPIO line 59 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO60  (0x10000000) /* GPIO line 60 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO61  (0x20000000) /* GPIO line 61 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO62  (0x40000000) /* GPIO line 62 input val*/
#define BF_PERIPH_GPIO_INPUT2_GPIO63  (0x80000000) /* GPIO line 63 input val*/ 

/* Bit definitions for set register 1*/

#define BF_PERIPH_GPIO_SET1_GPIO0   (0x00000001) /* GPIO line 0 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO1   (0x00000002) /* GPIO line 1 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO2   (0x00000004) /* GPIO line 2 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO3   (0x00000008) /* GPIO line 3 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO4   (0x00000010) /* GPIO line 4 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO5   (0x00000020) /* GPIO line 5 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO6   (0x00000040) /* GPIO line 6 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO7   (0x00000080) /* GPIO line 7 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO8   (0x00000100) /* GPIO line 8 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO9   (0x00000200) /* GPIO line 9 set value   */
#define BF_PERIPH_GPIO_SET1_GPIO10  (0x00000400) /* GPIO line 10 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO11  (0x00000800) /* GPIO line 11 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO12  (0x00001000) /* GPIO line 12 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO13  (0x00002000) /* GPIO line 13 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO14  (0x00004000) /* GPIO line 14 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO15  (0x00008000) /* GPIO line 15 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO16  (0x00010000) /* GPIO line 16 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO17  (0x00020000) /* GPIO line 17 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO18  (0x00040000) /* GPIO line 18 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO19  (0x00080000) /* GPIO line 19 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO20  (0x00100000) /* GPIO line 20 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO21  (0x00200000) /* GPIO line 21 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO22  (0x00400000) /* GPIO line 22 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO23  (0x00800000) /* GPIO line 23 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO24  (0x01000000) /* GPIO line 24 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO25  (0x02000000) /* GPIO line 25 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO26  (0x04000000) /* GPIO line 26 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO27  (0x08000000) /* GPIO line 27 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO28  (0x10000000) /* GPIO line 28 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO29  (0x20000000) /* GPIO line 29 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO30  (0x40000000) /* GPIO line 30 set value  */
#define BF_PERIPH_GPIO_SET1_GPIO31  (0x80000000) /* GPIO line 31 set value  */ 

/* Bit definitions for set register 2 */

#define BF_PERIPH_GPIO_SET2_GPIO32  (0x00000001) /* GPIO line 32 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO33  (0x00000002) /* GPIO line 33 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO34  (0x00000004) /* GPIO line 34 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO35  (0x00000008) /* GPIO line 35 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO36  (0x00000010) /* GPIO line 36 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO37  (0x00000020) /* GPIO line 37 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO38  (0x00000040) /* GPIO line 38 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO39  (0x00000080) /* GPIO line 39 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO40  (0x00000100) /* GPIO line 40 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO41  (0x00000200) /* GPIO line 41 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO42  (0x00000400) /* GPIO line 42 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO43  (0x00000800) /* GPIO line 43 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO44  (0x00001000) /* GPIO line 44 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO45  (0x00002000) /* GPIO line 45 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO46  (0x00004000) /* GPIO line 46 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO47  (0x00008000) /* GPIO line 47 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO48  (0x00010000) /* GPIO line 48 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO49  (0x00020000) /* GPIO line 49 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO50  (0x00040000) /* GPIO line 50 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO51  (0x00080000) /* GPIO line 51 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO52  (0x00100000) /* GPIO line 52 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO53  (0x00200000) /* GPIO line 53 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO54  (0x00400000) /* GPIO line 54 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO55  (0x00800000) /* GPIO line 55 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO56  (0x01000000) /* GPIO line 56 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO57  (0x02000000) /* GPIO line 57 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO58  (0x04000000) /* GPIO line 58 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO59  (0x08000000) /* GPIO line 59 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO60  (0x10000000) /* GPIO line 60 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO61  (0x20000000) /* GPIO line 61 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO62  (0x40000000) /* GPIO line 62 set value  */
#define BF_PERIPH_GPIO_SET2_GPIO63  (0x80000000) /* GPIO line 63 set value  */ 

/* Bit definitions for clear register 1*/

#define BF_PERIPH_GPIO_CLEAR1_GPIO0   (0x00000001) /* GPIO line 0 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO1   (0x00000002) /* GPIO line 1 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO2   (0x00000004) /* GPIO line 2 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO3   (0x00000008) /* GPIO line 3 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO4   (0x00000010) /* GPIO line 4 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO5   (0x00000020) /* GPIO line 5 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO6   (0x00000040) /* GPIO line 6 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO7   (0x00000080) /* GPIO line 7 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO8   (0x00000100) /* GPIO line 8 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO9   (0x00000200) /* GPIO line 9 clear val */
#define BF_PERIPH_GPIO_CLEAR1_GPIO10  (0x00000400) /* GPIO line 10 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO11  (0x00000800) /* GPIO line 11 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO12  (0x00001000) /* GPIO line 12 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO13  (0x00002000) /* GPIO line 13 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO14  (0x00004000) /* GPIO line 14 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO15  (0x00008000) /* GPIO line 15 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO16  (0x00010000) /* GPIO line 16 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO17  (0x00020000) /* GPIO line 17 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO18  (0x00040000) /* GPIO line 18 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO19  (0x00080000) /* GPIO line 19 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO20  (0x00100000) /* GPIO line 20 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO21  (0x00200000) /* GPIO line 21 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO22  (0x00400000) /* GPIO line 22 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO23  (0x00800000) /* GPIO line 23 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO24  (0x01000000) /* GPIO line 24 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO25  (0x02000000) /* GPIO line 25 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO26  (0x04000000) /* GPIO line 26 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO27  (0x08000000) /* GPIO line 27 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO28  (0x10000000) /* GPIO line 28 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO29  (0x20000000) /* GPIO line 29 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO30  (0x40000000) /* GPIO line 30 clear val*/
#define BF_PERIPH_GPIO_CLEAR1_GPIO31  (0x80000000) /* GPIO line 31 clear val*/ 

/* Bit definitions for clear register 2 */

#define BF_PERIPH_GPIO_CLEAR2_GPIO32  (0x00000001) /* GPIO line 32 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO33  (0x00000002) /* GPIO line 33 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO34  (0x00000004) /* GPIO line 34 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO35  (0x00000008) /* GPIO line 35 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO36  (0x00000010) /* GPIO line 36 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO37  (0x00000020) /* GPIO line 37 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO38  (0x00000040) /* GPIO line 38 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO39  (0x00000080) /* GPIO line 39 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO40  (0x00000100) /* GPIO line 40 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO41  (0x00000200) /* GPIO line 41 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO42  (0x00000400) /* GPIO line 42 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO43  (0x00000800) /* GPIO line 43 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO44  (0x00001000) /* GPIO line 44 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO45  (0x00002000) /* GPIO line 45 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO46  (0x00004000) /* GPIO line 46 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO47  (0x00008000) /* GPIO line 47 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO48  (0x00010000) /* GPIO line 48 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO49  (0x00020000) /* GPIO line 49 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO50  (0x00040000) /* GPIO line 50 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO51  (0x00080000) /* GPIO line 51 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO52  (0x00100000) /* GPIO line 52 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO53  (0x00200000) /* GPIO line 53 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO54  (0x00400000) /* GPIO line 54 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO55  (0x00800000) /* GPIO line 55 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO56  (0x01000000) /* GPIO line 56 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO57  (0x02000000) /* GPIO line 57 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO58  (0x04000000) /* GPIO line 58 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO59  (0x08000000) /* GPIO line 59 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO60  (0x10000000) /* GPIO line 60 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO61  (0x20000000) /* GPIO line 61 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO62  (0x40000000) /* GPIO line 62 clear val*/
#define BF_PERIPH_GPIO_CLEAR2_GPIO63  (0x80000000) /* GPIO line 63 clear val*/ 


/****************************************************************************/
/* COMPATIBILITY DEFINITIONS                                                */
/*    - The INFO registers no longer exist because all the options for      */
/*      configuring interrupts are in the CONTROL registers.  There is not  */
/*      NextPort for service requests and interrupt priorities can be set   */
/*      in the Vectored Interrupt Controller.                               */
/****************************************************************************/

/* Information register configuration values */

#define BF_PERIPH_GPIO_INFO_WAKEUP    (0x1) /* Wakeup                 */
#define BF_PERIPH_GPIO_INFO_SER_REQ_L (0x1) /* Service request low    */
#define BF_PERIPH_GPIO_INFO_SER_REQ_M (0x2) /* Service request medium */
#define BF_PERIPH_GPIO_INFO_SER_REQ_H (0x3) /* Service request High   */
#define BF_PERIPH_GPIO_INFO_IRQ_L     (0x4) /* IRQ low                */
#define BF_PERIPH_GPIO_INFO_IRQ_M     (0x5) /* IRQ medium             */
#define BF_PERIPH_GPIO_INFO_IRQ_H     (0x6) /* IRQ high               */
#define BF_PERIPH_GPIO_INFO_FIQ       (0x7) 

/* Information register 1 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO1_GPIO0_BIT  (0)   /* Bit pos for GPIO line 0    */
#define BF_PERIPH_GPIO_INFO1_GPIO1_BIT  (4)   /* Bit pos for GPIO line 1    */
#define BF_PERIPH_GPIO_INFO1_GPIO2_BIT  (8)   /* Bit pos for GPIO line 2    */
#define BF_PERIPH_GPIO_INFO1_GPIO3_BIT  (12)  /* Bit pos for GPIO line 3    */
#define BF_PERIPH_GPIO_INFO1_GPIO4_BIT  (16)  /* Bit pos for GPIO line 4    */
#define BF_PERIPH_GPIO_INFO1_GPIO5_BIT  (20)  /* Bit pos for GPIO line 5    */
#define BF_PERIPH_GPIO_INFO1_GPIO6_BIT  (24)  /* Bit pos for GPIO line 6    */
#define BF_PERIPH_GPIO_INFO1_GPIO7_BIT  (28)  /* Bit pos for GPIO line 7    */

#define BF_PERIPH_GPIO_INFO1_MASK       (0xf) /* Mask to get config bits    */

/* Information register 2 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO2_GPIO8_BIT  (0)   /* Bit pos for GPIO line 8    */
#define BF_PERIPH_GPIO_INFO2_GPIO9_BIT  (4)   /* Bit pos for GPIO line 9    */
#define BF_PERIPH_GPIO_INFO2_GPIO10_BIT (8)   /* Bit pos for GPIO line 10   */
#define BF_PERIPH_GPIO_INFO2_GPIO11_BIT (12)  /* Bit pos for GPIO line 11   */
#define BF_PERIPH_GPIO_INFO2_GPIO12_BIT (16)  /* Bit pos for GPIO line 12   */
#define BF_PERIPH_GPIO_INFO2_GPIO13_BIT (20)  /* Bit pos for GPIO line 13   */
#define BF_PERIPH_GPIO_INFO2_GPIO14_BIT (24)  /* Bit pos for GPIO line 14   */
#define BF_PERIPH_GPIO_INFO2_GPIO15_BIT (28)  /* Bit pos for GPIO line 15   */

#define BF_PERIPH_GPIO_INFO2_MASK       (0xf) /* Mask to get config bits    */

/* Information register 3 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO3_GPIO16_BIT (0)   /* Bit pos for GPIO line 16   */
#define BF_PERIPH_GPIO_INFO3_GPIO17_BIT (4)   /* Bit pos for GPIO line 17   */
#define BF_PERIPH_GPIO_INFO3_GPIO18_BIT (8)   /* Bit pos for GPIO line 18   */
#define BF_PERIPH_GPIO_INFO3_GPIO19_BIT (12)  /* Bit pos for GPIO line 19   */
#define BF_PERIPH_GPIO_INFO3_GPIO20_BIT (16)  /* Bit pos for GPIO line 20   */
#define BF_PERIPH_GPIO_INFO3_GPIO21_BIT (20)  /* Bit pos for GPIO line 21   */
#define BF_PERIPH_GPIO_INFO3_GPIO22_BIT (24)  /* Bit pos for GPIO line 22   */
#define BF_PERIPH_GPIO_INFO3_GPIO23_BIT (28)  /* Bit pos for GPIO line 23   */

#define BF_PERIPH_GPIO_INFO3_MASK       (0xf) /* Mask to get config bits    */

/* Information register 4 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO4_GPIO24_BIT (0)   /* Bit pos for GPIO line 24   */
#define BF_PERIPH_GPIO_INFO4_GPIO25_BIT (4)   /* Bit pos for GPIO line 25   */
#define BF_PERIPH_GPIO_INFO4_GPIO26_BIT (8)   /* Bit pos for GPIO line 26   */
#define BF_PERIPH_GPIO_INFO4_GPIO27_BIT (12)  /* Bit pos for GPIO line 27   */
#define BF_PERIPH_GPIO_INFO4_GPIO28_BIT (16)  /* Bit pos for GPIO line 28   */
#define BF_PERIPH_GPIO_INFO4_GPIO29_BIT (20)  /* Bit pos for GPIO line 29   */
#define BF_PERIPH_GPIO_INFO4_GPIO30_BIT (24)  /* Bit pos for GPIO line 30   */
#define BF_PERIPH_GPIO_INFO4_GPIO31_BIT (28)  /* Bit pos for GPIO line 31   */

#define BF_PERIPH_GPIO_INFO4_MASK       (0xf) /* Mask to get config bits    */

/* Information register 5 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO5_GPIO32_BIT (0)   /* Bit pos for GPIO line 32   */
#define BF_PERIPH_GPIO_INFO5_GPIO33_BIT (4)   /* Bit pos for GPIO line 33   */
#define BF_PERIPH_GPIO_INFO5_GPIO34_BIT (8)   /* Bit pos for GPIO line 34   */
#define BF_PERIPH_GPIO_INFO5_GPIO35_BIT (12)  /* Bit pos for GPIO line 35   */
#define BF_PERIPH_GPIO_INFO5_GPIO36_BIT (16)  /* Bit pos for GPIO line 36   */
#define BF_PERIPH_GPIO_INFO5_GPIO37_BIT (20)  /* Bit pos for GPIO line 37   */
#define BF_PERIPH_GPIO_INFO5_GPIO38_BIT (24)  /* Bit pos for GPIO line 38   */
#define BF_PERIPH_GPIO_INFO5_GPIO39_BIT (28)  /* Bit pos for GPIO line 39   */

#define BF_PERIPH_GPIO_INFO5_MASK       (0xf) /* Mask to get config bits    */

/* Information register 6 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO6_GPIO40_BIT (0)   /* Bit pos for GPIO line 40   */
#define BF_PERIPH_GPIO_INFO6_GPIO41_BIT (4)   /* Bit pos for GPIO line 41   */
#define BF_PERIPH_GPIO_INFO6_GPIO42_BIT (8)   /* Bit pos for GPIO line 42   */
#define BF_PERIPH_GPIO_INFO6_GPIO43_BIT (12)  /* Bit pos for GPIO line 43   */
#define BF_PERIPH_GPIO_INFO6_GPIO44_BIT (16)  /* Bit pos for GPIO line 44   */
#define BF_PERIPH_GPIO_INFO6_GPIO45_BIT (20)  /* Bit pos for GPIO line 45   */
#define BF_PERIPH_GPIO_INFO6_GPIO46_BIT (24)  /* Bit pos for GPIO line 46   */
#define BF_PERIPH_GPIO_INFO6_GPIO47_BIT (28)  /* Bit pos for GPIO line 47   */

#define BF_PERIPH_GPIO_INFO6_MASK       (0xf) /* Mask to get config bits    */

/* Information register 7 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO7_GPIO48_BIT (0)   /* Bit pos for GPIO line 48   */
#define BF_PERIPH_GPIO_INFO7_GPIO49_BIT (4)   /* Bit pos for GPIO line 49   */
#define BF_PERIPH_GPIO_INFO7_GPIO50_BIT (8)   /* Bit pos for GPIO line 50   */
#define BF_PERIPH_GPIO_INFO7_GPIO51_BIT (12)  /* Bit pos for GPIO line 51   */
#define BF_PERIPH_GPIO_INFO7_GPIO52_BIT (16)  /* Bit pos for GPIO line 52   */
#define BF_PERIPH_GPIO_INFO7_GPIO53_BIT (20)  /* Bit pos for GPIO line 53   */
#define BF_PERIPH_GPIO_INFO7_GPIO54_BIT (24)  /* Bit pos for GPIO line 54   */
#define BF_PERIPH_GPIO_INFO7_GPIO55_BIT (28)  /* Bit pos for GPIO line 55   */

#define BF_PERIPH_GPIO_INFO7_MASK       (0xf) /* Mask to get config bits    */

/* Information register 8 bit positions - bit numbers, not masks! */

#define BF_PERIPH_GPIO_INFO8_GPIO56_BIT (0)   /* Bit pos for GPIO line 56   */
#define BF_PERIPH_GPIO_INFO8_GPIO57_BIT (4)   /* Bit pos for GPIO line 57   */
#define BF_PERIPH_GPIO_INFO8_GPIO58_BIT (8)   /* Bit pos for GPIO line 58   */
#define BF_PERIPH_GPIO_INFO8_GPIO59_BIT (12)  /* Bit pos for GPIO line 59   */
#define BF_PERIPH_GPIO_INFO8_GPIO60_BIT (16)  /* Bit pos for GPIO line 60   */
#define BF_PERIPH_GPIO_INFO8_GPIO61_BIT (20)  /* Bit pos for GPIO line 61   */
#define BF_PERIPH_GPIO_INFO8_GPIO62_BIT (24)  /* Bit pos for GPIO line 62   */
#define BF_PERIPH_GPIO_INFO8_GPIO63_BIT (28)  /* Bit pos for GPIO line 63   */

#define BF_PERIPH_GPIO_INFO8_MASK       (0xf) /* Mask to get config bits    */

#endif
