#include <linux/delay.h>
#include <gpio_bf.h>
#include <bf_config_io.h>
#include <sm_drv_ahb.h>
#include <linux/sched.h>
#include <linux/timer.h>

#define WLAN_SET 1
#define WLAN_CLEAR 0
#define LINK_UP 1
#define LINK_DOWN 0
#define REGIO(_dev, _reg) ( ((BF_##_dev##_REGS *)(BF_##_dev))->_reg )

unsigned char stun_gpio_shift[] = {8, 12, 24, 16, 20, 28};
int stun_gpio_inv[GPIO_STUN_GPIOS];
static int wlan_link = LINK_DOWN;
void control_wlan_led(unsigned long int GPIONum , int mode);

static struct timer_list blink_timer;

void control_wlan_led(unsigned long int GPIONum , int mode)
{
    unsigned long int set_val = 0;
    U32 reg = REGIO (IOCONF, CONFIG19);

    if ((GPIONum > GPIO_TRUE_GPIOS) && (mode != WLAN_SET))
    {
        int gpio = GPIONum - GPIO_TRUE_GPIOS - 1;

        stun_gpio_inv[gpio] = 1;
        if (stun_gpio_inv[GPIONum - GPIO_TRUE_GPIOS - 1] == 0)
        {
            reg &= ~((U32) (1 << (stun_gpio_shift[gpio] + GPIO_STUN_GPIO_OUTPUT_BIT)));

        }
        else
        {
            reg |= (1 << (stun_gpio_shift[gpio] + GPIO_STUN_GPIO_OUTPUT_BIT));
        }
    }
    else 
    {
        int gpio = GPIONum - GPIO_TRUE_GPIOS - 1;

        stun_gpio_inv[gpio] = 1;
        if (stun_gpio_inv[gpio] == 0)
        {
            reg |= (1 << (stun_gpio_shift[gpio] + GPIO_STUN_GPIO_OUTPUT_BIT));

        }
        else
        {
            reg &= ~((U32) (1 << (stun_gpio_shift[gpio] + GPIO_STUN_GPIO_OUTPUT_BIT)));
        }
    }

    REGIO (IOCONF, CONFIG19) = reg;
#if 0 /* To be decided */

    if ( mode == WLAN_SET)
    {
        set_val = 0x00400000;
        REGIO (IOCONF, CONFIG19) = set_val;
    }
    else
    {
        set_val = ~(0x00400000);
        REGIO (IOCONF, CONFIG19) &= set_val;
    }
}
else
REGIO_GPIO(SET, GPIONum) = 1 << GPIO_SHIFT(SET, GPIONum);
#endif
}

void wlan_link_status(int link)
{
    wlan_link = link;
}

void blink_callback(unsigned long data)
{
    control_wlan_led(22,WLAN_SET);
}

void toggle_wlan_led()
{
    if(wlan_link == LINK_UP)
    {
        if(! timer_pending(&blink_timer))
        { 
            init_timer(&blink_timer);
            blink_timer.expires=jiffies + 3; /* In jiffies. One jiffie equal to 10ms */
            blink_timer.function= blink_callback;
            blink_timer.data=(unsigned long)NULL;
            add_timer(&blink_timer);
            control_wlan_led(22,WLAN_CLEAR);
            control_wlan_led(22,WLAN_CLEAR);
            control_wlan_led(22,WLAN_CLEAR);
        }
    }
}

