
#define IWMAX_BSS		20
#define IWMAX_BITRATES	20
#define IWMAX_FREQ		51

#define PRIV_STR_SIZE		1024
#define MAX_COUNTRYLIST_SIZE    200

/*Convert between channel and freq */
const int frequency_list_bg[] = { 2412,2417,2422,2427,2432,2437,2442,2447,
								  2452,2457,2462,2467,2472,2484
};
const int frequency_list_a[] =  { 5170,5180,5190,5200,5210,5220,5230,5240,
								  5260,5280,5300,5320
}; 	

// @struct ChannelData_t | kHz <--> channel conversion data
typedef struct {
    uint32_t         firstChannelMHz;
    uint32_t         lastChannelMHz;
    uint32_t         spacing;
    uint32_t         firstChannelNbr;
    uint32_t         lastChannelNbr;
} ChannelData_t;

#define OID_FLAG_CACHED		0x80
#define OID_FLAG_TYPE		0x7f

#define OID_TYPE_INT		0x00
#define OID_TYPE_U32		0x01
#define OID_TYPE_SSID		0x02
#define OID_TYPE_KEY		0x03
#define OID_TYPE_BUFFER		0x04
#define OID_TYPE_BSS		0x05
#define OID_TYPE_BSSLIST	0x06
#define OID_TYPE_FREQUENCIES	0x07
#define OID_TYPE_MLME		0x08
#define OID_TYPE_MLMEEX		0x09
#define OID_TYPE_ADDR		0x0A
#define OID_TYPE_RAW		0x0B
#define OID_TYPE_ATTACH		0x0C
#define OID_TYPE_STAKEY		0x0D
#define OID_TYPE_COUNTRY	0x0E
#define OID_TYPE_SCAN   	0x0F
#define OID_TYPE_DRIVER   	0x10

#ifndef ETH_ALEN
#define ETH_ALEN 0x6
#endif





struct obj_oid_t{
	uint32_t oid;
	uint32_t ioctl;
	uint8_t type;
	uint16_t size;                                          
} oid_t[] = {
	{ GEN_OID_MACADDRESS, 0, OID_TYPE_ADDR, ETH_ALEN},
	{ GEN_OID_LINKSTATE, 1, OID_TYPE_U32, 0 },
	{ GEN_OID_LEDCONFIG, 2, OID_TYPE_U32, 0 },

	/* 802.11 */
	{ DOT11_OID_BSSTYPE, 3 , OID_TYPE_U32, 0},
	{ DOT11_OID_BSSID, 4, OID_TYPE_ADDR, ETH_ALEN},
	{ DOT11_OID_SSID, 5, OID_TYPE_SSID, 0 },
	{ DOT11_OID_STATE, 6, OID_TYPE_U32, 0 },
	{ DOT11_OID_AID, 7, OID_TYPE_U32, 0 },
	{ DOT11_OID_SSIDOVERRIDE, 8, OID_TYPE_SSID, IW_ESSID_MAX_SIZE+1 },

	{ DOT11_OID_BEACONPERIOD, 9, OID_TYPE_U32, 0 },
	{ DOT11_OID_DTIMPERIOD, 10, OID_TYPE_U32, 0 },
	{ DOT11_OID_ATIMWINDOW, 11, OID_TYPE_U32, 0 },
	{ DOT11_OID_LISTENINTERVAL, 12, OID_TYPE_U32, 0 },

	{ DOT11_OID_AUTHENABLE, 13, OID_TYPE_U32, 0 },
	{ DOT11_OID_PRIVACYINVOKED, 14, OID_TYPE_U32, 0 },
	{ DOT11_OID_EXUNENCRYPTED, 15, OID_TYPE_U32, 0  },
	{ DOT11_OID_DEFKEYID, 16, OID_TYPE_U32, 0  },
	{ DOT11_OID_DEFKEY1, 17, OID_TYPE_U32, 0  },
	{ DOT11_OID_DEFKEY2, 18, OID_TYPE_U32, 0 },
	{ DOT11_OID_DEFKEY3, 19, OID_TYPE_U32, 0 },
	{ DOT11_OID_DEFKEY4, 20, OID_TYPE_U32, 0 },
	{ DOT11_OID_STAKEY, 21, 0, 0 },
	{ DOT11_OID_STASC, 22, 0, 0 },

	{ DOT11_OID_PRIVTXREJECTED, 23, OID_TYPE_U32, 0 },
	{ DOT11_OID_PRIVRXPLAIN, 24, OID_TYPE_U32, 0 },
	{ DOT11_OID_PRIVRXFAILED, 25, OID_TYPE_U32, 0 },
	{ DOT11_OID_PRIVRXNOKEY, 26, OID_TYPE_U32, 0 },

	{ DOT11_OID_RTSTHRESH, 27, OID_TYPE_U32, 0 },
	{ DOT11_OID_FRAGTHRESH, 28, OID_TYPE_U32, 0 },
	{ DOT11_OID_SHORTRETRIES, 29, OID_TYPE_U32, 0 },
	{ DOT11_OID_LONGRETRIES, 30, OID_TYPE_U32, 0 },
	{ DOT11_OID_MAXTXLIFETIME, 31, OID_TYPE_U32, 0 },
	{ DOT11_OID_MAXRXLIFETIME, 32, OID_TYPE_U32, 0 },
	{ DOT11_OID_AUTHRESPTIMEOUT, 33, OID_TYPE_U32, 0 },
	{ DOT11_OID_ASSOCRESPTIMEOUT, 34, OID_TYPE_U32, 0 },

	{ DOT11_OID_ALOFT_TABLE, 35, 0, 0 },
	{ DOT11_OID_ALOFT_CTRL_TABLE, 36, 0, 0 },
	{ DOT11_OID_ALOFT_RETREAT, 37, 0, 0 },
	{ DOT11_OID_ALOFT_PROGRESS, 38, 0, 0 },
	{ DOT11_OID_ALOFT_FIXEDRATE, 39, OID_TYPE_INT, 0 },
	{ DOT11_OID_ALOFT_RSSIGRAPH, 40, 0, 0 },
	{ DOT11_OID_ALOFT_CONFIG, 41, 0, 0 },

	{ DOT11_OID_MAXFRAMEBURST, 42, OID_TYPE_U32, 0 },

	{ DOT11_OID_PSM, 43, OID_TYPE_U32, 0 },
	{ DOT11_OID_CAMTIMEOUT, 44, OID_TYPE_U32, 0 },
	{ DOT11_OID_RECEIVEDTIMS, 45, OID_TYPE_U32, 0 },
	{ DOT11_OID_ROAMPREFERENCE, 46, OID_TYPE_U32, 0 },

	{ DOT11_OID_CLIENTS, 47, OID_TYPE_U32, 0 },
	{ DOT11_OID_CLIENTS, 47, OID_TYPE_U32, 0 },

	{ DOT11_OID_CLIENTFIND, 49, OID_TYPE_ADDR, ETH_ALEN },
     
      /* Added to just make index right */
	{ DOT11_OID_CLIENTFIND, 49, OID_TYPE_ADDR, ETH_ALEN },
	{ DOT11_OID_CLIENTFIND, 49, OID_TYPE_ADDR, ETH_ALEN },
	{ DOT11_OID_CLIENTFIND, 49, OID_TYPE_ADDR, ETH_ALEN },
	{ DOT11_OID_CLIENTFIND, 49, OID_TYPE_ADDR, ETH_ALEN }, 
      
        /* deprecated in new version of emac */   
/*	{ DOT11_OID_WDSLINKADD, 50, OID_TYPE_ADDR, ETH_ALEN},
	{ DOT11_OID_WDSLINKREMOVE, 51, OID_TYPE_ADDR, ETH_ALEN},
	{ DOT11_OID_EAPAUTHSTA, 50, OID_TYPE_ADDR, ETH_ALEN},
	{ DOT11_OID_EAPUNAUTHSTA, 53, OID_TYPE_ADDR, ETH_ALEN},*/

	{ DOT11_OID_DOT1XENABLE, 54, OID_TYPE_U32, 0 },
	{ DOT11_OID_MICFAILURE, 55, 0, 0 },

	{ DOT11_OID_MPDUTXSUCCESSFUL, 56, OID_TYPE_U32, 0 },
	{ DOT11_OID_MPDUTXONERETRY, 57, OID_TYPE_U32, 0 },
	{ DOT11_OID_MPDUTXMULTIPLERETRIES, 58, OID_TYPE_U32, 0 },
	{ DOT11_OID_MPDUTXFAILED, 59, OID_TYPE_U32, 0 },
	{ DOT11_OID_MPDURXSUCCESSFUL, 60, OID_TYPE_U32, 0 },
	{ DOT11_OID_MPDURXDUPS, 61, OID_TYPE_U32, 0 },
	{ DOT11_OID_RTSSUCCESSFUL, 62, OID_TYPE_U32, 0 },
	{ DOT11_OID_RTSFAILED, 63, OID_TYPE_U32, 0 },
	{ DOT11_OID_ACKFAILED, 64, OID_TYPE_U32, 0 },
	{ DOT11_OID_FRAMERECEIVES, 65, OID_TYPE_U32, 0 },
	{ DOT11_OID_FRAMEERRORS, 66, OID_TYPE_U32, 0 },
	{ DOT11_OID_FRAMEABORTS, 67, OID_TYPE_U32, 0 },
	{ DOT11_OID_FRAMEABORTSPHY, 68, OID_TYPE_U32, 0 },

	{ DOT11_OID_SLOTTIME, 69, OID_TYPE_U32, 0 },
	{ DOT11_OID_CWMIN, 70, OID_TYPE_U32, 0  },/* MIN DCS backoff */
	{ DOT11_OID_CWMAX, 71, OID_TYPE_U32, 0  },/* MAX DCS backoff */
	{ DOT11_OID_ACKWINDOW, 72, OID_TYPE_U32, 0 },
	{ DOT11_OID_ANTENNARX, 73, OID_TYPE_U32, 0 },
	{ DOT11_OID_ANTENNATX, 74, OID_TYPE_U32, 0 },
	{ DOT11_OID_ANTENNADIVERSITY, 75, OID_TYPE_U32, 0 },

      /* Added to just make index right */
	{ DOT11_OID_FREQUENCY, 84, OID_TYPE_U32, 0 }, 

	{ DOT11_OID_EDTHRESHOLD, 77, OID_TYPE_U32, 0 },
	{ DOT11_OID_PREAMBLESETTINGS, 78, OID_TYPE_U32, 0 },
	{ DOT11_OID_RATES, 79, OID_TYPE_RAW, sizeof(uint8_t)*(IWMAX_BITRATES+1) },
	{ DOT11_OID_CCAMODESUPPORTED, 80, OID_TYPE_U32, 0 },
	{ DOT11_OID_CCAMODE, 81, OID_TYPE_U32, 0 },
	{ DOT11_OID_OUTPUTPOWER, 82, OID_TYPE_U32, 0 },
	{ DOT11_OID_SUPPORTEDRATES, 83, OID_TYPE_RAW, sizeof(uint8_t)*(IWMAX_BITRATES+1) },
	{ DOT11_OID_FREQUENCY, 84, OID_TYPE_U32, 0 },
	{ DOT11_OID_SUPPORTEDFREQUENCIES, 85 , OID_TYPE_FREQUENCIES, 0},
	{ DOT11_OID_NOISEFLOOR, 86, OID_TYPE_INT, 0 },
	{ DOT11_OID_NONERPPROTECTION, 87, OID_TYPE_U32, 0 },
	{ DOT11_OID_SLOTSETTINGS, 88, OID_TYPE_U32, 0 },
	{ DOT11_OID_NONERPTIMEOUT, 89, OID_TYPE_U32, 0 },
	{ DOT11_OID_PROFILES, 90, OID_TYPE_U32, 0 },
	{ DOT11_OID_EXTENDEDRATES, 91, OID_TYPE_RAW, sizeof(uint8_t)*(IWMAX_BITRATES+1) },

	{ DOT11_OID_DEAUTHENTICATE, 92, OID_TYPE_MLME, 0 },
	{ DOT11_OID_AUTHENTICATE, 93, OID_TYPE_MLME, 0 },
	{ DOT11_OID_DISASSOCIATE, 94, OID_TYPE_MLME, 0 },
	{ DOT11_OID_ASSOCIATE, 95, OID_TYPE_MLME, 0 },
	{ DOT11_OID_SCAN, 96, 0, 0 },
	{ DOT11_OID_REASSOCIATE, 97, OID_TYPE_MLME, 0 },

	{ DOT11_OID_NONERPSTATUS, 98, OID_TYPE_U32, 0 },

	{ DOT11_OID_STATIMEOUT, 99, OID_TYPE_U32, 0 },
	{ DOT11_OID_BSSTIMEOUT, 100, OID_TYPE_U32, 0 },
	{ DOT11_OID_ATTACHMENT, 101, OID_TYPE_ATTACH, 0 },

	{ DOT11_OID_BSSS, 102, OID_TYPE_BSS, 0 },
	{ DOT11_OID_BSSFIND, 103, OID_TYPE_BSS,0 },  
	{ DOT11_OID_BSSLIST, 104, OID_TYPE_BSSLIST,0 },
	{ DOT11_OID_COUNTRY, 105, OID_TYPE_COUNTRY,sizeof(uint8_t)*3 },
	{ DOT11_OID_SCAN, 106, OID_TYPE_SCAN,sizeof(struct obj_scan) },
	{ 0, 107, OID_TYPE_DRIVER,PRIV_STR_SIZE },
	
	/*{ OID_INL_TUNNEL,
	{ OID_INL_MEMADDR,
	{ OID_INL_MEMORY,
	{ OID_INL_MODE,
	{ OID_INL_COMPONENT_NR,
	{ OID_INL_VERSION,
	{ OID_INL_INTERFACE_ID,
	{ OID_INL_COMPONENT_ID,
	{ OID_INL_CONFIG,
	{ OID_INL_DOT11D_CONFORMANCE,
	{ OID_INL_PHYCAPABILITIES,
	{ OID_INL_OUTPUTPOWER, */

};

#ifndef  __SM_DRV_IOCTL_H__
#define  __SM_DRV_IOCTL_H__

#define CAP_ESS 0x01
#define CAP_IBSS 0x02
#define CAP_CRYPT 0x10


#define MAX_SUB_IOCTL_NUM	105




int oid2ioctl(int n)
{
	int i;
	for (i=0;i<MAX_SUB_IOCTL_NUM;i++)
		if(oid_t[i].oid==n) return oid_t[i].ioctl;
	return -1;
}




int ioctl2oid(int n)
{
	int i;
	for (i=0;i<MAX_SUB_IOCTL_NUM;i++)
		if(oid_t[i].ioctl==n) return oid_t[i].oid;
	return -1;
}

#endif
