
/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2001, 2006
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
#define MODULE

#include "linux/kernel.h"
#include "linux/module.h"
# licensee.support@conexant.com
# ##########################################################################*/

#define MODULE

#include "linux/kernel.h"
#include "linux/module.h"
#include <linux/types.h> //for dev_t
#include <linux/fs.h> // for alloc_chrdev_region
#include <linux/kdev_t.h> //for MAJOR and MINOR macros
#include <linux/cdev.h> //for cdev

#include "bun_if_char_module.h"
#include "bun_if_char.h"
#define DBG(x...) printk(x)

static int __init bun_if_char_module(void);
static int bun_if_ioctl(struct inode *inode,struct file *file,unsigned int cmd,unsigned long arg);


static dev_t bdev;
static struct file_operations bfops = {
	.owner = THIS_MODULE,
	.ioctl = bun_if_ioctl,
};
static struct cdev *bcdev;
#define DRIVER_NAME "drv-ctl"

int (*DSLattrib)(char *string,char *ret) = NULL;
EXPORT_SYMBOL(DSLattrib);


static int bun_if_ioctl(struct inode *inode,struct file *file,unsigned int cmd,unsigned long arg)
{
	dslattrib_t *t = (dslattrib_t *) arg;
	switch(cmd) {
		case DSLATTRIBGET:
			if(!DSLattrib) {
				DBG("------> EMPTY\n");
			}
			else {
				DSLattrib(t->cmd,t->value);
			}
			break;

		case DSLATTRIBSET:
			if(!DSLattrib) {
				DBG("------> EMPTY\n");
			}
			else {
				DSLattrib(t->cmd,t->value);
			}
			break;

		case DSLATTRIBLIST:
			if(!DSLattrib) {
                                DBG("------> EMPTY\n");
                        }
                        else {
				DSLattrib(t->cmd,t->value);
			}
			break;

		case VECTATTRIBGET:
                        if(!DSLattrib) {
                                DBG("------> EMPTY\n");
                        }
                        else {
                                DSLattrib(t->cmd,t->value);
                        }
                        break;
		case VECTATTRIBSET:
                        if(!DSLattrib) {
                                DBG("------> EMPTY\n");
                        }
                        else {
                                DSLattrib(t->cmd,t->value);
                        }
                        break;


		default:
			DBG("DEFAULT\n");			
	}
	return 0;
}

static int __init bun_if_char_module(void)
{
	//DBG("%s Starting \n",__FUNCTION__);

 	if(alloc_chrdev_region(&bdev,0,5,(char *)DRIVER_NAME)) {
		printk("alloc_chrdev_region failed\n");
		return -1;
	}
	DBG("DRV-CTL : Major : %d Minor : %d\n",MAJOR(bdev),MINOR(bdev));

	//registering cdev
	bcdev = cdev_alloc();
	bcdev->ops = &bfops;
	if (cdev_add(bcdev,bdev,1) < 0) {
		printk("cdev_add failed\n");
		return -1;
	}
		
	
			
	return 0;
}


module_init(bun_if_char_module);

