/* ###########################################################################
# (c) Copyright Conexant Systems, Inc. 2006
# (c) Copyright GlobespanVirata, Inc., 1997-2004
#
# Conexant Systems, Inc. Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc. and its subsidiaries (collectively 
# "Conexant"). It may only be read, used, copied, adapted, modified or 
# otherwise dealt with by you if you have entered into a license agreement 
# with Conexant and then subject to the terms of that agreement and any other
# applicable confidentiality agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a license agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

/**@file       cnxt_hsl_port.h  
*  @brief      Linux interface code.
*  @ingroup    message
*  
* This file contains header files & constants of 3rd os [shim layer 
* for Linux kernel interface]. 
*/

#ifndef CNXT_HSL_PORT_H
#define CNXT_HSL_PORT_H
#ifndef MODULE
#define MODULE
#endif
#ifndef EXPORT_SYMTAB
#define EXPORT_SYMTAB
#endif
#include <linux/ctype.h>
#include <linux/module.h> 
#include <linux/wait.h>
#include <linux/interrupt.h> /* used for tasklet creations etc */
 
#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/poll.h>
#include <linux/netdevice.h>
#include <linux/if_arp.h>
#include <linux/etherdevice.h>
#include <linux/if_ether.h>
#include <linux/config.h>
#include <linux/signal.h>
 
#define CNXT_HSL_TASK_RUNNING          TASK_RUNNING
#define CNXT_HSL_TASK_INTERRUPTIBLE    TASK_INTERRUPTIBLE
#define CNXT_HSL_TASK_UNINTERRUPTIBLE  TASK_UNINTERRUPTIBLE
#define CNXT_HSL_TASK_STOPPED          TASK_STOPPED
#define CNXT_HSL_TASK_TRACED           TASK_TRACED
#define CNXT_HSL_EXIT_ZOMBIE           EXIT_ZOMBIE
#define CNXT_HSL_EXIT_DEAD             EXIT_DEAD

#endif /* CNXT_HSL_PORT_H */
