/* ###########################################################################
# (c) Copyright Virata Limited 1998
#
# Virata Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Virata Limited ("Virata").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Virata and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Virata.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Virata.  If you have not entered into a
# confidentiality agreement with Virata granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Virata.
#
# Virata reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@virata.com
# ##########################################################################*/


#ifndef _QUANTUM_HF_INTERRUPT_H
#define _QUANTUM_HF_INTERRUPT_H

/** @file   lx_interrupt.h
 *  @brief  Linux interrupt definitions.
 */

/** Interrupt object version code.
 */
#define kHFInterruptVersion     100

/* Include the actual IRQ numbers for the hardware.h" */
#include "hw_interrupt.h"


#if defined (HF_ASSEMBLER_INCLUDE)
/* --------------------------------------------------------------------------
 *
 *              Assembler specific declarations
 *
 * --------------------------------------------------------------------------
 */

/* Assembler version of the interrupt object.
 */
#include "quantum/hs_interface.h"

                        macro
$name                   sHSInterrupt
$(name)
$(name).interface       sHSInterface
$(name).object          ds  1
$(name).source          ds  1
$(name).gpio_sense      ds  1
$(name).gpio_hw_register ds 1
$(name).gpio_hw_mask    ds  1
$(name).gpio_hw_enable  ds  1
$(name).gpio_hw_disable ds  1
$(name)_size            equ *-$(name)
                        mend

                dorg    0
tHSInterrupt    sHSInterrupt

#else /* defined HF_ASSEMBLER_INCLUDE */

/* --------------------------------------------------------------------------
 *
 *              C specific declarations
 *
 * --------------------------------------------------------------------------
 */

#include "quantum/hs_interrupt.h"
#include "quantum/hs_interface.h"

/* APIs interfacing with the assembler code in hf_arm.s
 */
extern void hf_ArmAbortSetInterface(int source, tHSInterface interface);


typedef void (*linux_handler)( int irq, void *context, struct pt_regs *regs);

extern int lx_IRQClaim( int, linux_handler, int, const char *, void *);

#endif /* defined HF_ASSEMBLER_INCLUDE */

#endif  /* _QUANTUM_HF_INTERRUPT_H */
