/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2001, 2004
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

#define MODULE
#define EXPORT_SYMTAB
#include "linux/kernel.h"
#include "linux/module.h"
#include "linux/completion.h"
#include "linux/sched.h"
#include "lx_module.h"
#include <linux/crypto.h>

#include "lx_shim_fp.h"
#include "lx_shim_defines.h"

#if 1
/* There isn't a libc, and depending on toolchain we 
 * may need a reference to this. It doesn't do anything. */
extern void __gccmain(void);

void __gccmain(void)
{
  return;
}

EXPORT_SYMBOL(__gccmain);
#endif

/* Export the hsl shim function pointers! These function 
 * pointers gets initialised in the init module function 
 * of hsl_mod.o
 */

EXPORT_SYMBOL(hsl_ObjectNew);
EXPORT_SYMBOL(hsl_ObjectNewAlloc);
EXPORT_SYMBOL(hsl_ObjectListSet);
EXPORT_SYMBOL(hsl_ObjectDelete);
EXPORT_SYMBOL(hsl_ObjectEnable);
EXPORT_SYMBOL(hsl_ObjectSetTypeHandle);
EXPORT_SYMBOL(hsl_ObjectHandle);
EXPORT_SYMBOL(hsl_ObjectFromAlloc);
EXPORT_SYMBOL(hsl_ObjectOpen);
EXPORT_SYMBOL(hsl_ObjectClose);
EXPORT_SYMBOL(hsl_ObjectMkdir);
EXPORT_SYMBOL(hsl_ObjectTypeHandle);
EXPORT_SYMBOL(hsl_ObjectIsEnabled);
EXPORT_SYMBOL(hsl_ObjectTypeRegisterSimple);
EXPORT_SYMBOL(hsl_ObjectTypeRegisterDerived);
EXPORT_SYMBOL(hsl_ObjectTypeRegisterBase);
EXPORT_SYMBOL(hsl_UartWriteByte);
EXPORT_SYMBOL(hsl_ObjectTypeRegisterCast);
EXPORT_SYMBOL(hsl_ObjectTransmute);
EXPORT_SYMBOL(hsl_InterfaceInit);
EXPORT_SYMBOL(hsl_DebugRegisterCommands);
EXPORT_SYMBOL(hsl_StrSkip);
EXPORT_SYMBOL(hsl_hw_TimerInterruptEnable);
EXPORT_SYMBOL(hsl_hw_startup);
EXPORT_SYMBOL(hsl_hw_systemFigureOutChipType);
EXPORT_SYMBOL(hsl_hw_systemBenchmarkCPU);
EXPORT_SYMBOL(hsl_TaskStart);
EXPORT_SYMBOL(hsl_MemRegionNew);
EXPORT_SYMBOL(hsl_MemRegionClose);
EXPORT_SYMBOL(hsl_InterfaceOpen);
EXPORT_SYMBOL(hsl_MemSync);
EXPORT_SYMBOL(hsl_MessageFree);
EXPORT_SYMBOL(hsl_MessageReply);
EXPORT_SYMBOL(hsl_Debug);

#include "quantum/hs_interface.h"
EXPORT_SYMBOL(hs_InterfaceOpen);
EXPORT_SYMBOL(hs_InterfaceNew);
EXPORT_SYMBOL(hs_InterfaceClose);
EXPORT_SYMBOL(hs_InterfaceLibraryInitialise);

#include "quantum/hs_interrupt.h"
EXPORT_SYMBOL(hs_InterruptLibraryInitialise);

#include "quantum/hs_message.h"
#include "quantum/hs_messagehdr.h"
#include "quantum/hs_pool.h"
EXPORT_SYMBOL(hs_MessageFree);
EXPORT_SYMBOL(hs_MessageReply);
EXPORT_SYMBOL(hs_MessageSend);
EXPORT_SYMBOL(hs_MessageMapBytes);
EXPORT_SYMBOL(hs_MessageMapStructure);
EXPORT_SYMBOL(hs_MessageGet);
EXPORT_SYMBOL(hs_MessagePut);
EXPORT_SYMBOL(hs_MessageSetCode);
EXPORT_SYMBOL(hs_MessageCode);
EXPORT_SYMBOL(hs_MessageWait);
EXPORT_SYMBOL(hs_MessageLength);
EXPORT_SYMBOL(hs_MessageSetLength);
EXPORT_SYMBOL(hs_MessageStatus);
EXPORT_SYMBOL(hs_MessageSetStatus);
EXPORT_SYMBOL(hs_MessagePass);
EXPORT_SYMBOL(hs_MessageAllocGet);
EXPORT_SYMBOL(hs_MessageAllocGetData);
EXPORT_SYMBOL(hs_MessageAllocGetControl);
EXPORT_SYMBOL(hs_MessageParameter1);
EXPORT_SYMBOL(hs_MessageParameter2);
EXPORT_SYMBOL(hs_MessageSetContext1);
EXPORT_SYMBOL(hs_MessageSetParameter1);
EXPORT_SYMBOL(hs_MessageContext1);
EXPORT_SYMBOL(hs_MessageSetParameter2);
EXPORT_SYMBOL(hs_MessagePostfix);
#ifndef QUANTUM_LEAN
EXPORT_SYMBOL(hs_MessageCut);
#endif
EXPORT_SYMBOL(hs_MessageRead);
EXPORT_SYMBOL(hs_MessageWrite);
EXPORT_SYMBOL(hs_MessagePriority);
EXPORT_SYMBOL(hs_MessageSetPriority);
EXPORT_SYMBOL(hs_MessageLibraryInitialise);
EXPORT_SYMBOL(hs_PoolOpen);
EXPORT_SYMBOL(hs_PoolNew);
EXPORT_SYMBOL(hs_PoolLibraryInitialise);
EXPORT_SYMBOL(hs_PoolDelete);

#include "quantum/hs_system.h"
EXPORT_SYMBOL(hs_SystemRestart);
EXPORT_SYMBOL(hs_SystemLibraryInitialise);

#include "quantum/hs_uart.h"
EXPORT_SYMBOL(hs_UartInitialise);

#include "quantum/hs_task.h"
EXPORT_SYMBOL(hs_TaskCurrent);
EXPORT_SYMBOL(hs_TaskCurrentSecondary);
EXPORT_SYMBOL(hs_TaskCurrentPrimary);
EXPORT_SYMBOL(hs_TaskRelinquish);
EXPORT_SYMBOL(hsi_TaskRegisterEntry);
EXPORT_SYMBOL(hs_TaskDesynchronize);
EXPORT_SYMBOL(hs_TaskSynchronize);
EXPORT_SYMBOL(hs_TaskPrimary);
EXPORT_SYMBOL(hs_TaskSchedulerStart);
#ifdef SOLOS_WITH_SIMI
EXPORT_SYMBOL(hs_TaskDelete);
#endif

EXPORT_SYMBOL(hs_TaskPoolGeneric);
EXPORT_SYMBOL(hs_TaskPoolData);
EXPORT_SYMBOL(hs_TaskPoolControl);
EXPORT_SYMBOL(hs_TaskStart);
EXPORT_SYMBOL(hs_TaskNew);
EXPORT_SYMBOL(hs_TaskLibraryInitialise);
EXPORT_SYMBOL(hs_TaskObject);

#include "quantum/hs_semaphore.h"
EXPORT_SYMBOL(hs_SemaphorePost);
EXPORT_SYMBOL(hs_SemaphoreWait);
EXPORT_SYMBOL(hs_SemaphoreDelete);
EXPORT_SYMBOL(hs_SemaphoreLibraryInitialise);
EXPORT_SYMBOL(hs_SemaphoreNew);
//EXPORT_SYMBOL(hs_SemaphoreTry);
#include "quantum/hs_timer.h"
EXPORT_SYMBOL(hs_TimerWait);
EXPORT_SYMBOL(hs_TimerDelay);
EXPORT_SYMBOL(hs_TimerDelayCancel);
EXPORT_SYMBOL(hs_TimerSeconds);
EXPORT_SYMBOL(hs_TimerClock);
EXPORT_SYMBOL(hs_TimerLibraryInitialise);
#include "quantum/hs_mem.h"
EXPORT_SYMBOL(hs_MemAlloc);
EXPORT_SYMBOL(hs_MemInitialiseShared);
EXPORT_SYMBOL(hs_MemAllocCommon);
EXPORT_SYMBOL(hs_MemFree);
EXPORT_SYMBOL(hs_MemFreeCommon);
EXPORT_SYMBOL(hs_MemLibraryInitialise);
extern unsigned long temp_pa( void* ph);
void atmos_round_robin(void);
EXPORT_SYMBOL(temp_pa);
EXPORT_SYMBOL(atmos_round_robin);


/* Some ATMOS-1 compatibility can be provided */
#ifdef LX_HAVE_MICROLS
#include "kernel.h"
#include "lx_microls.c"
#endif

#include "linux/proc_fs.h"


void atmos_round_robin(void)
{
   int i = 0;
   for( i = 0 ; i <= 1000; i++);
}

/* Allow external modules to create entries under /proc/quantum */
extern struct proc_dir_entry *quantum_dir;
EXPORT_SYMBOL(quantum_dir);
#ifdef PROC_DSL_APP 
extern struct proc_dir_entry *adsl_dir;
EXPORT_SYMBOL(adsl_dir);
#endif

/*
 * Error : For 2.6 kernel module support
 * Warning : static declaration for `init_module' follows non-static
 */

static int __init lx_init_module(void)
{
 return 0;
}

static void __exit lx_exit_module(void)
{
}

/*
 * Error : For 2.6 kernel module support
 * Warning : static declaration for `init_module' follows non-static
 */
module_init(lx_init_module);
module_exit(lx_exit_module);
