/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2001, 2006
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/


#ifndef SHIM_XS_H
#define SHIM_XS_H

extern int (*hsl_ObjectNew)( void** pObject, const char* pszName,
        const char* pszDefaults, void* pHandle, unsigned int type,
           void *owner);

extern int (*hsl_ObjectNewAlloc)(void** pObject, void* pszName, void** pMem,
           unsigned int memsize, unsigned int type, void* owner);

extern int (*hsl_ObjectListSet)(void *object, const char* pszList, 
        const char** ppszError);

extern int (*hsl_ObjectDelete)(void *object, void *caller);

extern int (*hsl_ObjectEnable)(void *object);

extern int (*hsl_ObjectSetTypeHandle)(void *object, unsigned int type, 
        void *handle);

extern void* (*hsl_ObjectHandle)(void *object);

extern void *(*hsl_ObjectFromAlloc)(void *memObjAlloc);

extern int (*hsl_ObjectOpen)(void ** pObject, const char* pszName, 
        unsigned int type, void **caller);

extern int (*hsl_ObjectClose)(void *object, void *caller);

extern int (*hsl_ObjectMkdir)(const char* pszName, void* owner);

extern int (*hsl_ObjectTypeHandle)(void *object, unsigned int type,
                                          void **pHandle);


extern int (*hsl_ObjectIsEnabled)(void *object);


extern int (*hsl_ObjectTypeRegisterSimple)( const unsigned int type, 
        const char* pszName, const int version, 
        void *pKeys, void *pfNew, void *pfDelete);

extern int (*hsl_ObjectTypeRegisterDerived)(unsigned int type, 
        const char* pszAbout, const int version, 
        void *keys, unsigned int base);

extern int (*hsl_ObjectTypeRegisterBase)(unsigned int type, 
        const char* pszAbout, const int version, void *keys);

extern void (*hsl_UartWriteByte)(int uart, unsigned char code);


extern int (*hsl_ObjectTypeRegisterCast)( unsigned int type, 
        const char* pszAbout, const int version, void *keys, 
        void *pfNew, void *pfDelete, unsigned int base);

extern int (*hsl_ObjectTransmute)(void *object, unsigned int type);
    
extern int (*hsl_InterfaceInit)(void *txif, void *object, 
        void *pfTransfer, void *route);

extern void (*hsl_DebugRegisterCommands)(const char* pszPrefix, 
        void * pCommands);

extern char* (*hsl_StrSkip)(const char* source);

extern int (*hsl_hw_TimerInterruptEnable)( unsigned int baseFrequency );

extern void (*hsl_hw_startup)(void );

extern void (*hsl_hw_systemFigureOutChipType)(char *name, unsigned int *chipId, 
        unsigned int *chipVersion);

extern unsigned int (*hsl_hw_systemBenchmarkCPU)(void);


extern int (*hsl_TaskStart)(void *task);

extern int (*hsl_MemRegionNew)(void *pRegion, const char *name, 
        void *vaddr, unsigned int size, const char *properties);

extern int (*hsl_MemRegionClose)(void *region);

extern int (*hsl_InterfaceOpen)(void ** pInterface, const char* name);

extern void (*hsl_MemSync)(void* vaddr, unsigned int size);

extern void (*hsl_MessageFree)(void *msg);

extern int (*hsl_MessageReply)(void *msg);

extern void (*hsl_Debug)(const char* pszReason);
    
extern int (*hsl_ObjectDelete)(void *object, void *caller);

extern void *(*hsl_ObjectFromAlloc)(void *memObjAlloc);

#endif /* SHIM_XS_H */

