/* ###########################################################################
# (c) Copyright Virata Limited 2001
#
# Virata Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Virata Limited ("Virata").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Virata and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Virata.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Virata.  If you have not entered into a
# confidentiality agreement with Virata granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Virata.
#
# Virata reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@virata.com
# ##########################################################################*/

#ifndef _QUANTUM_HS_ARM_H
#define _QUANTUM_HS_ARM_H


/*! \file       hs_arm.h
    \brief      ARM-specific services.
*/


#ifdef __cplusplus
extern "C" {
#endif

//#include "quantum/as_types.h"

/* Version information.
 */
#define kHSArmVersion  (100)     /**< Version number for the module */

/**
 * FIQ Registers
 */
typedef struct sARMFIQRegisters
{
    U32 r8;
    U32 r9;
    U32 r10;
    U32 r11;
    U32 r12;
    U32 r13;
} tARMFIQRegisters;

/**
 * FIQ Handler
 */
typedef void (*tARMFIQHandler)(void);     

/* Public prototypes.
 */
extern void arm_FIQCriticalEnd(U32);
extern U32  arm_FIQCriticalStart(void);
extern void arm_FIQInstall(tARMFIQHandler); 
extern void arm_FIQRegistersGet(tARMFIQRegisters *regs);
extern void arm_FIQRegistersSet(tARMFIQRegisters *regs);

#ifdef __cplusplus
}
#endif

#endif  /* defined _QUANTUM_HS_ARM_H */
