/* ###########################################################################
# (c) Copyright GlobespanVirata Inc. 2001, 2003
#
# GlobespanVirata Inc. Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to GlobespanVirata Inc. ("GlobespanVirata").  It may only be 
# read, used, copied, adapted, modified or otherwise dealt with by you if you 
# have entered into a confidentiality agreement with GlobespanVirata and then 
# subject to the terms of that confidentiality agreement and any other 
# applicable agreement between you and GlobespanVirata.  If you are in any 
# doubt as to whether you are entitled to access, read, use, copy, adapt, 
# modify or otherwise deal with the Software or whether you are entitled to 
# disclose the Software to any other person you should contact
# GlobespanVirata. If you have not entered into a confidentiality agreement
# with GlobespanVirata granting access to this Software you should forthwith
# return all media, copies and printed listings containing the Software to
# GlobespanVirata.
#
# GlobespanVirata reserves the right to take legal action against you should
# you breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@globespanvirata.com
# ##########################################################################*/

#ifndef _QUANTUM_HS_SYSTEM_H
#define _QUANTUM_HS_SYSTEM_H


/*! \file       hs_system.h
    \brief      Non-specific system services.
*/


#include "quantum/as_types.h" /* for tASErr */
#include "quantum/as_stdbool.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Version information.
 */
#define kHSSystemVersion  (100)     /**< Version number for the module */

/* Debugger access.
 */

#define _LINKAGE_hs_SystemLibraryInitialise	EXTERN
#define _LINKAGE_hs_SystemDebug	                EXTERN
#define _LINKAGE_hs_SystemRestart               EXTERN 

extern tASErr hs_SystemLibraryInitialise(void);
extern void hs_SystemDebug(const char* pszReason);
extern void hs_SystemRestart( void );

#ifdef __cplusplus
}
#endif

#endif  /* defined _QUANTUM_HS_TASK_H */
