/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2001, 2006
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

#include "quantum/xs_printf.h"
#include "quantum/xs_debug.h"
#include "quantum/xs_object.h"

int shim_ObjectNew(void** pObject, const char* pszName, const char* pszDefaults, 
        void* pHandle, unsigned int type, void *owner);

int shim_ObjectNewAlloc(void** pObject, void* pszName, void** pMem, U32 memsize, 
        unsigned int type, void* owner);
int shim_ObjectListSet(void* object, const char* pszList, const char** ppszError);
int shim_ObjectDelete(void *object, void *caller);
int shim_ObjectEnable(void *object);
int shim_ObjectSetTypeHandle(void *object, unsigned int type,
                                              void *handle);
void *shim_ObjectFromAlloc(void *memObjAlloc);
int shim_ObjectOpen(void ** pObject, const char* pszName, 
        unsigned int type, void **caller);
int shim_ObjectClose(void *object, void *caller);
int shim_ObjectMkdir(const char* pszName, void *owner);
int shim_ObjectTypeHandle(void *object, unsigned int type, void **pHandle);
int shim_ObjectTypeRegisterSimple( const unsigned int type, 
        const char* pszName, const int version, void *pKeys, void *pfNew, 
        void *pfDelete);
int shim_InterfaceInit(void *txif, void *object, void *pfTransfer, 
        void *route);
void* shim_ObjectHandle(void *object);
int shim_ObjectIsEnabled(void *object);
char* shim_StrSkip(const char* source);
void shim_DebugRegisterCommands(const char* pszPrefix,
                                             void * pCommands);
void shim_ObjectTypeRegisterDerived( unsigned int type, 
        const char* pszAbout, const int version, void *keys, 
        unsigned int base);
int shim_ObjectTypeRegisterBase( unsigned int type, const char* pszAbout, 
        const int version, void *keys);
void shim_UartWriteByte(int uart, unsigned char code);
int shim_ObjectTypeRegisterCast(
            unsigned int type, const char* pszAbout, const int version,
            void *keys,
            void *pfNew, void *pfDelete,
            unsigned int base);
int shim_ObjectTransmute(void *object, unsigned int type);
int shim_hw_TimerInterruptEnable( unsigned int baseFrequency );
void shim_hw_startup(void );
void shim_hw_systemFigureOutChipType(char *name, unsigned int *chipId,
        unsigned int *chipVersion);
unsigned int shim_hw_systemBenchmarkCPU(void);
int shim_TaskStart(void *task);
int shim_MemRegionNew(void *pRegion, const char *name, void *vaddr, 
        unsigned int size, const char *properties);
int shim_MemRegionClose(void *region);
int shim_InterfaceOpen(void** pInterface, const char* name);
void shim_MemSync(void* vaddr, U32 size);
void shim_MessageFree(void *msg);
int shim_MessageReply(void *msg);
void shim_Debug(const char* pszReason);
