/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2003 - 2004
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

#include "quantum/as_types.h"
#include <linux/kernel.h>
#include <linux/module.h>
#include "linux/completion.h"
#include "linux/sched.h"
#include "linux/proc_fs.h"

#include "quantum/as_task.h"
#include "bun_channelattr.h"
#include "bun_channel.h"
#include "bun_proc.h"
#include "bun_port.h"
#include "config.h"
#include "led_if.h"
#define MODULE_LOAD_DELAY 1 /* no of seconds */
#include"cyanlib.h"
extern int bf_ether_ChannelTxPacket( void *pBuf, void *dev);

extern int bun_if_init_module(void);

/* This gets linked onto the front of every ISOS loadable kernel
 * module that contains Quantum tasks. It provides an init_module()
 * function that registers all the task entry points with the 
 * Quantum infrastructure when the module is first loaded. */

/* This is a dummy entry that marks the start of the entry point list. */
/* Using common registration in init, and using common marker instead */
static tHSITaskEntryDefinition __quantum_task_marker __attribute__((section(".entrypoints"))) = 
{ kHSITaskEntryMagic, kHSITaskEntryMagic, "marker", {0}, &__quantum_task_marker}; 

int isos_bun_markeraddress = &__quantum_task_marker;
typedef int (*lx_kthread_entry)(void *);

/*
 * Error : For 2.6 kernel module support
 * Warning : static declaration for `init_module' follows non-static
 */
int task_glue_init_module( void )
{
  tHSITaskEntryDefinition *pEntry;
  char properties[128];
  tASTask task;
  tASErr err, rc;
  BOOL error;
  int pid;
  int done = 0;
  tASTask led_task_id;
  char attr[255];
  unsigned int delay;
  /* All the entry points are stuck in their own section, and if we linked 
   * the objects in the right order,__quantum_task_marker is the first 
   * element in that section, so we just iterate through the array. */
  pEntry = isos_bun_markeraddress;
  while( !done && pEntry->magic ==  kHSITaskEntryMagic )
    {
      switch( pEntry->type )
        {
        case kHSITaskEntryMagic:
        case kHSITaskEntryMain:
        case kHSITaskEntryPrologue:
        case kHSITaskEntryEpilogue:
        case kHSITaskEntryQHandler:
          break;
        default:
          printk("Unknown entry type found. Giving up!\n");
          done = 1;
          break;
        }
      if ( pEntry->type != kHSITaskEntryMagic )
    {
        hsi_TaskRegisterEntry( pEntry );
    }
      pEntry++;
    }

  error = bun_ProcPrologue(0, NULL);

  as_StrPrintf(properties, sizeof( properties ),
#ifndef QUANTUM_LEAN
        "main=%s/stack=2048/service=2/argument=%d",
        "bun.main",0);
#else
        "main=%s", "bun.main");
#endif
  rc = as_TaskNew(&task, "/task/bun", properties);
  if (kASEOK != rc)
  {
       printk("%C: Failed to create task bun rc=%d\n", rc );
       return rc;
   }

   rc = as_TaskStart(task);

   if (kASEOK != rc)
   {
        printk("%C: Failed to start task 0x%x rc=%d\n", task, rc );
        return( rc );
   }


//going to create led task from here
#ifndef QUANTUM_LEAN
  snprintf (attr, sizeof attr, "main=%s/stack=2048", "led.main");
#else
  snprintf (attr, sizeof attr, "main=%s", "led.main");
#endif
  err = as_TaskNew (&led_task_id, "/task/led", attr);
  if (err == kASEOK) err = as_TaskStart (led_task_id);
  if (err)
    {
        printk ("Couldn't start led task: err = %d, attr = '%s'\n", err, attr);
        return 0;
    }

#ifdef VOIP_ON_LINUX
   LVOICE_DriverInit();
#endif
#ifdef LINUX_USER_SPACE_LED_MODULE 
   //ledif_init();
#endif
#ifdef OAM_ON_LINUX
 oam_init_module();
 delay=jiffies + HZ *MODULE_LOAD_DELAY;
 while(time_before(jiffies,delay))
      cond_resched();
#endif
#ifdef BUN_IF_ON_LINUX
 bun_if_init_module();
 delay=jiffies + HZ *MODULE_LOAD_DELAY*2;
 while(time_before(jiffies,delay))
      cond_resched();
#endif

  return 0;
}

extern unsigned long simple_strtoul( const char * cp, char ** endp, unsigned int base);
/* wrapper for strtoul */
unsigned long strtoul( const char * cp, char ** endp, int base)
{
    /* simply call the linux simple_strtoul */
    simple_strtoul(cp, endp,base);
}

/* to find out y these functions are not getting including */
void skipsp(char **a)
{
    /*  kernel white-space skipping routine:
     *     skips over space and TAB
     *     updates `a' to point beyond space/TAB
     */

    while (**a == ' ' || **a == '\t')
    {
        (*a)++;
    }
}
