/* ###########################################################################
# (c) Copyright Conexant Systems, Inc 2003 - 2004
#
# Conexant Systems, Inc Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc ("Conexant"). It may only be read,
# used, copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to
# the terms of that confidentiality agreement and any other applicable
# agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a confidentiality agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

//#define MODULE
//#define EXPORT_SYMTAB

#include "quantum/as_types.h"
#include <linux/kernel.h>
#include <linux/module.h>
#include "quantum/as_task.h"
//#include "task_glue_np_module.h"

/* This gets linked onto the front of every ISOS loadable kernel
 * module that contains Quantum tasks. It provides an init_module()
 * function that registers all the task entry points with the 
 * Quantum infrastructure when the module is first loaded. */

/* This is a dummy entry that marks the start of the entry point list. */
//void *cyan_qPut_with_status(void *, void *); /* Dinesh for sdsp.asm */

/* This is a dummy entry that marks the start of the entry point list. */
static tHSITaskEntryDefinition __quantum_task_marker __attribute__((section(".entrypoints"))) = 
{ kHSITaskEntryMagic, kHSITaskEntryMagic, "marker", {0}, &__quantum_task_marker}; 

/*
 * Error : For 2.6 kernel module support
 * Warning : static declaration for `init_module' follows non-static
 */
int task_glue_np_init_module( void )
{
  tHSITaskEntryDefinition *pEntry;
  tASErr err;
  int done = 0;

  /* All the entry points are stuck in their own section, and if we linked 
   * the objects in the right order,__quantum_task_marker is the first 
   * element in that section, so we just iterate through the array. */
  pEntry = &__quantum_task_marker;
  while( !done && pEntry->magic ==  kHSITaskEntryMagic )
    {
      switch( pEntry->type )
        {
        case kHSITaskEntryMagic:
        case kHSITaskEntryMain:
        case kHSITaskEntryPrologue:
        case kHSITaskEntryEpilogue:
        case kHSITaskEntryQHandler:
          break;
        default:
          printk("Unknown entry type found. Giving up!\n");
          done = 1;
          break;
        }
      if ( pEntry->type != kHSITaskEntryMagic )
        hsi_TaskRegisterEntry( pEntry );

      pEntry++;
    }

  return 0;
}

//#include "cyanlib.h"
//EXPORT_SYMBOL(cyan_qPut_with_status);
//EXPORT_SYMBOL(cyan_qGet);
//EXPORT_SYMBOL(cyan_qPut);
//EXPORT_SYMBOL(cyan_qInit);
/*
 * Error : For 2.6 kernel module support
 */
//module_init(task_glue_np_init_module);
