/*
** Defines for the generic PHY registers
*/
#define PHY_CTL_REG                 0
#define PHY_STATUS_REG              1
#define PHY_ID_1_REG                0
#define PHY_ID_2_REG                1
#define PHY_REG_16                 16
#define PHY_REG_18                 18
#define PHY_REG_22                 22
#define PHY_REG_24                 24
#define PHY_REG_25                 25

/* Bit Settings for PHY_REG_16 */
#define PHY_REG16_DIS_8021Q_VLN     (0x0400) //Disable 802.1Q tag aware VLAN
#define PHY_REG16_DIS_VLN_IF        (0x0200) //Disable VLAN member set ingress f
iltering
#define PHY_REG16_DIS_VLN_CTRL      (0x0100) //Disable VLAN tag admit control
#define PHY_REG_16_SOFT_RESET       (0x1000) //SoftReset RTL8305SC

/* Bit Settings for PHY_REG_18 */
#define PHY_REG18_DIS_VLAN          (0x0100)//Disable VLAN


/* Bit Settings for PHY_REG_22 */
#define PHY_VLAN_TAG_CTRL_11        (0x0003)
#define PHY_VLAN_TAG_CTRL_10        (0x0002)
#define PHY_VLAN_TAG_CTRL_01        (0x0001)
#define PHY_VLAN_TAG_CTRL_00        (0x0000)
#define PHY_VLAN_TAG_CTRL_MASK      (0x0003)
/* Bit Settings for PHY_REG_24 */
#define  PHY_VLAN_INDEX_MASK        (0xF000) //Port n VLAN index[15:12]
#define  PHY_VLAN_ID_MB_MASK        (0x001F) //VLAN ID n Membership bit[4:0]

/* Bit Settings for PHY_REG_25 */
#define PHY_VLAN_ID_MASK            (0x0FFF)



