/* ###########################################################################
# (c) Copyright Conexant Limited 2006
#
# Conexant Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Limited ("Conexant").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Conexant.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Conexant.  If you have not entered into a
# confidentiality agreement with Conexant granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@conexant.com
# ##########################################################################*/

#include<linux/kernel.h>
#include<linux/slab.h>

#include "devapi.h"

unsigned long flags;

void* usb2_allocateFromHeap(unsigned int size, unsigned int alignment)
{
    uint_8 *ptr;
    int remainder;

    // The lame strategy here is to over-allocate a buffer, and then
    // shift the pointer to the next aligned value.  We are assuming
    // that the buffer will never need to be freed.

   /* see if memory is more than 4K then it will be in terms of pages */
    if ( size >=4096 )
       ptr = kmalloc(size,GFP_ATOMIC);
    else
    ptr = kmalloc(size + alignment,GFP_ATOMIC);

    if (ptr == NULL)
        return ptr;

    remainder = (int)ptr % alignment;
    if ( size < 4096 )
    {
    ptr += alignment - remainder;
    }

    // Place region in uncached memory
#ifdef _VIRT_MEM
    ptr = (uint_8 *)phys2virt(virt2phys(ptr)) ;
#else
    ptr += 0x20000000;
#endif

    return ptr;
}

void* _mem_alloc_system_zero(int n)
{
    void *ptr;
    ptr =  kmalloc((unsigned int)n, GFP_ATOMIC);
      if(ptr != NULL)
          memset(ptr,0, (unsigned int)n);
    return ptr;
}

void _mem_free(void *ptr)
{
    kfree(ptr);
}

void _mem_zero(void *ptr, int n)
{
    memset(ptr,0,(unsigned int)n);

}

void _mem_copy(void *src, void *dst, int n)
{
   memcpy(dst,src,(unsigned int)n);

}

void _int_disable(void)
{

    local_save_flags(flags);
    local_irq_disable();

}

void _int_enable(void)
{
   local_irq_restore(flags);
}



