/* ###########################################################################
# (c) Copyright Conexant Limited 2006
#
# Conexant Limited Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Limited ("Conexant").  It may only be read, used,
# copied, adapted, modified or otherwise dealt with by you if you have
# entered into a confidentiality agreement with Conexant and then subject to the
# terms of that confidentiality agreement and any other applicable agreement
# between you and Conexant.  If you are in any doubt as to whether you are
# entitled to access, read, use, copy, adapt, modify or otherwise deal with
# the Software or whether you are entitled to disclose the Software to any
# other person you should contact Conexant.  If you have not entered into a
# confidentiality agreement with Conexant granting access to this Software you
# should forthwith return all media, copies and printed listings containing
# the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you breach
# the above provisions.
#
# If you are unsure, or to report violations, please contact
# support@conexant.com
# ##########################################################################*/


#include<linux/config.h>

#if defined(CONFIG_ARCH_SOLOS_GALLUS) || defined(CONFIG_ARCH_SOLOSW_GALLUS)
#include<asm/arch/hardware.h>
#include<asm/arch/hardware.h>
#include<asm/memory.h>

#define AREA_TEST1 0xFFF00000
#define AREA_TEST2 0xFF000000
#endif

#if defined(CONFIG_ARCH_SOLOS_GALLUS) || defined(CONFIG_ARCH_SOLOSW_GALLUS)	
unsigned long virt2phys( void* ph)
{

   unsigned long p = (unsigned long)ph;
   unsigned long temp =0;

   if( p == 0)
   {
      return p;
   }

   temp = p & AREA_TEST1;
   
switch(temp)
 {
    case SOLOS_SRAM_VIRT:
            p = p - SOLOS_SRAM_VIRT + SOLOS_SRAM_PHYS;
          break;
    case  SOLOS_LAHB_VIRT:
          p = p - SOLOS_LAHB_VIRT + SOLOS_LAHB_PHYS;
         break;

    case  SOLOS_UAHB_VIRT:
	 p = p - SOLOS_UAHB_VIRT + SOLOS_UAHB_PHYS;
           break;

    default:
          if( (p & AREA_TEST2) == SOLOS_EPBMEM_VIRT)
            {
             p = p - SOLOS_EPBMEM_VIRT + SOLOS_EPBMEM_PHYS;
           }
           else
            {
       // it is sdram area
       if( (p & SOLOS_SDRAMU_VIRT) == SOLOS_SDRAMU_VIRT )
       {
          p = p - SOLOS_SDRAMU_VIRT + SOLOS_SDRAMU_PHYS;
       }
       else if( (p & 0xC0000000) == 0xC0000000 )
       {
          p = p - 0xC0000000 + SOLOS_SDRAMU_PHYS;
       }
       else
       {
         p = p;
        }
       }
          break;
   }
return p;

}



unsigned long phys2virt(unsigned long ptr)
{
        unsigned long p = (unsigned long) ptr ;

        if(!ptr) return ptr ;

        if(((p & SOLOS_SRAM_PHYS) == SOLOS_SRAM_PHYS)
                && ((p - SOLOS_SRAM_PHYS) < SOLOS_SRAM_MAP_SIZE)) {
                return (p - SOLOS_SRAM_PHYS + SOLOS_SRAM_VIRT) ;
        }
        else
        if(((p & SOLOS_SDRAMU_PHYS) == SOLOS_SDRAMU_PHYS)
                && ((p - SOLOS_SDRAMU_PHYS) < SOLOS_SDRAMU_MAP_SIZE)) {
                return (p - SOLOS_SDRAMU_PHYS + SOLOS_SDRAMU_VIRT) ;
        }
        else
        if(((p & SOLOS_UAHB_PHYS) == SOLOS_UAHB_PHYS)
                && ((p - SOLOS_UAHB_PHYS) < SOLOS_UAHB_MAP_SIZE)) {
                return (p - SOLOS_UAHB_PHYS + SOLOS_UAHB_VIRT) ;
        }
        else
        if(((p & SOLOS_LAHB_PHYS) == SOLOS_LAHB_PHYS)
                && ((p - SOLOS_LAHB_PHYS) < SOLOS_LAHB_MAP_SIZE)) {
                return (p - SOLOS_LAHB_PHYS + SOLOS_LAHB_VIRT) ;
        }
        else {
                return ptr ;
        }
return ptr;

}
#endif

