/*
 * linux/include/asm-arm/arch-cx2417x/hardware.h
 * (C) Conexant 2005
 */

#ifndef __ASM_ARCH_HARDWARE_H
#define __ASM_ARCH_HARDWARE_H

#define ASX0_BASE_PHYS	(0xE0400000)
/* The physical address is high enough not to clash with
 * the kernel mapping for any plausible amount of RAM */
#define ASX0_BASE_VIRT	(ASX0_BASE_PHYS)
#define ASX0_SIZE 	(0x100000)

#define SYSCTRL_BASE	(ASX0_BASE_VIRT)
#define SER_BASE_UART1  (ASX0_BASE_VIRT + 0x10000)
#define TIMER_BASE    	(ASX0_BASE_VIRT + 0x300000)
#define IRQ_CTL_BASE	(ASX0_BASE_VIRT + 0x500000)



#define SYSCTRL_SUSPEND	(SYSCTRL_BASE + 0x04)
#define	SYSCTRL_RESET	(SYSCTRL_BASE + 0x1c)

#define SER_STATUS_UART1 (SER_BASE_UART1 + 0x14)
#define SER_TX_FIFO_LOW  (0x20)


#define TIMER_VALUE_0	(TIMER_BASE + 0x00)
#define TIMER_LIMIT_0	(TIMER_BASE + 0x04)
#define TIMER_CTRL_0	(TIMER_BASE + 0x08)
#define TIMER_TIMEBASE_0	(TIMER_BASE + 0x0C)
#define TIMER_IRQS	(TIMER_BASE + 0x100)
#define TIMER_INT_EN	(1 << 3)
#define TIMER_RESET_CTR	(1 << 1)
#define TIMER_ENABLE	(1 << 0)
#define TIMER_BASE_FREQ	(54000000)


#define IRQ_EN_GRP1		(IRQ_CTL_BASE + 0x04)
#define IRQ_DST_GRP1		(IRQ_CTL_BASE + 0x00)
#define	IRQ_IRQ_GRP1		(IRQ_CTL_BASE + 0x08)
#define IRQ_STATCLR_GRP1	(IRQ_CTL_BASE + 0x10)

#define IRQ_EN_GRP2		(IRQ_CTL_BASE + 0x24)
#define IRQ_DST_GRP2		(IRQ_CTL_BASE + 0x20)
#define	IRQ_IRQ_GRP2		(IRQ_CTL_BASE + 0x28)
#define IRQ_STATCLR_GRP2	(IRQ_CTL_BASE + 0x30)

#endif
/* __ASM_ARCH_HARDWARE_H */

