
/*Header files */

#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include "atmstats.h"

/* Variables */
static struct ifreq ifr;
ATM_INTF_AAL5_AAL0_STATS  data_stats;  

/*Main routine*/
int main(int argc, char **argv)
{
  char vpi_vci[10];
  int fd = 0;
  int err = 0;
  memset(&ifr, 0, sizeof(ifr));

  if ( argc != 5 )
  {
   printf("Incorrect number of args\n");
   return;
  }
  *argv++;
  if (strcmp(*argv,"get")) 
  {
     printf("incorrect usage\n");
     return;
  }
  *argv++;
  if (strcmp(*argv,"atm")) 
  {   printf("incorrect usage\n");
      return;
  }
  *argv++;
  if (strcmp(*argv,"stats")) 
  {   printf("incorrect usage\n");
      return;
   }
  *argv++;
  strcpy(vpi_vci, *argv);
  fd = socket(AF_INET, SOCK_DGRAM, 0);
  if (fd < 0) {
        printf("atmctl: Cannot open socket");
        return -1;
    }
  strcpy(ifr.ifr_name, vpi_vci);
  ifr.ifr_data = &data_stats;
  err = ioctl(fd, ATM_IOC_GET_AAL5_STATS, &ifr);
  if ( err < 0 )
     printf("ioctl returned error:%d\n",err);
  else
  { 
    printf("\n\tRecieve Stats\n");
    printf("\tGood bytes rcvd:%d\n",data_stats.ulIfInOctets);
    printf("\tGood packets rcvd:%d\n",data_stats.ulIfInUcastPkts);
    printf("\tErrored packets rcvd:%d\n\n",data_stats.ulIfInErrors);
    printf("\tTransmit Stats\n");
    printf("\tTotal bytes sent:%d\n",data_stats.ulIfOutOctets);
    printf("\tTotal packets sent:%d\n",data_stats.ulIfOutUcastPkts);
    printf("\tErrored packets sent:%d\n",data_stats.ulIfOutErrors);
  }  
  close(fd);
 
     

}

