.\"
.\" "$Id: cupstestdsc.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $"
.\"
.\"   cupstestdsc man page for the Common UNIX Printing System (CUPS).
.\"
.\"   Copyright 2006 by Easy Software Products.
.\"
.\"   These coded instructions, statements, and computer programs are the
.\"   property of Easy Software Products and are protected by Federal
.\"   copyright law.  Distribution and use rights are outlined in the file
.\"   "LICENSE.txt" which should have been included with this file.  If this
.\"   file is missing or damaged please contact Easy Software Products
.\"   at:
.\"
.\"       Attn: CUPS Licensing Information
.\"       Easy Software Products
.\"       44141 Airport View Drive, Suite 204
.\"       Hollywood, Maryland 20636 USA
.\"
.\"       Voice: (301) 373-9600
.\"       EMail: cups-info@cups.org
.\"         WWW: http://www.cups.org
.\"
.TH cupstestdsc 1 "Common UNIX Printing System" "20 March 2006" "Easy Software Products"
.SH NAME
cupstestdsc \- test conformance of postscript files
.SH SYNOPSIS
.B cupstestdsc
[ -h ] filename.ps [ ...
.I filenameN.ps
]
.br
.B cupstestdsc
[ -h ] -
.SH DESCRIPTION
\fIcupstestdsc\fR tests the conformance of PostScript files to
the Adobe PostScript Language Document Structuring Conventions
Specification version 3.0. The results of testing and any other
output are sent to the standard output. The second form of the
command reads PostScript from the standard input.
.SH LIMITATIONS
\fIcupstestdsc\fR only validates the DSC comments in a PostScript
file and does not attempt to validate the PostScript code itself.
Developers must ensure that the PostScript they generate follows
the rules defined by Adobe. Specifically, all pages must be
independent of each other, code outside page descriptions may not
affect the graphics state (current font, color, transform matrix,
etc.), and device-specific commands such as setpagedevice should
not be used.
.SH SEE ALSO
http://localhost:631/help
.br
Adobe PostScript Language Document Structuring Conventions
Specification, Version 3.0.
.SH COPYRIGHT
Copyright 2006 by Easy Software Products, All Rights Reserved.
.\"
.\" End of "$Id: cupstestdsc.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $".
.\"
