.\"
.\" "$Id: lpoptions.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $"
.\"
.\"   lpoptions man page for the Common UNIX Printing System (CUPS).
.\"
.\"   Copyright 1997-2006 by Easy Software Products.
.\"
.\"   These coded instructions, statements, and computer programs are the
.\"   property of Easy Software Products and are protected by Federal
.\"   copyright law.  Distribution and use rights are outlined in the file
.\"   "LICENSE.txt" which should have been included with this file.  If this
.\"   file is missing or damaged please contact Easy Software Products
.\"   at:
.\"
.\"       Attn: CUPS Licensing Information
.\"       Easy Software Products
.\"       44141 Airport View Drive, Suite 204
.\"       Hollywood, Maryland 20636 USA
.\"
.\"       Voice: (301) 373-9600
.\"       EMail: cups-info@cups.org
.\"         WWW: http://www.cups.org
.\"
.TH lpoptions 1 "Common UNIX Printing System" "20 March 2006" "Easy Software Products"
.SH NAME
lpoptions \- display or set printer options and defaults
.SH SYNOPSIS
.B lpoptions
[ -E ] [ -U
.I username
] [ -h
.I server[:port]
] -d
.I destination[/instance]
[ -o
.I option[=value]
] ... [ -o
.I option[=value]
]
.br
.B lpoptions
[ -E ] [ -U
.I username
] [ -h
.I server[:port]
] [ -p
.I destination[/instance]
] -l
.br
.B lpoptions
[ -E ] [ -U
.I username
] [ -h
.I server[:port]
] [ -o
.I option[=value]
] ... [ -o
.I option[=value]
] [ -p
.I destination[/instance]
] -r
.I option
.br
.B lpoptions
[ -E ] [ -U
.I username
] [ -h
.I server[:port]
] -x
.I destination[/instance]
.SH DESCRIPTION
\fIlpoptions\fR displays or sets printer options and defaults.
\fIlpoptions\fR shows the default printer options when run with no
arguments. Other options include:
.TP 5
-E
.br
Enables encryption when communicating with the CUPS server.
.TP 5
-U username
.br
Uses an alternate username.
.TP 5
-d destination[/instance]
.br
Sets the default printer to \fIdestination\fR. If \fIinstance\fR
is supplied then that particular instance is used. This option
overrides the system default printer for the current user.
.TP 5
-h server[:port]
.br
Uses an alternate server.
.TP 5
-l
.br
Lists the printer specific options and their current settings.
.TP 5
-o option[=value]
.br
Specifies a new option for the named destination.
.TP 5
-p destination[/instance]
.br
Sets the destination and instance, if specified, for any options
that follow. If the named instance does not exist then it is
created.
.TP 5
-r option
.br
Removes the specified option for the named destination.
.TP 5
-x destination[/instance]
.br
Removes the options for the named destination and instance, if
specified. If the named instance does not exist then this does
nothing.
.LP
If no options are specified using the \fI-o\fR option, then the
current options for the named printer are reported on the
standard output.
.LP
Options set with the \fIlpoptions\fR command are used by the
\fIlp(1)\fR and \fIlpr(1)\fR commands when submitting jobs.
.SH ROOT ACCOUNT OPTIONS
When run by the root user, \fIlpoptions\fR gets and sets default
options and instances for \fIall users\fR in the
/etc/cups/lpoptions file.
.SH COMPATIBILITY
The \fIlpoptions\fR command is unique to CUPS.
.SH FILES
~/.cups/lpoptions - user defaults and instances created by non-root
users.
.br
/etc/cups/lpoptions - system-wide defaults and instances
created by the root user.
.SH SEE ALSO
\fIcancel(1)\fR, \fIlp(1)\fR, \fIlpr(1)\fR,
.br
http://localhost:631/help
.SH COPYRIGHT
Copyright 1997-2006 by Easy Software Products, All Rights Reserved.
.\"
.\" End of "$Id: lpoptions.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $".
.\"
