.\"
.\" "$Id: lpr.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $"
.\"
.\"   lpr man page for the Common UNIX Printing System (CUPS).
.\"
.\"   Copyright 1997-2006 by Easy Software Products.
.\"
.\"   These coded instructions, statements, and computer programs are the
.\"   property of Easy Software Products and are protected by Federal
.\"   copyright law.  Distribution and use rights are outlined in the file
.\"   "LICENSE.txt" which should have been included with this file.  If this
.\"   file is missing or damaged please contact Easy Software Products
.\"   at:
.\"
.\"       Attn: CUPS Licensing Information
.\"       Easy Software Products
.\"       44141 Airport View Drive, Suite 204
.\"       Hollywood, Maryland 20636 USA
.\"
.\"       Voice: (301) 373-9600
.\"       EMail: cups-info@cups.org
.\"         WWW: http://www.cups.org
.\"
.TH lpr 1 "Common UNIX Printing System" "12 February 2006" "Easy Software Products"
.SH NAME
lpr \- print files
.SH SYNOPSIS
.B lpr
[ -E ] [ -H
.I server[:port]
] [ -U
.I username
] [ -P
.I destination[/instance]
] [ -#
.I num-copies
[ -h ] [ -l ] [ -m ] [ -o
.I option[=value]
] [ -p] [ -q ] [ -r ] [ -C/J/T
.I title
] [
.I file(s)
]
.SH DESCRIPTION
\fIlpr\fR submits files for printing. Files named on the command
line are sent to the named printer (or the system default
destination if no destination is specified). If no files are
listed on the command-line, \fIlpr\fR reads the print file from
the standard input.
.SH OPTIONS
The following options are recognized by \fIlpr\fR:
.TP 5
-E
.br
Forces encryption when connecting to the server.
.TP 5
-H server[:port]
.br
Specifies an alternate server.
.TP 5
-C "name"
.TP 5
-J "name"
.TP 5
-T "name"
.br
Sets the job name.
.TP 5
-P destination[/instance]
.br
Prints files to the named printer.
.TP 5
-U username
.br
Specifies an alternate username.
.TP 5
-# \fIcopies\fR
.br
Sets the number of copies to print from 1 to 100.
.TP 5
-h
.br
Disables banner printing. This option is equivalent to "-o
job-sheets=none".
.TP 5
-l
.br
Specifies that the print file is already formatted for the
destination and should be sent without filtering. This option is
equivalent to "-o raw".
.TP 5
-m
.br
Send an email on job completion.
.TP 5
-o option[=value]
.br
Sets a job option.
.TP 5
-p
.br
Specifies that the print file should be formatted with a shaded
header with the date, time, job name, and page number. This
option is equivalent to "-o prettyprint" and is only useful when
printing text files.
.TP 5
-q
.br
Hold job for printing.
.TP 5
-r
.br
Specifies that the named print files should be deleted after
printing them.
.SH COMPATIBILITY
The "c", "d", "f", "g", "i", "n", "t", "v", and "w" options
are not supported by CUPS and produce a warning message if used.
.SH SEE ALSO
\fIcancel(1)\fR, \fIlp(1)\fR, \fIlpq(1)\fR, \fIlprm(1)\fR,
\fIlpstat(1)\fR,
.br
http://localhost:631/help
.SH COPYRIGHT
Copyright 1997-2006 by Easy Software Products, All Rights Reserved.
.\"
.\" End of "$Id: lpr.man,v 1.1.1.1 2007-10-04 03:13:57 raul_xu Exp $".
.\"
