#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <bun_if_char.h>
#include "drvctl.h"

/*
*	Set Conexant Vector attribute for the portname specified and the attribute in the second parameter 
*/
int setCNXTvect(int fd,char *portname,char *attr)
{
	dslattrib_t att;

        memset(&att,0,sizeof(dslattrib_t));

	sprintf(att.cmd,"M%s:%s",portname,attr);

	return (ioctl(fd,VECTATTRIBSET,&att));
}
/*
*	Display Conexant Vector attribute for the portname and return the value in the third parameter
*/

int dispCNXTvect(int fd,char *portname,char *attr,char *value)
{
	dslattrib_t att;
        int ret=-1;

        memset(&att,0,sizeof(dslattrib_t));

	sprintf(att.cmd,"V%s:%s",portname,attr);

	ret = ioctl(fd,VECTATTRIBGET,&att);

	strcpy(value,att.value);

	return ret;
}
/*
*	List Conexant DSL attribute for the portname specified on the console
*/
int listCNXTattrib(int fd,char *portname)
{
	dslattrib_t att;
	int ret=-1;

	memset(&att,0,sizeof(dslattrib_t));

	sprintf(att.cmd,"L%s",portname);

	ret = ioctl(fd,DSLATTRIBLIST,&att);	

	return ret;
}
/*
 *	Function to get the DSL attribute for portname
 */
int getCNXTattrib(int fd,char *portname,char *attr,char *value)
{
	dslattrib_t att;
	int ret=-1;

	memset(&att,0,sizeof(dslattrib_t));

	sprintf(att.cmd,"D%s:%s",portname,attr);

	strncpy(att.attribute,attr,BUF_SIZE);

	ret = ioctl(fd,DSLATTRIBGET,&att);	

	strcpy(value,att.value);	

	return ret;
}

/*
 *	Function to set the DSL attribute for portname
 */
int setCNXTattrib(int fd,char *portname,char *attr)
{
	dslattrib_t att;
	int ret=-1;

	memset(&att,0,sizeof(dslattrib_t));

	sprintf(att.cmd,"S%s:%s",portname,attr);

	/*
	*	Find and set up the variables.
	*/
	{
		char *ptr = strchr(attr,':');
		if(!ptr) {
			//we did not find any : so exiting cleanly
			printf("Missing \":\" in arguments passed\n");
			return ret;
		}
		strncpy(att.attribute,attr,(int)(ptr - attr ));
		ptr++;
		strcpy(att.value,ptr);
	}

	ret = ioctl(fd,DSLATTRIBSET,&att);	

	return ret;
}

