#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/wait.h>


#include <dslconf.h>
#include <deltdiag.h>

int cnxtGetDslAttribute(char *attribute, char* out);
int cnxtSetDslAttribute(char *attribute , char *value);

CNXTDSL_STATUS cnxtStartOamTest(cnxtOamLoop_t *oamLoop)
{
  char sysCmd[512];
  int ret;
  char *oam_type[2] = {"etoe", "segment"};
  int oam_type_indx = 0;

  if(!strncmp(oamLoop->type, CNXT_OAMCLI_FLAGSTR_ETOE, 
		strlen(CNXT_OAMCLI_FLAGSTR_ETOE)))
  {
	oam_type_indx = 0;
  } 
  else if (!strncmp(oamLoop->type, CNXT_OAMCLI_FLAGSTR_SEGMENT, 
		strlen(CNXT_OAMCLI_FLAGSTR_SEGMENT)))
  {
	oam_type_indx = 1;
  }

  memset(sysCmd,0,512);
  sprintf(sysCmd, 
	  "echo \"loopset a1 %d %d %s %s \" > /proc/quantum/oam",
	  oamLoop->vpi, 
	  oamLoop->vci, 
	  !strncmp(oamLoop->flags, "f4", 2) ? "f4":"f5",
	  oam_type[oam_type_indx]);

  if((ret = system(sysCmd)) == -1)
	return -1;

  memset(sysCmd,0,512);
  sprintf(sysCmd, 
	  "echo \"loopsend a1 %d %d %d %d %s %s \" > /proc/quantum/oam",
	  oamLoop->numRepetitions,
	  oamLoop->timeout, 
	  oamLoop->vpi, 
	  oamLoop->vci,
	  !strncmp(oamLoop->flags, "f4", 2) ? "f4":"f5", 
	  oam_type[oam_type_indx]);

  if((ret=system(sysCmd))==-1)
	return -1;
  return 0;
}


CNXTDSL_STATUS cnxtGetOamTestResults(cnxtOamLoop_t *oamLoop)
{
  FILE *fp;
  int ret=0;
  char out[512];
  char *value_str;

  oamLoop->numRepetitions 	= 0;
  oamLoop->timeout			= 0;
  oamLoop->successCount 	= 0;
  oamLoop->failureCount 	= 0;
  oamLoop->avgRespTime 		= 0;
  oamLoop->minRespTime 		= 0;
  oamLoop->maxRespTime 		= 0;

  fp=fopen("/proc/quantum/oam", "r");
  memset(out,0,512);
  while(feof(fp)==0)
  {
	fgets(out,512,fp);

	if(strstr(out,"Repetitions"))
	{
	  value_str = strchr(out,':');
	  oamLoop->numRepetitions = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"Timeout"))
	{
	  value_str = strchr(out,':');
	  oamLoop->timeout = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"SuccessCount"))
	{
	  value_str = strchr(out,':');
	  oamLoop->successCount = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"FailureCount"))
	{
	  value_str = strchr(out,':');
	  oamLoop->failureCount = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"AverageResponseTime"))
	{
	  value_str = strchr(out,':');
	  oamLoop->avgRespTime = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"MinResponseTime"))
	{
	  value_str = strchr(out,':');
	  oamLoop->minRespTime = strtoul(value_str+1,NULL,0);
	}
	else if (strstr(out,"MaxResponseTime"))
	{
	  value_str = strchr(out,':');
	  oamLoop->maxRespTime = strtoul(value_str+1,NULL,0);
	}

	/*get the values for success and timeout and others values like above */

	fclose(fp);
	return ret;
  }
}

CNXTDSL_STATUS cnxtClearOamTest(cnxtOamLoop_t *oamLoop)
{
  char sysCmd[512];
  int ret;
  sprintf(sysCmd, 
	  "echo \"loopclear a1 %d %d %s \" > /proc/quantum/oam", 
	  oamLoop->vpi, 
	  oamLoop->vci,
	  !strncmp(oamLoop->flags, "f4", 2) ? "f4":"f5");

  if((ret=system(sysCmd)) == -1)
	return -1;
  return 0;
}

