#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

//#define DEBUG 1
#ifdef DEBUG
#define DbgPrint(x) printf x
#else
#define DbgPrint(x)
#endif

#define NVSSIZE 256
#define PDASIZE (8 * 1024)

extern void hex_dump(char *buf, unsigned int size) ;

unsigned int search_for_PDA(int fd)
{
int count = 0, i ;
unsigned short header, footer ;

	do {
		read(fd, &header, sizeof(short)) ;
		if(header == 0xdead) {
			DbgPrint(("Found header\n")) ;
			count = 0 ;
			do {
				read(fd, &footer, sizeof(short)) ;
				count++ ;
			}
			while(footer != 0xbeef && (count < 5000)) ; // PDA is expected in the next 8k range
			if(footer == 0xbeef) {
				count++ ;
				i = lseek(fd, (-2 * count), SEEK_CUR) ;
				DbgPrint(("found ftr %d %d\n", count, i)) ;
				return 1 ;
			} else {
				return 0 ;
			}
		}
	}
	while(count++ < 8192) ; // PDA is expected in 16k range
	return 0 ;
}


/* int main() */
int config_read(char* dev, char** buf, unsigned int* size) 
{
int fd ;

	/*
	 *	Allocating space for :
	 *	1. config offset pointer
	 *	2. NVS !! assuming 256 bytes
	 *	3. PDA 8K only
	 */
	if(!(*buf = (char*) calloc(sizeof(int) + NVSSIZE + PDASIZE, sizeof(char)))) {
		DbgPrint(("No memory\n")) ;
		return 1 ;
	}
	if((fd = open(dev, O_SYNC | O_RDONLY)) < 0) {
		DbgPrint(("error opening %s\n", dev)) ;
		return 1 ;
	}
	if(read(fd, *buf, sizeof(int) + NVSSIZE) != (sizeof(int) + NVSSIZE)) {
		DbgPrint(("error reading %s\n", dev)) ;
		close(fd) ;
		return 1 ;
	}

	if(search_for_PDA(fd)) {
                if(read(fd, *buf + sizeof(int) + NVSSIZE, PDASIZE) != PDASIZE) {
                        DbgPrint(("error reading %s\n", dev)) ;
                        close(fd) ;
                        return 1 ;
                }
		**buf = 0 ;
		*size = sizeof(int) + NVSSIZE + PDASIZE ;
                close(fd) ;
                return 0 ;
	} else {
		**buf = 0 ;
		*size = sizeof(int) + NVSSIZE ;
		close(fd) ;
		return 0 ; // Atleast NVS is there !!! keeping fingers crossed.
	}
}

