
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "flash_config.h"

#define RES_DEF_DEV "/dev/resdef"

int readNVSHeader(NVSHEADER *nvsHeader);
int writeNVSHeader(NVSHEADER *nvsHeader);

int main()
{
    NVSHEADER nvsHeader;
    int fd = -1;
    int retVal = 1;

    system("mount -t  proc proc proc");
    system("mknod /dev/resdef c 157 0");
    fd = open(RES_DEF_DEV, O_RDONLY, 0);
    if (fd < 0) {
        printf("\nCannot open device " RES_DEF_DEV "\n");
        goto EXIT;
    }
    if (readNVSHeader(&nvsHeader)) {
        printf("Cannot read NVS Header\n") ;
        goto EXIT;
    }
    // Turn ON net boot once
    nvs_SetFlags(&nvsHeader,
        nvs_GetFlags(&nvsHeader) | CI_NET_BOOT_FROM_FLASH_ONCE);
    if (writeNVSHeader(&nvsHeader)) {
        printf("Cannot read NVS Header\n") ;
        goto EXIT;
    }
    retVal = 0;

EXIT:
    if (fd >= 0)
        close(fd);

    return retVal;
}

