//############DEFINES SECTION###############

//#define DEBUG 1 
#ifdef DEBUG
#define DbgPrint(x) printf x
#else
#define DbgPrint(x)
#endif
#define OPT_GETCONFIG 1
/* Hard-coded limit that configinfo must appear within the first 512k
   of flash
*/

#define UID_SIZE        (8)     /* Size (bytes) of the UID field */
#define ESUCCESS 0
#define __LINUX__ 1
#define MAC_SIZE        (6)     /* Size (bytes) of the MAC address field */
#define IP_SIZE        (4)     /* Size (bytes) of the IP address field */
#define MSNL_SIZE       (4)     /* Size (bytes) of an MSNL address field */
#define NVSHEADER_VERSION   (0x01)     /* Structure version number */
#define TRUE        (1)

// CI_NET_BOOT_FROM_FLASH_ONCE is required when user does not have UART console and presses reset button
// for 8 secs, then this flag is set and system is re-booted. The PP BOOT Code will check this flag
// and clears it before jumping to np_neboot code for nwt wrok boot.
#define CI_NET_BOOT_FROM_FLASH_ONCE  0x01    /* Flag to BOOT ROM - attempt to network boot from flash boot ROM only once*/

//#define TEMP 1

#define solosW 1

#ifdef solosW

#define MAX_FLASH_WORDS (0x10000)
#define NVSHEADER_MAXSIZE  (0x100)   /* Maximum size */

extern const unsigned short magics[][2] ;

#define good_ftr(magic, i) (magics[(i)][1] == (magic))

#define COMMAND_LINE_SIZE 512
#ifndef U16
typedef unsigned short U16;
#endif

typedef struct {
	unsigned short magic ;
} configInfoHdr, configInfoFtr ;

typedef struct lx_cmdline_header{
  configInfoHdr hdr ;
  unsigned short flags;
}lx_cmdline_header;

typedef struct lx_cmdline_footer{
  configInfoFtr ftr ;
}lx_cmdline_footer;

#else

#define MAX_FLASH_WORDS (0x80000)
#define NVSHEADER_MAXSIZE  (0x10000)   /* Maximum size */
#define HEADER_MAGIC 0x5441
#define FOOTER_MAGIC 0x0001

#define COMMAND_LINE_SIZE 1024

typedef struct lx_cmdline_header{
  unsigned short magic;
  unsigned short flags;
}lx_cmdline_header;

typedef struct lx_cmdline_footer{
  unsigned short magic;
}lx_cmdline_footer;

#endif

#define NETBOOT_CMDLINE 0
#define FLASHBOOT_CMDLINE 1
#define NUM_BOOT_SOURCES 2

#define CMDLINEINFOSIZE (sizeof(lx_cmdline_header) + \
                         sizeof(lx_cmdline_data) + \
                        sizeof(lx_cmdline_footer))

#define CMDLINE_DATA_OFFSET(off) (off + sizeof(lx_cmdline_header))
#define CMDLINE_FOOTER_OFFSET(off) (CMDLINE_DATA_OFFSET(off) + sizeof(lx_cmdline_data))
#define CMDLINE_BOOTSRC_OFFSET(off, src) (CMDLINE_DATA_OFFSET(off) + (src * COMMAND_LINE_SIZE))

typedef struct lx_cmdline_data{
  char cmdline_strings[NUM_BOOT_SOURCES][COMMAND_LINE_SIZE];
}lx_cmdline_data;


typedef struct
{
    /* NVS CRC-16.  Calculated for the entire block, excluding the
     * CRC itself.
     */
    unsigned char crcLo;
    unsigned char crcHi;

    /* NVS Private control information.
     */
    unsigned char version;                 /* Structure version number */
    unsigned char sizeLo;                  /* Size of data area and header - 1 */
    unsigned char sizeHi;
    unsigned char reserved1[3];            /* Reserved - set zero */

    /* Public data fields.  Applications may directly manipulate
     * these entries.
     */
 unsigned char msnl[MSNL_SIZE];         /* MSNL address */
    unsigned char uid[UID_SIZE];           /* UID */
    unsigned char flags0;                  /* Misc bit flags */
    unsigned char flags1;                  /* Misc bit flags */
    unsigned char mac[MAC_SIZE];           /* MAC address */
    unsigned char ip[IP_SIZE];              /* IP Address */
    unsigned char reserved2[4];            /* Reserved - set zero */

} NVSHEADER;

#define NVS_VALID_SIZE(_s)  (((size_t)(_s)) >= sizeof(NVSHEADER)  &&  ((size_t)(_s)) <= (size_t)NVSHEADER_MAXSIZE)

#define NVS_SIZE(nvshdr) ((((nvshdr)->sizeHi << 8) | ((nvshdr)->sizeLo)) + 1)
extern U16 nvs_GetFlags(NVSHEADER *pHeader);
extern void nvs_SetFlags(NVSHEADER *pHeader, U16 configFlags);

