#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mount.h>
#include <sys/wait.h>
#include <sys/sysmacros.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>

#define MNT_DETACH 0x00000002 

#define DEBUG

extern int errno;

/* Global variables */
static const char proc_user_pid[64] = "proc/proc_turbo_user_pid";

static void turbo_op_showtime()
{
#ifdef DEBUG
    printf("DSL came up...\n");
#endif

}

static void turbo_op_training()
{
#ifdef DEBUG
    printf("DSL went down ....\n");
#endif
}

int main()
{
    int fd = -1;
    volatile int indx = -1, ii = 0, ret = 0;
    sigset_t set;
    int pid;
    int signal_var=0;
    pid_t my_pid=0;
    int op_state;
    char strline[256];


    //printf("---------------Making Daemon process-----------------------\n");    

    // create - fork 1
    if(fork()) return 0;

    // it separates the son from the father
    chdir("/");
    setsid();
    umask(0);

    pid = fork();

    if(pid)
    {
        return 0;
    }

    /* write the current process pid the proc entry */

    if((fd = open(proc_user_pid,O_RDWR)) == -1)
    {
        printf("Error opening file: %s, Ret: %d\n", proc_user_pid, fd);
        return;
    }

    sprintf(strline,"%s","16");

    close(fd);

    if((fd = open(proc_user_pid,O_RDWR)) == -1)
    {
        printf("Error opening file: %s, Ret: %d\n", proc_user_pid, fd);
        return;
    }

    // Lets loop around 
    while (1)
    {

        op_state =0;
        ret = 0;
        memset(strline,0,256);
        ret = read(fd, (char*)strline, (sizeof(strline)));
        op_state = strtol(strline, NULL, 10);
        if (op_state == 0x1)
            turbo_op_showtime();
        else
            turbo_op_training();

        close(fd);
        sleep(1);
        if((fd = open(proc_user_pid,O_RDONLY)) == -1)
        {
            printf("Error opening file: %s, Ret: %d\n", proc_user_pid, fd);
            return;
        }
    }
    printf("Exiting....");
}




