
/* ###########################################################################
# (c) Copyright Conexant Systems, Inc. 2005
# (c) Copyright GlobespanVirata, Inc., 1997-2005
#
# Conexant Systems, Inc. Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc. and its subsidiaries (collectively
# "Conexant"). It may only be read, used, copied, adapted, modified or
# otherwise dealt with by you if you have entered into a license agreement
# with Conexant and then subject to the terms of that agreement and any other
# applicable confidentiality agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a license agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/
/** @file    lvoice_potsim_isos.c
 *  @brief   pots simulator and runs on isos board  
 *  @ingroup linuxvoice/app_if
 */


#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <cyanlib.h>
#include <arpa/inet.h>

#include "ppots.h"
#include "vcore.h"
#include "lvoice_ioctl.h"


#define BASE_PORT 5500


#define PEER_LINUX_IP_ADDRESS "172.26.20.157"

unsigned int  lvoice_pPhone[10];
tASPool  pool;
int  lvoice_sock_addr[2];
char initialized = 0;
char task_info =0;
ATMOS_MSGQUEUE *lvoice_iface; 
#include "lvoice_sim_isos.h"

extern void lvoice_sim_store_phone ( unsigned int index, unsigned int value);
extern void lvoice_sim_audio_txcall1(CYANBUFFER *pBuffer, struct _iobuf *iobuf);
extern int lvoice_sim_process (int argc, char *argv[]);

extern void (*upperLayerEventCB)(CYANBUFFER* pCyanBuf, void* pUserId);
extern void (*upperLayerAudioCB)(CYANBUFFER* pCyanBuf, void* pUserId);

void lvoice_sim_store_phone ( unsigned int index, unsigned int value)
{
  if ( index >=10) /* no space */
  {
    kprintf("%s out of range\n",__FUNCTION__);
    return;

  }
  //kprintf("%s storing at index %d",__FUNCTION__, index);
  lvoice_pPhone[index]=value;
}




/**
 * Function for processing received AUDIO stream
 * Format of Audio
 *           int      portId;
 *           ---      Audio buffer          
 *  portID, timeStamp, seqNo, payloadType, payloadLen, payload 
 */
void lvoice_sim_process_audio(char *buffer,char bufSize)
{
   CYANBUFFER *pCyanBuf;
   int *pInt=(int *)buffer;

   unsigned int  upperLayerHandle;
   unsigned char index=0,i;
   int portId=0;
   char  *pData;
   tPOTS_Phone *pPhone;
   char  len;

   UNUSED(bufSize);
  /* allocate a cyan buffer from pool */
  if ( (pCyanBuf=(CYANBUFFER *)as_PoolGet(pool))==NULL)
  {

   kprintf("%s could not allocate message ", __FUNCTION__);
   return;

  }
  //kprintf ("\n\n");
  pData= (char*)(pCyanBuf->data);
  //kprintf ("length in audio buffer %d\n",  *(pInt + 4));
  cyan_bufSetLength(&pCyanBuf, *(pInt + 4));

  //kprintf ("CYAN BUFFER LENGTH %d\n", pCyanBuf->length);
  
  pCyanBuf->parameter1 = *(pInt + 1);
  pCyanBuf->parameter2 = *(pInt + 2);
  upperLayerHandle = *(pInt + 3);
   /* set the status */
  //pCyanBuf->parameter2 = lvoice_pPhone[pInt[index++]]; /* status handle */
  memcpy (pData, pInt + 5, pCyanBuf->length);
  
  upperLayerAudioCB (pCyanBuf, upperLayerHandle);
  //kprintf ("R");
}

/* Buffer format 
 *  portId, subCmd, arg0 and arg1 
 */


void lvoice_sim_process_event(char *buffer, char bufSize)
{
   CYANBUFFER *pCyanBuf;
   int *pInt=(int *)buffer, i;
   unsigned int userId, *pUserId;
   char  *pData=0, *pBuffData;
   
   unsigned char index=0;
  UNUSED(bufSize);
#if 1
  //kprintf("%s: Entered buffer = 0x%x, size = 0x%x \n", __FUNCTION__, buffer, bufSize);
#endif /* 1 */
  /* allocate a cyan buffer from pool */
  if ( (pCyanBuf=(CYANBUFFER *)as_PoolGet(pool))==NULL)
  {

   kprintf("%s could not allocate message ", __FUNCTION__);
   return;

  }
#if 0
  kprintf ("Parameter 1 = %x\n", *(pInt + 1));
  kprintf ("Parameter 2 = %x\n", *(pInt + 2));
  kprintf ("status = %x\n", *(pInt + 3));
  kprintf ("length = %x\n", *(pInt + 4));
#endif
  //kprintf ("lvoice_sim_process_event buffer::\n");
 // for (i = 0; i < 15; i ++)
  //    kprintf ("%x   ", pInt[i]);

  //kprintf ("\n\n");
  //cyan_bufSetLength(&pCyanBuf, sizeof(VCORE_Status));
  pData= (char*)(pCyanBuf->data);
  //kprintf ("length in buffer %d\n",  *(pInt + 4));
  //cyan_bufSetLength(&pCyanBuf, *(pInt + 4) - 4);
  cyan_bufSetLength(&pCyanBuf, *(pInt + 4));

  //kprintf ("CYAN BUFFER LENGTH %d\n", pCyanBuf->length);
  pUserId = pInt + 5;
  pBuffData = (char*)(((char *)pUserId) + pCyanBuf->length);
  
  //kprintf ("pBuffData = %x %x %x %x\n", pBuffData[0], pBuffData[1],pBuffData[2],pBuffData[3]);
  userId = *((int*)pBuffData);
  //kprintf ("User ID AFter manipulations %x\n", userId);
  pCyanBuf->parameter1 = *(pInt + 1);
  pCyanBuf->parameter2 = *(pInt + 2);
  pCyanBuf->status = *(pInt + 3);
   /* set the status */
  //pCyanBuf->parameter2 = lvoice_pPhone[pInt[index++]]; /* status handle */
  memcpy (pData, pInt + 5, pCyanBuf->length);
  //kprintf("%s : userId= 0x%x \n", __FUNCTION__, userId);
  //kprintf("Pushing message to voip proc \n");
  if ( !task_info )
  {
    //kprintf("%s: Retrieving task info \n",__FUNCTION__);
   lvoice_iface = findqueue("voip"); 

      //kprintf("%s : lvoice_iface = 0x%x \n", __FUNCTION__, lvoice_iface);
     task_info=1;
  }
  //upperLayerEventCB (pCyanBuf, userId);
  {
      ATMOS_MESSAGE *m = cyan_bufToMsg(pCyanBuf);
      //kprintf(" %s: m %x pCyanBuf %x \n",__FUNCTION__,m,pCyanBuf);
      sendmessage(m, MSG_N_CYAN_RECV,lvoice_iface); 
      //kprintf("%s: Message Send \n",__FUNCTION__);
      //kprintf("%s: param1 %x len %x data %x \n",__FUNCTION__,pCyanBuf->parameter1,
       //         pCyanBuf->length, pCyanBuf->data);
      //kprintf("%s data \n",__FUNCTION__); 
     // for ( i=0; i < pCyanBuf->length; i++ )
     // kprintf(" %x ", *(pCyanBuf->data + i));
      
  }
}
#if 0
void lvoice_sim_sig_txcall(CYANBUFFER *pBuffer, struct _iobuf *iobuf)
{

  int  buffer[100];
  unsigned char index=0,i;
  char length=cyan_bufLength(pBuffer);
  char *data = pBuffer->data;
  int rc = 0;
  struct sockaddr_in addr;
  char peerAddress[20];
  UNUSED(iobuf);
  
#if OS_HOSTED != LINUX
  //kprintf("%s : CYANBUFFER = 0x%x \n", __FUNCTION__, pBuffer);
#endif /* OS_HOSTED != LINUX */


  //kprintf("%s data %x \n",__FUNCTION__, *(pBuffer->data));
  if ( !initialized )
  {
    tASMessage msg = as_MessageAllocWaitControl();
    kprintf(" Not initialized, using getting socket address \n");

    rc = as_InterfaceOpen(&lvoice_iface, "/task/voicesim"); 
    if(kASEOK != rc)
    {
      kprintf("%s: as_InterfaceOpen returned rc = 0x%x, %s\n",__FUNCTION__, rc, as_StrErr(rc));
      as_MessageFree(msg);
      return;
    }
    
    kprintf("%s : lvoice_iface = 0x%x \n", __FUNCTION__, lvoice_iface);

     msg = as_InterfaceSendWait(lvoice_iface, msg);
     if(kASMessageInvalid == msg){
       kprintf("%s : as_InterfaceSendWait returned msg = 0x%x \n", __FUNCTION__, msg);
       return;
     } else kprintf("%s : SUCCESS : as_InterfaceSendWait returned msg = 0x%x \n", 
		    __FUNCTION__, msg);

    /* Before replying, the svdsp task put its size info into
     * parameter1
     */
    lvoice_sock_addr = as_MessageParameter1(msg);
    as_MessageFree(msg);
    initialized=1;
  }
  kprintf("%s : lvoice_sock_addr = 0x%x \n", __FUNCTION__, lvoice_sock_addr);
/* check if main process is initialized */
  /* fill the header  pr1 prm2 status  arg0 and arg1*/
  index++; /* Zeroth is reserved for total length */
  /* parameter1 contains port but that has to beconverted in logical port */
#if 0
  for ( i =0; i < 10; i++ )
  {
    if ( ((tPOTS_Phone*)(lvoice_pPhone[i]))->cmdHandle == (pBuffer->parameter1 &0xff) )
    {
      buffer[index++]=i;
      kprintf("%s : buffer[%d] = 0x%x \n",
	      __FUNCTION__, index - 1, buffer[index - 1]);
      break;
    }
  }
#endif

  buffer[index++]=pBuffer->parameter1;
  buffer[index++]=pBuffer->parameter2;
  buffer[index++]=pBuffer->status;
  buffer[index++]=(unsigned int) *(pBuffer->data);
  /* copy data portion */
#if 0
  for ( i=0; i < length; i++) 
  {
        buffer[index++]=(unsigned int)(*data++);
  } 
#endif
 /* set the length */
  buffer[0]= (5) * sizeof( int);


  strcpy(peerAddress, "172.26.20.157");
  memset(&addr,0,sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = inet_addr(peerAddress);
  addr.sin_port = htons(5500);       
  if (sendto(lvoice_sock_addr, buffer, buffer[0], 0, (struct sockaddr *)&addr,sizeof(addr)  )  < 0 )
  //if (send(lvoice_sock_addr[0], buffer, buffer[0], 0 )  < 0 )
    {
      kprintf("%s : Failed to send %s \n", __FUNCTION__, as_StrErr(_errno));
    }

  kprintf("%s send buffer len %d \n",__FUNCTION__, buffer[0]);
  kprintf("%s buffer \n");
  for (index=0; index < 10; index++ )
  {
   kprintf("%x:%x ",index, buffer[index]); 

  }

  cyan_bufRelease(pBuffer);
 

}
#endif


void lvoice_sim_audio_txcall(CYANBUFFER *pBuffer, struct _iobuf *iobuf)
{
  int  buffer[100], *pIntBuff;
  unsigned char index=0,i;
  char *data=pBuffer->data;
  char length= 40;//cyan_bufLength(pBuffer);
  struct sockaddr_in addr;


#if OS_HOSTED != LINUX
  //kprintf("%s : CYANBUFFER = 0x%x \n", __FUNCTION__, pBuffer);
#endif /* OS_HOSTED != LINUX */

  pIntBuff = (int*)buffer;

  pIntBuff[0] = pBuffer->parameter1;
  pIntBuff[1] = pBuffer->parameter2;
  pIntBuff[2] = iobuf;
  pIntBuff[3] = length;

  memcpy (buffer + 16, data, length);

  memset(&addr,0,sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = inet_addr("172.26.20.157");
  addr.sin_port = htons(5501);
  //kprintf ("Befor Sending.............\n");


  if (sendto(lvoice_sock_addr[1], buffer, 16 + length, 0,(struct sockaddr *)&addr,sizeof(addr) )  < 0 )
  {
   kprintf("%s : Failed to send %s", __FUNCTION__, as_StrErr(_errno));
  }
  //kprintf("%s send buffer len %d",__FUNCTION__, 16 + length);
 
 // kprintf ("S");
  cyan_bufRelease (pBuffer);
}
#if 0
void lvoice_sim_audio_txcall1(CYANBUFFER *pBuffer, struct _iobuf *iobuf)
{
  int  buffer[100];
  unsigned char index=0,i, *pCharBuffer;
  char *data=pBuffer->data;
  char length=cyan_bufLength(pBuffer);
  unsigned int *pIntBuff = (unsigned int *)buffer;

  /* fill the header  pr1 prm2 status  arg0 and arg1*/
  pIntBuff[index++]=pBuffer->parameter1;
  pIntBuff[index++]=pBuffer->parameter2;
  pIntBuff[index++]=iobuf;
  pIntBuff[index++]=pBuffer->length;

  /* copy data portion */
  pCharBuffer = (unsigned char *)pIntBuff[index];
  memcpy (pCharBuffer, data, pBuffer->length);
  
  if (send(lvoice_sock_addr, buffer, 16 + pBuffer->length, 0 )  < 0 )
  {
     kprintf("%s : Failed to send %s", __FUNCTION__, as_StrErr(_errno));
   
  }
  kprintf("%s send buffer len %d",__FUNCTION__, 16 + pBuffer->length);
}
#endif

void lvoice_sendandRecv_cmd(char *buffer, unsigned int len)
{
  struct sockaddr_in addr;
  int i;
  int rc = 0;

  //kprintf("%s  buffer %x buffer[0] %x len %x \n",__FUNCTION__,buffer, buffer[0], len);
  while ( !initialized ) 
  {
    //kprintf("%s socket is not yet open. opened it \n",__FUNCTION__);
    for ( i=0; i < 2 ; i++)
     {
      if ( (lvoice_sock_addr[i]=socket(AF_INET, SOCK_DGRAM, 0)) < 0)
      {
        kprintf("%s Failed to create socket:%s", __FUNCTION__,as_StrErr(_errno));
        break;
      }
      //kprintf("%s socket created %d \n",__FUNCTION__,lvoice_sock_addr);

      memset(&addr,0,sizeof(addr));
      addr.sin_family = AF_INET;
      addr.sin_addr.s_addr = htonl (INADDR_ANY);
      addr.sin_port = htons(5502+i);

      if ( bind(lvoice_sock_addr[i], (struct sockaddr*)&addr,sizeof(addr)) < 0 )
      {
         kprintf("%sFailed to bind socket:%s\n",__FUNCTION__, as_StrErr(_errno));
      }
      //kprintf("%s bind success  on port\n",__FUNCTION__);

     }
      initialized=1;
  }
  memset(&addr,0,sizeof(addr));
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = inet_addr("172.26.20.157");
  addr.sin_port = htons(5502);
  //kprintf ("Befor Sending.............\n");
  //for (i = 0 ; i< 10; i ++)
   //   kprintf ("%x  ", ((int*)buffer)[i]);
 // kprintf("\n");
  if (sendto(lvoice_sock_addr[0], buffer, len, 0, (struct sockaddr *)&addr,sizeof(addr)  )  < 0 )
    {
      kprintf("%s : Failed to send %s \n", __FUNCTION__, as_StrErr(_errno));
    }

    //kprintf("%s: Message send waiting for reply \n",__FUNCTION__);
 if ( recv(lvoice_sock_addr[0], buffer, len,0) < 0 ) /* read the len*/
     {
      kprintf("%s : Failed to recv %s \n", __FUNCTION__, as_StrErr(_errno));
     }
  //kprintf ("After recive.............\n");
  //for (i = 0 ; i< 10; i ++)
   //   kprintf ("%x  ", ((int*)buffer)[i]);
  //kprintf("\n");
}

