/* ###########################################################################
# (c) Copyright Conexant Systems, Inc. 2005
# (c) Copyright GlobespanVirata, Inc., 1997-2005
#
# Conexant Systems, Inc. Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc. and its subsidiaries (collectively
# "Conexant"). It may only be read, used, copied, adapted, modified or
# otherwise dealt with by you if you have entered into a license agreement
# with Conexant and then subject to the terms of that agreement and any other
# applicable confidentiality agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a license agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

/* Linux Voice Driver common  definition */

#ifndef __LVOICE_COMMON_H__
#define __LVOICE_COMMON_H__
#ifndef true
#define true 1 
#endif
#ifndef false
#define false 0 
#endif
typedef struct sPOTS_InitPots
{
     U32            region;  /* region for tones and rings */
     U32            hPots;/*  handle to the POTS obj. used for other calls */
}tPOTS_InitPots;

typedef struct  sPOTS_StartRingAnPhone
{
     U32           hPhone;
     ePOTS_Rings   ringId;
     U32           numRings;
}tPOTS_StartRingAnPhone;

typedef struct sPOTS_StartSignalAnPhone
{
    U32           hPhone;
    ePOTS_Signals signalId;
    U32           direction;
    ePOTS_Signals customId;
}tPOTS_StartSignalAnPhone;

typedef struct sPOTS_StopSignalAnPhone
{
     U32          hPhone;
     U32          direction;
}tPOTS_StopSignalAnPhone;

typedef struct sPOTS_CallerIdAnPhone
{
     U32          hPhone;
     U8           name[20];
     U8           number[20];
     U8           dateTime[50];
}tPOTS_CallerIdAnPhone;

typedef struct sPOTS_AddUpstreamAudio
{
     U32          hPhone;
     U32          hUpperHandle; /* Upper Layer Handle for the upstream channel */
     U32          *pAudioHandler;
     U32          *subChannel;
}tPOTS_AddUpstreamAudio;

typedef struct sPOTS_AddAudioPhone
{
     U32          hPhone;
     U32          *pAudioHandler;
     U32          *subChannel;
}tPOTS_AddAudioPhone;

typedef struct sPOTS_ModifyPhone
{
     U32          hPhone;
     char   modifications[100];  
}tPOTS_ModifyPhone;

typedef struct sPOTS_SetFaxCoderName
{
    U32           hPhone;
    char    coderName[50];
}tPOTS_SetFaxCoderName;

typedef struct sPOTS_SetFaxOption
{
     U32   hPhone;
     int  faxOptions;
}tPOTS_SetFaxOption;

typedef struct sPOTS_InitAnPhone
{
    U32           hPots;
    U32           logicalId;
   /* User supplied id, it will be return in event corresponding this port */ 
    U32           hUserEventId; 
 
    U32           hPhone;

}tPOTS_InitAnPhone;
#define LVOICE_PREFIX_SIZE 20
/* DialPlan Database actions */
typedef enum
{
    kPOTS_DCM_DIAL_NONE,
    kPOTS_DCM_DIAL_NO_PREFIX,
    kPOTS_DCM_DIAL_W_PREFIX,
    kPOTS_DCM_DIAL_AT_TIMEOUT,
} eDialPlanAction;
typedef struct sPOTS_AddDelDCM
{
    U32           hPots;
    int           numDigits;
    eDialPlanAction        dialAction;
    int           add;
    char          prefix[LVOICE_PREFIX_SIZE];
}tPOTS_AddDelDCM;
typedef struct sPOTS_GetPstnStatus
{
    U32          hPhone;
    BOOL         status;
}tPOTS_GetPstnStatus;
typedef enum
{
  kFXS0_PORT, kFSX1_PORT, kFXO_PORT,
  kPORT_ALL           /* For all ports, used in config command */
}eLVOICE_PortId;

/* Audio codec */

#define SHR_USE_G729    (1)

#define SHR_G711U       (0)
#define SHR_G711A       (1)
#define SHR_G726        (2)
#define SHR_DTMF        (3)
#define SHR_G723         (4)
#if SHR_USE_G729
#define SHR_G729        (5)
#define SHR_CLEARMODE   (6)
#define SHR_NUM_CODERS  (7)
#define SHR_G729AB      (SHR_G729)  /* alias for SHR_G729 */
#else
#define SHR_NUM_CODERS  (5)
#endif
#ifdef VOICE_T38_FAX_SUPPORT
#define SHR_T38         (23)
#endif


/*
 * There are 6 coders. SID has its packet type but not coder. SID is handled by
the
 * vocoder (G711,g726,g729ab) that immediately precedes it.
 * CIDSEND is a coder but not enumerated with the other ones because it's
 * treated differently in DSP.
 */
#define SHR_CIDSEND     (0x14)
#define SHR_CIDSEND_PREAMBLE (0x15)
#define SHR_CIDSEND_TRAILER  (0x16)
#define SHR_G729_SID    (0x1e)         /* used by host only for jitter buf */
#define SHR_SID         (0x80)
#define SHR_IDLE        (0xff)



#endif
