/* ###########################################################################
# (c) Copyright Conexant Systems, Inc. 2005
# (c) Copyright GlobespanVirata, Inc., 1997-2005
#
# Conexant Systems, Inc. Confidential and Proprietary
#
# The following software source code ("Software") is strictly confidential and
# is proprietary to Conexant Systems, Inc. and its subsidiaries (collectively
# "Conexant"). It may only be read, used, copied, adapted, modified or
# otherwise dealt with by you if you have entered into a license agreement
# with Conexant and then subject to the terms of that agreement and any other
# applicable confidentiality agreement between you and Conexant.
#
# If you are in any doubt as to whether you are entitled to access, read,
# use, copy, adapt, modify or otherwise deal with the Software or whether you
# are entitled to disclose the Software to any other person you should
# contact Conexant.  If you have not entered into a license agreement
# with Conexant granting access to this Software you should forthwith return
# all media, copies and printed listings containing the Software to Conexant.
#
# Conexant reserves the right to take legal action against you should you
# breach the above provisions.
#
# If you are unsure, or to report violations, please contact
# licensee.support@conexant.com
# ##########################################################################*/

/* Linux Voice Driver IOCTL command definition */

#ifndef __LVOICE_IOCTL_H__
#define __LVOICE_IOCTL_H__
#define LVOICE_CODE 'c'
/* Configuration command */
#define POTS_InitPots_Cmd                _IOW(LVOICE_CODE, 0x80, tPOTS_InitPots *)
#define POTS_StartSignalAnPhone_Cmd      _IOW(LVOICE_CODE, 0x81, tPOTS_StartSignalAnPhone *)
#define POTS_StartRingAnPhone_Cmd        _IOW(LVOICE_CODE, 0x82, tPOTS_StartRingAnPhone *)
#define POTS_StopSignalAnPhone_Cmd       _IOW(LVOICE_CODE, 0x83, tPOTS_StopSignalAnPhone *)
#define POTS_CallerIdAnPhone_Cmd         _IOW(LVOICE_CODE, 0x84, tPOTS_StopSignalAnPhone *)
#define POTS_ConnectPhone_Cmd            _IOW(LVOICE_CODE, 0x85, U32* )
#define POTS_AddUpstreamAudio_Cmd        _IOW(LVOICE_CODE, 0x86, tPOTS_AddUpstreamAudio * )
#define POTS_AddAudioPhone_Cmd           _IOW(LVOICE_CODE, 0x87, tPOTS_AddAudioPhone * )
#define POTS_DisconnectPhone_Cmd         _IOW(LVOICE_CODE, 0x88, U32* )
#define POTS_ModifyPhone_Cmd             _IOW(LVOICE_CODE, 0x89, tPOTS_ModifyPhone* )
#define POTS_SetFaxCoderName_Cmd         _IOW(LVOICE_CODE, 0x8A, tPOTS_SetFaxCoderName*)
#define POTS_EnableAudioMixing_Cmd       _IOW(LVOICE_CODE, 0x8B, U32* )
#define POTS_InitAnPhone_Cmd             _IOW(LVOICE_CODE, 0x8C, tPOTS_InitAnPhone* )
#define POTS_RemoveUpstreamAudio_Cmd     _IOW(LVOICE_CODE, 0x8D, U32*)
#define POTS_FailSafePots_Cmd            _IOW(LVOICE_CODE, 0x8E, U32* )
#define POTS_AddDelDCM_Cmd               _IOW(LVOICE_CODE, 0x8F, tPOTS_AddDelDCM *)
#define POTS_GetPstnStatus_Cmd           _IOR(LVOICE_CODE, 0x90, tPOTS_GetPstnStatus *)
#define POTS_FunctionReturn_Cmd          _IOR(LVOICE_CODE, 0x91, U32* )
#define POTS_Event_Cmd                   _IOR(LVOICE_CODE, 0x92, void*)
#define POTS_Audio_Cmd                   _IOR(LVOICE_CODE, 0x93, void*) 
#define POTS_RemoveAudioPhone_Cmd        _IOR(LVOICE_CODE, 0x94, U32*)
#define POTS_StopRingAnPhone_Cmd         _IOW(LVOICE_CODE, 0x95, U32* )
#define POTS_SetFaxOption_Cmd            _IOW(LVOICE_CODE, 0x96, tPOTS_SetFaxOption *)
#if 0
#define POTS_InitPots_Cmd                 0x80
#define POTS_StartSignalAnPhone_Cmd       0x81
#define POTS_StartRingAnPhone_Cmd         0x82
#define POTS_StopSignalAnPhone_Cmd        0x83
#define POTS_CallerIdAnPhone_Cmd          0x84
#define POTS_ConnectPhone_Cmd             0x85
#define POTS_AddUpstreamAudio_Cmd         0x86
#define POTS_AddAudioPhone_Cmd            0x87
#define POTS_DisconnectPhone_Cmd          0x88
#define POTS_ModifyPhone_Cmd              0x89
#define POTS_SetFaxCoderName_Cmd          0x8a
#define POTS_EnableAudioMixing_Cmd        0x8b
#define POTS_InitAnPhone_Cmd              0x8c
#define POTS_RemoveUpstreamAudio_Cmd      0x8d
#define POTS_FailSafePots_Cmd             0x8e
#define POTS_AddDelDCM_Cmd                0x8f
#define POTS_GetPstnStatus_Cmd            0x90
#define POTS_FunctionReturn_Cmd           0x91
#define POTS_Event_Cmd                    0x92
#define POTS_Audio_Cmd                    0x93
#define POTS_RemoveAudioPhone_Cmd         0x94
#endif
#endif
