// V2118 1/13/2003

var HelpOptionsVar = "width=480,height=420,scrollbars,toolbar,resizable,dependent=yes";
var GlossOptionsVar = "width=420,height=180,scrollbars,toolbar,resizable,dependent=yes";
var bigsub   = "width=560,height=440,scrollbars,menubar,resizable,status,dependent=yes";
var hugesub   = "width=620,height=500,scrollbars,menubar,resizable,status,dependent=yes";
var smallsub = "width=440,height=320,scrollbars,resizable,status,dependent=yes";
var memsub   = "width=630,height=320,scrollbars,menubar,resizable,status,dependent=yes";
var helpWinVar = null;
var glossWinVar = null;
var datSubWinVar = null;
var ValidStr = 'abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
var hex_str = "ABCDEFabcdef0123456789";


function setHTML(windowObj, el, htmlStr)
{
    if (document.all)
	{
	  if (windowObj.document.all(el) )
        windowObj.document.all(el).innerHTML = htmlStr;
	}
	else if (document.getElementById)
	{
	  if (windowObj.document.getElementById(el) )
	    windowObj.document.getElementById(el).innerHTML = htmlStr;
	}
}

function showMsg()
{
	var msgVar=document.forms[0].message.value;
	if (msgVar.length > 1)
		alert(msgVar);
}

function errMsg(msg)  // return true if msg.length > 1
{
	if (msg.length > 1)
	{
		alert(msg);
		return true;
	}
	else return false;
}

function closeWin(win_var)
{
	if   ((win_var != null) && (win_var.closed == false))
			win_var.close();
}

function openHelpWin(file_name)
{
   helpWinVar = window.open(file_name,'help_win',HelpOptionsVar);
   if (helpWinVar.focus)
		setTimeout('helpWinVar.focus()',200);
}

function openGlossWin()
{
	glossWinVar = window.open('','gloss_win',GlossOptionsVar);
	if (glossWinVar.focus)
		setTimeout('glossWinVar.focus()',200);
}

function openDataSubWin(filename,win_type)
{
	closeWin(datSubWinVar);
	datSubWinVar = window.open(filename,'datasub_win',win_type);
	if (datSubWinVar.focus)
		setTimeout('datSubWinVar.focus()',200);
}

function closeSubWins()
{
	closeWin(helpWinVar);
	closeWin(glossWinVar);
	closeWin(datSubWinVar);
}

function addstr(input_msg)
{
	var last_msg = "";
	var str_location;
	var temp_str_1 = "";
	var temp_str_2 = "";
	var str_num = 0;
	temp_str_1 = addstr.arguments[0];
	while(1)
	{
		str_location = temp_str_1.indexOf("%s");
		if(str_location >= 0)
		{
			str_num++;
			temp_str_2 = temp_str_1.substring(0,str_location);
			last_msg += temp_str_2 + addstr.arguments[str_num];
			temp_str_1 = temp_str_1.substring(str_location+2,temp_str_1.length);
			continue;
		}
		if(str_location < 0)
		{
			last_msg += temp_str_1;
			break;
		}
	}
	return last_msg;
}

function checkBlank(fieldObj, fname)
{
	var msg = "";
	if (fieldObj.value.length < 1)
		msg = addstr(msg_blank,fname);
	return msg;
}

function checkNoBlanks(fObj, fname)
{
	var space = " ";
 	if (fObj.value.indexOf(space) >= 0 )
			return addstr(msg_space,fname);
	else return "";
}

//checkName(cf.ssid, "SSID", "123abc_")
function checkName(field, fname, Valid_Str)
{
	var error_msg = "";
	var len = field.value.length;
	var str = field.value;
	
	error_msg += checkBlank(field, fname);
	if(error_msg.length > 1)return error_msg;
	
	for(var i = 0; i < len; i++)
	{
			if(Valid_Str.indexOf(str.charAt(i)) == -1)
			{
				error_msg += addstr(msg_valid_name, fname);
				break;
			}
	}

	return error_msg;
}


function checkValid(text_input_field, field_name, Valid_Str, max_size, mustFill)
{
	var error_msg= "";
	var size = text_input_field.value.length;
	var str = text_input_field.value;

	if ((mustFill) && (size != max_size) )
		error_msg = addstr(msg_blank_in,field_name);
 	for (var i=0; i < size; i++)
  	{
    	if (!(Valid_Str.indexOf(str.charAt(i)) >= 0))
    	{
			error_msg = addstr(msg_invalid,field_name,Valid_Str);
			break;
    	}
  	}
  	return error_msg;
}

function checkInt(text_input_field, field_name, min_value, max_value, required)
// NOTE: Doesn't allow negative numbers, required is true/false
{
	var str = text_input_field.value;
	var error_msg= "";

	if (text_input_field.value.length==0) // blank
	{
		if (required)
			error_msg = addstr(msg_blank,field_name);
	}
	else // not blank, check contents
	{
		for (var i=0; i < str.length; i++)
		{
			if ((str.charAt(i) < '0') || (str.charAt(i) > '9'))
				error_msg = addstr(msg_check_invalid,field_name);
		}
		if (error_msg.length < 2) // don't parse if invalid
		{
			var int_value = parseInt(str,10);
			if (int_value < min_value)
				error_msg = addstr(msg_greater,field_name,(min_value - 1));
			if (int_value > max_value)
				error_msg = addstr(msg_less,field_name,(max_value + 1));
		}
	}
	return(error_msg);
}

function blankIP(fn) // true if 0 or blank
{
	return ( (fn.value == "") || (fn.value == "0") )
}

function checkIp(ip1,ip2,ip3,ip4,msg,rq_flag)
{
	if( (rq_flag == false) && blankIP(ip1) && blankIP(ip2) && blankIP(ip3) && blankIP(ip4) )
		return "";
	var errmsg =  checkInt(ip1,msg,1,223,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,1,254,true);
	errmsg =  (errmsg.length > 1) ? addstr(msg_validIP,msg) : "";
	return errmsg;
}

function checkIpLoose(ip1,ip2,ip3,ip4,msg)
{
	var errmsg =  checkInt(ip1,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : "";
	return (errmsg.length > 1)? msg:"";
}

function prefixIs1(num) // just for check mask
{
	if(num == 0)return 1;
	var i = 0, j = 0;
	for(; i < 8; i ++)
	{
		if((num & 0x0080) == 0)
		{
			j = 1;			
		}
		else{
				if(j == 1)return 0;			
		}
		num = num << 1;		
	}
	
	return 1;
}


function checkNetMask(ip1,ip2,ip3,ip4,msg)
{
	var errmsg =  checkInt(ip1,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip2,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip3,msg,0,255,true);
	errmsg =  (errmsg.length > 1) ? errmsg : checkInt(ip4,msg,0,255,true);
  if(errmsg.length > 0)return errmsg;
  
	var num1 = parseInt(ip1.value, 10);
	var num2 = parseInt(ip2.value, 10);
	var num3 = parseInt(ip3.value, 10);
	var num4 = parseInt(ip4.value, 10);
	if(num1 != 255)
		if(num2 + num3 + num4 != 0 || prefixIs1(num1) == 0)
			return msg_netmask + " is invalid.\n";				
		
	if(num2 != 255 && ((num3 + num4 != 0) || prefixIs1(num2) == 0))
			return msg_netmask + " is invalid.\n";			
 		
	if(num3 != 255 && ((num4 != 0) || prefixIs1(num3) == 0))
			return msg_netmask + " is invalid.\n";			
	
	if(prefixIs1(num4) == 0)return msg_netmask + " is invalid.\n";
	return "";
}

function checkMAC(fieldObj,fmsg)
{
	var address = fieldObj.value;
	var myRE = /[0-9a-fA-F]{12}/;
	var newMAC = "";
	var mac = "";

	if(address.length > 11)
	{
	   newMAC = address.replace(/[:-]/g,"");
	   //fieldObj.value = newMAC;	
	}
		mac = newMAC.charAt(1) ;

	if ((newMAC.length != 12) || (newMAC=="000000000000") ||(mac=="1")||(mac=="3")||(mac=="5")||(mac=="7")||(mac=="9")||(mac=="b")||(mac=="d")||(mac=="f")||(myRE.test(newMAC)!=true))	
		return addstr(msg_invalidMAC,fmsg);	
	else
		return "";
} 

function cp_ip(from1,from2,from3,from4,to1,to2,to3,to4)
//true invalid from and to ip;  false valid from and to ip;
{
    var total1 = 0;
    var total2 = 0;
    
    total1 += parseInt(from4.value,10);
    total1 += parseInt(from3.value,10)*256;
    total1 += parseInt(from2.value,10)*256*256;
    total1 += parseInt(from1.value,10)*256*256*256;
    
    total2 += parseInt(to4.value,10);
    total2 += parseInt(to3.value,10)*256;
    total2 += parseInt(to2.value,10)*256*256;
    total2 += parseInt(to1.value,10)*256*256*256;
    if(total1 > total2)
        return true;
    return false;
}

function isHex(str) {
    var i;
    for(i = 0; i<str.length; i++) {
        var c = str.substring(i, i+1);
        if(("0" <= c && c <= "9") || ("a" <= c && c <= "f") || ("A" <= c && c <= "F")) {
            continue;
        }
        return false;
    }
    return true;
}

function isBigger(str_a, str_b)
//  true if a bigger than b
{
	var int_value_a = parseInt(str_a);
	var int_value_b = parseInt(str_b);
	return (int_value_a > int_value_b);
}


function isNumber(object,field_name)
{
    var str = object.value;
    var error_msg="";
    for (var i=0; i < str.length; i++)
	{
	    if ((str.charAt(i) < '0') || (str.charAt(i) > '9'))
			error_msg = addstr(msg_check_invalid,field_name);
	}
	if(error_msg.length > 2){
	    return error_msg;
	}
	return error_msg;
}
function isIntStr(str) {
    var i;
    for(i = 0; i<str.length; i++) {
        var c = str.substring(i, i+1);
        if("0" <= c && c <= "9") {
            continue;
        }
        return false;
    }
    return true;
}

function checkIntStr(str,minval,maxval)
{
	if(!(isIntStr(str)))
		return false;	
	var ival = parseInt(str);
	if(ival < minval || ival > maxval)
		return false;
	else return true;
}	

function isIpStr(addrStr) 
{
    var i;
    var a = addrStr.split(".");
    if(a.length != 4) 
        return false;
    if(!checkIntStr(a[0],1,254))
		return false;
    if(!checkIntStr(a[1],0,255))
		return false;
    if(!checkIntStr(a[2],0,255))
		return false;
    if(!checkIntStr(a[3],1,254))
		return false;
    return true;
}


var showit = "block";
var hideit = "none";

function show_hide(el,shownow)  // IE & NS6; shownow = true, false
{
//	alert("el = " + el);
	if (document.all)
		document.all(el).style.display = (shownow) ? showit : hideit ;
	else if (document.getElementById)
		document.getElementById(el).style.display = (shownow) ? showit : hideit ;
}

function returnAC(avar)
{
	var str = "";
	for (var i =0; i < avar.length; i++)
		str +=  avar[i] + "," ;
	return str;
}

function chkSelected(selObj, err_msg)
{
    if(!(selObj.selectedIndex >= 0 ))
	{
	    alert(err_msg);
	    return false;
	}
	return true;
}

function getSelIndex(sel_object, sel_text) // Index matching string sel_text
{
	if (sel_text.length == 0)
		return 0;  
	var size = sel_object.options.length;
	for (var i = 0; i < size; i++)
	{
		if ( (sel_object.options[i].value == sel_text) || (sel_object.options[i].text == sel_text) )
			return(i);
	}
	return 0;  // if no match
}
	
function swapSel(selObj,updown_str)
{
	var cf = document.forms[0];
	var imin = (updown_str == "up") ? 1 : 0;
	var imax = (updown_str == "up") ? selObj.options.length -1 :selObj.options.length -2;
	var index = selObj.selectedIndex;
	var swap_index;

	if ((index >= imin ) && (index <= imax))
	{
		swap_index = (updown_str == "up") ? index -1 : index + 1 ;
		var temp_text = selObj.options[index].text;
		var temp_v = selObj.options[index].value;
		selObj.options[index].text = selObj.options[swap_index].text ;
		selObj.options[index].value = selObj.options[swap_index].value ;
		selObj.options[swap_index].text = temp_text ;
		selObj.options[swap_index].value = temp_v ;
		selObj.selectedIndex = swap_index;
		return true;
	}
	else return false;
}  // no msg if can't move


function dupSelEntry(sel_object,newvalue,caseSensitive)
// check if renaming current value to existing value
// caseSensitive: true = exact match, false = ignore case
{
	var counter = 0;
	var match;
	var size = sel_object.options.length;
	var index = sel_object.selectedIndex;

	for (var i = 0; i < size; i++)
	{
		if (caseSensitive)
		  match = (sel_object.options[i].text == newvalue) ;
		else
		  match =  (sel_object.options[i].text.toLowerCase() == newvalue.toLowerCase() );
		if ((match) && (i != index))
			return true;
	}
	return false;
}


function setDisabled(OnOffFlag,formFields)
{
	for (var i = 1; i < setDisabled.arguments.length; i++)
		setDisabled.arguments[i].disabled = OnOffFlag;
}


