# Use helper perl script to set enviroment variables. Initially set to default but
# can be changed later.
setenv GSV_PERL_SCRIPT "/usr/local/virata/config.pl"

# Make sure the following variables are available to config.pl, ie. environment
# variables not just shell variables.
if ( $?VIRATA_TOOLS ) then
    setenv VIRATA_TOOLS "$VIRATA_TOOLS"
endif
if ( $?VIRATA_TOOLS_DIR ) then
    setenv VIRATA_TOOLS_DIR "$VIRATA_TOOLS_DIR"
endif

# See if user wants to override default tools location:
if ( $?VIRATA_TOOLS_DIR ) then
    setenv GSV_PERL_SCRIPT "$VIRATA_TOOLS_DIR/config.pl"
endif

# Use common script to set environment.
if ( $?VIRATA_TOOLS ) then
    if ( { $GSV_PERL_SCRIPT CHECK } ) then
	setenv ATMOSTOOLS `$GSV_PERL_SCRIPT ATMOSTOOLS`
	setenv ATMOSHOST `$GSV_PERL_SCRIPT ATMOSHOST`
        setenv PATH `$GSV_PERL_SCRIPT PATH`
        setenv MANPATH `$GSV_PERL_SCRIPT MANPATH`

	# If non-standard location we also need to tell GCC about it.
	if ( $?VIRATA_TOOLS_DIR ) then
            setenv GCC_EXEC_PREFIX `$GSV_PERL_SCRIPT GCC_EXEC_PREFIX`
	else
	    unsetenv GCC_EXEC_PREFIX
	endif
    endif
endif

# Tidy up
unsetenv GSV_PERL_SCRIPT
