# Use helper perl script to set enviroment variables. Initially set to default but
# can be changed later.
GSV_PERL_SCRIPT="/usr/local/virata/config.pl"

# Make sure the following variables are available to config.pl, ie. environment
# variables not just shell variables.
export VIRATA_TOOLS
export VIRATA_TOOLS_DIR
export PATH
export MANPATH

# See if user wants to override default tools location:
if [ "$VIRATA_TOOLS_DIR" != "" ]; then
    GSV_PERL_SCRIPT="$VIRATA_TOOLS_DIR/config.pl"
fi

# Use common script to set environment.
if [ "$VIRATA_TOOLS" != "" ]; then
    if $GSV_PERL_SCRIPT CHECK; then
        ATMOSTOOLS=`$GSV_PERL_SCRIPT ATMOSTOOLS`
        ATMOSHOST=`$GSV_PERL_SCRIPT ATMOSHOST`
        PATH=`$GSV_PERL_SCRIPT PATH`
        MANPATH=`$GSV_PERL_SCRIPT MANPATH`
	export ATMOSTOOLS ATMOSHOST PATH MANPATH

        # If non-standard location we also need to tell GCC about it.
	if [ "$VIRATA_TOOLS_DIR" != "" ]; then
            GCC_EXEC_PREFIX=`$GSV_PERL_SCRIPT GCC_EXEC_PREFIX`
	    export GCC_EXEC_PREFIX
        else
            unset GCC_EXEC_PREFIX
	fi
    fi
fi

# Tidy up
unset GSV_PERL_SCRIPT
