=head1 TITLE

utils - Handy utility functions for syslink/catobj scriplets

=cut

use 5.004;
package atmos_utils;
use Exporter;
@ISA = qw(Exporter);
use File::Basename;

@EXPORT_OK = qw( system tmpfile );
use strict;

=head2 system

Fork a subshell and exit if it fails

=cut

sub system($)
{
    my $cmd = shift;
    print $cmd, "\n";
    system( $cmd ) && exit 1;
}

=head2 tmpfile

Return the name of a temporary file.
The file is automatically deleted on program termination

=cut

my $id = 0;
my @tmpfiles;

sub tmpfile()
{
    my $progname = basename $0;
    my $tmpdir = '/tmp';
    $tmpdir = $ENV{TEMP} if defined $ENV{TEMP};

    my $file = $tmpdir . "/$progname-$$.$id";
    push @tmpfiles, $file;
    return $file;
}

sub END
{
    unlink @tmpfiles;
}

1;



